// register module
angular.module('security.register', [])

    .controller('RegisterCtrl', ['$scope', 'Validate', 'Register', 'MESSAGE', '$ionicPopup', '$ionicLoading','$rootScope', 'AUTH_EVENTS', '$ionicModal', 'security', function ($scope, Validate, Register, MESSAGE, $ionicPopup, $ionicLoading, $rootScope, AUTH_EVENTS, $ionicModal, security) {
         $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };
        $scope.sendData = {
            isChecked:true
        };

        $scope.setData = {
            isSendCode:true,
            isIdentify:false,
            isSetPassword:false
        }
        $scope.MESSAGE = MESSAGE;

        $scope.resendCodeData = {
            isDisabled:false,
            countdown: 60,
            btnMsg: "重新获取验证码"
        }

        $scope.sendCode = function (isValid) {

            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Validate.send($scope.sendData).then(function(res) {
                $ionicLoading.hide();
                $scope.setData.isSendCode = false;
                $scope.setData.isIdentify = true;
                setTime();
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '发送失败',
                template: ''+err.errorMessage
              });
              $ionicLoading.hide();
            });
        };

        $scope.identifyCode = function (isValid) {

            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Validate.identify($scope.sendData).then(function(res) {
                $ionicLoading.hide();
                $scope.setData.isIdentify = false;
                $scope.setData.isSetPassword = true;
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: ''+err.errorMessage
              });
              $ionicLoading.hide();
            });
        };



        $scope.register = function (isValid) {
            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Validate.register($scope.sendData).then(function(res) {
                $ionicLoading.hide();
                $rootScope.$broadcast(AUTH_EVENTS.registerSuccess);
                var data = {
                    'mobile':res.data.mobile,
                    'password':$scope.sendData.password
                }
                login(data);
                try{
                    window.plugins.jPushPlugin.setAlias(res.data.id);
                }
                catch(exception){
                    console.log(exception);
                }
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '注册失败',
                template: ''+err.errorMessage
              });
              $ionicLoading.hide();
            });

        };
        var login = function(res){
            security.login(res).then(function(authenticated) {
                $ionicLoading.hide();
                $rootScope.$broadcast(AUTH_EVENTS.loginSuccess);
                try{
                    window.plugins.jPushPlugin.setAlias(authenticated.data.id);
                }
                catch(exception){
                    console.log(exception);
                }
            }, function(err) {
                $ionicLoading.hide();
                var alertPopup = $ionicPopup.alert({
                    title: '登录失败',
                    template: ''+err.errorMessage
                });
            });
        }


        $scope.resendCode = function () {

            setTime();
            Validate.send($scope.sendData).then(function(res) {
                $ionicLoading.hide();
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '发送失败',
                template: ''+err.errorMessage
              });
              $ionicLoading.hide();
            });
        };

        $scope.countdownNum = 1;

        function setTime() {
            $scope.$broadcast('timer-add-cd-seconds', 60, true);
            $scope.resendCodeData.isDisabled = true;
        };

        $scope.finished =function(){
            $scope.resendCodeData.isDisabled = false;
            $scope.$apply();
        }

        $scope.goAgreement = function () {
            $ionicModal.fromTemplateUrl('templates/agreement.html', {
                scope: $scope,
                backdropClickToClose: false,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.agreementModal = modal;
                $scope.agreementModal.show();
            });
        };

        $scope.closeModal = function () {
            $scope.agreementModal.hide();
        };
    }])
    .controller('forgotPasswordCtrl', ['$scope', 'Validate', 'Register', 'MESSAGE', '$ionicPopup', '$ionicLoading','$rootScope', 'AUTH_EVENTS','$ionicViewSwitcher', '$ionicHistory','Account', 'URLConfig', function ($scope, Validate, Register, MESSAGE, $ionicPopup, $ionicLoading, $rootScope, AUTH_EVENTS, $ionicViewSwitcher, $ionicHistory, Account, URLConfig) {
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };
        $scope.sendData = {
            'isChecked': true
        };
        var date = new Date().getTime();
        $scope.verify = URLConfig.API_BASEURL +'index.php/home/member/verify?time='+date;
        $scope.setData = {
            isCheckAccount:true,
            isIdentify:false,
            isSetPassword:false
        };
        $scope.MESSAGE = MESSAGE;
        $scope.resendCodeData = {
            isDisabled:false,
            countdown: 60,
            btnMsg: "发送验证码"
        };

        $scope.checkCode = function (isValid) {
            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Validate.checkVerify($scope.sendData).then(function(res) {
                $ionicLoading.hide();
                $scope.setData.isCheckAccount = false;
                $scope.setData.isIdentify = true;
            }, function(err) {
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: ''+ err.errorMessage
                });
                $ionicLoading.hide();
            });
        };
        $scope.changeVerify = function () {
           var date = new Date().getTime();
            $scope.verify = URLConfig.API_BASEURL +'index.php/home/member/verify?time='+date;
        };
        $scope.changeVerify();
        $scope.identifyCode = function (isValid) {

            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Validate.identify($scope.sendData).then(function(res) {
                $ionicLoading.hide();
                $scope.setData.isIdentify = false;
                $scope.setData.isSetPassword = true;
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: ''+err.errorMessage
              });
              $ionicLoading.hide();
            });
        };
        $scope.register = function (isValid) {

            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Validate.setPassword($scope.sendData).then(function(res) {
                $ionicLoading.hide();
                $rootScope.$broadcast(AUTH_EVENTS.setPasswordSuccess);
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '设置失败',
                template: ''+err.data.errorMessage
              });
              $ionicLoading.hide();
            });

        };
        $scope.sendCode = function () {
            setTime();
            Validate.send($scope.sendData).then(function(res) {
                $ionicLoading.hide();
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '发送失败',
                template: ''+err.errorMessage
              });
              $ionicLoading.hide();
            });
        };
         $scope.setPasswordData ={
            'password': '',
            'user_id': $scope.user.id,
            'old_password':''
        }
        $scope.setPassword = function(isValid) {
            if (!isValid) {
              return;
            }
            if($scope.setPasswordData.password!=$scope.setPasswordData.again) {
                var alertPopup = $ionicPopup.alert({
                    title: '操作失败',
                    template: '两次密码不一样'
                });
                return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Account.setPassword($scope.setPasswordData).then(function(res) {
                $ionicLoading.hide();
                $ionicViewSwitcher.nextDirection('back');
                $ionicHistory.goBack();
            }, function(err) {
                var alertPopup = $ionicPopup.alert({
                    title: '操作失败',
                    template: ''+err.data.errorMessage
                });
                $ionicLoading.hide();
            });
        }
        $scope.countdownNum = 1;

        function setTime() {
            $scope.$broadcast('timer-add-cd-seconds', 60, true);
            $scope.resendCodeData.isDisabled = true;
        };

        $scope.finished =function(){
            $scope.resendCodeData.isDisabled = false;
            $scope.$apply();
        }
    }])
    .controller('ChangePhoneCtrl', ['$scope', 'Validate', 'Register', 'MESSAGE', '$ionicPopup', '$ionicLoading','$rootScope', 'AUTH_EVENTS', '$stateParams', '$ionicHistory', '$ionicViewSwitcher', 'Account', function ($scope, Validate, Register, MESSAGE, $ionicPopup, $ionicLoading, $rootScope, AUTH_EVENTS, $stateParams, $ionicHistory,$ionicViewSwitcher, Account) {
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };
        var type = $stateParams.type;
        if(type === "1"){
            $scope.showBack= true;
        }else {
            $scope.showBack= false;
        }
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
        if($scope.user.mobile){
            $scope.hasMobile = true;
        }else{
            $scope.hasMobile = false;
        }
        $scope.sendData = {
            isChecked:true,
            mobile: $scope.user.mobile
        };

        $scope.setMobileData = {
            'mobile' : '',
            'user_id': $scope.user.id
        }

        $scope.setData = {
            isCheckAccount:true,
            isIdentify:false
        };
        $scope.MESSAGE = MESSAGE;

        $scope.resendCodeData = {
            isDisabled:false,
            countdown: 60,
            btnMsg: "发送验证码"
        };

        $scope.resendNewCodeData = {
            isDisabled:false,
            countdown: 60,
            btnMsg: "发送验证码"
        };
        $scope.checkCode = function (isValid,index) {

            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            if(index==1){
                $scope.sendData.mobile = $scope.setMobileData.mobile;
            }
            Validate.identify($scope.sendData).then(function(res) {
                if(index==0){
                    $scope.setData.isCheckAccount = false;
                    $scope.setData.isIdentify = true;
                    $scope.sendData.code = '';

                }else {
                    $scope.setMobile(isValid);
                }
                $ionicLoading.hide();

            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: ''+err.errorMessage
              });
              $ionicLoading.hide();
            });
        };
        $scope.setMobile = function (isValid) {
            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Account.setMobile($scope.setMobileData).then(function(res) {
                $ionicLoading.hide();
                $scope.user.mobile = $scope.setMobileData.mobile;
                window.localStorage.setItem('USERS', JSON.stringify($scope.user));
                $ionicViewSwitcher.nextDirection('back');
                $ionicHistory.goBack();
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '操作失败',
                template: ''+err.errorMessage
              });
              $ionicLoading.hide();
            });
        };
        $scope.sendCode = function (index) {
            setTime(index);
            if(index==1){
                $scope.sendData.mobile = $scope.setMobileData.mobile;
            }
            Validate.send($scope.sendData).then(function(res) {
                $ionicLoading.hide();
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '发送失败',
                template: ''+err.errorMessage
              });
              $ionicLoading.hide();
            });
        };
        $scope.countdownNum = 1;
        $scope.countdownNum1 = 1;
        function setTime(index) {
            if(index==0){
                $scope.$broadcast('timer-add-cd-seconds', 60, true);
                $scope.resendCodeData.isDisabled = true;
            }else{
                $scope.resendNewCodeData.isDisabled = true;
                $scope.$broadcast('timer-add-cd-seconds', 60, true);
            }
        };

        $scope.finished =function(index){
            if(index==0){
                $scope.resendCodeData.isDisabled = false;
                $scope.$apply();
            }else {
                $scope.resendNewCodeData.isDisabled = false;
                $scope.$apply();
            }
        }
    }])
    .controller('QuickLoginCtrl', ['$scope', 'Validate', 'Register', 'MESSAGE', '$ionicPopup', '$ionicLoading','$rootScope', 'AUTH_EVENTS', '$stateParams', '$ionicHistory', '$ionicViewSwitcher', 'security', function ($scope, Validate, Register, MESSAGE, $ionicPopup, $ionicLoading, $rootScope, AUTH_EVENTS, $stateParams, $ionicHistory,$ionicViewSwitcher, security) {

        $scope.sendData = {
            isChecked:true,
            mobile: ''
        };

        $scope.resendCodeData = {
            isDisabled:false,
            countdown: 60,
            btnMsg: "发送验证码"
        };

        $scope.checkCode = function (isValid) {

            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Validate.fastRegister($scope.sendData).then(function(res) {
                security.quickLogin(res);
                $ionicLoading.hide();
                $rootScope.$broadcast(AUTH_EVENTS.registerSuccess);
                $rootScope.$broadcast(AUTH_EVENTS.loginSuccess);
                try{
                    window.plugins.jPushPlugin.setAlias(res.data.id);
                }
                catch(exception){
                    console.log(exception);
                }
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '操作失败',
                template: '' + err.errorMessage
              });
              $ionicLoading.hide();
            });

        };

        $scope.sendCode = function () {
            setTime();
            Validate.send($scope.sendData).then(function(res) {
                $ionicLoading.hide();
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '发送失败',
                template: ''+err.errorMessage
              });
              $ionicLoading.hide();
            });
        };
        $scope.countdownNum = 1;

        function setTime() {
            $scope.$broadcast('timer-add-cd-seconds', 60, true);
            $scope.resendCodeData.isDisabled = true;
        };

        $scope.finished =function(){
            $scope.resendCodeData.isDisabled = false;
            $scope.$apply();
        }
    }]);

angular.module('security.login', ['security.login.form']);

angular.module('security.login.form', [])

    // This LoginFormController provides the behaviour behind a reusable form to allow users to authenticate.
    .controller('LoginFormController', ['$scope', 'security', 'localizedMessages', '$ionicPopup', '$rootScope', 'AUTH_EVENTS', '$ionicModal', '$ionicLoading', function ($scope, security, localizedMessages, $ionicPopup, $rootScope, AUTH_EVENTS, $ionicModal, $ionicLoading) {

            // The model for this form.
            $scope.user = {};

            // Any error message from failing to login.
            $scope.authError = null;

            // Attempt to authenticate the user specified in the form's model.
            $scope.login = function (isValid) {
                // Clear any previous security errors
                if (!isValid) {
                  return;
                }
                $scope.loading = $ionicLoading.show({
                  showBackdrop: false
                });
                $scope.authError = null;

                security.login($scope.user).then(function(authenticated) {
                    if(authenticated.status==1){
                        $ionicLoading.hide();
                        $scope.setCurrentUsername($scope.user.UserName);
                        $rootScope.$broadcast(AUTH_EVENTS.loginSuccess);
                        try{
                            window.plugins.jPushPlugin.setAlias(authenticated.data.id);
                        }
                        catch(exception){
                            console.log(exception);
                        }
                    }else {
                        var alertPopup = $ionicPopup.alert({
                            title: '登录失败',
                            template: '请检查你的用户名和密码是否正确'
                        });
                    }
                    $ionicLoading.hide();
                }, function(err) {
                    $ionicLoading.hide();
                    var alertPopup = $ionicPopup.alert({
                        title: '登录失败',
                        template: ''+err.errorMessage
                    });
                });
            };

            // Clear the model of this form
            $scope.clearForm = function () {
                loginCtrl.user = {};
            };

            // Cancel login.
            $scope.cancelLogin = function () {
                security.cancelLogin();
            };

            $scope.goRegister = function () {
                $ionicModal.fromTemplateUrl('templates/register.html', {
                    scope: $scope,
                    backdropClickToClose: false,
                    animation: 'slide-in-up'
                }).then(function(modal) {
                    $scope.RegisterModal = modal;
                    $scope.RegisterModal.show();
                });
            };

            $scope.forgotYourPassword = function () {
                $ionicModal.fromTemplateUrl('templates/forgot-password.html', {
                    scope: $scope,
                    backdropClickToClose: false,
                    animation: 'slide-in-up'
                }).then(function(modal) {
                    $scope.forgotPasswordModal = modal;
                    $scope.forgotPasswordModal.show();
                });
            }

            $scope.quickLogin = function () {
                $ionicModal.fromTemplateUrl('templates/quick-login.html', {
                    scope: $scope,
                    backdropClickToClose: false,
                    animation: 'slide-in-up'
                }).then(function(modal) {
                    $scope.quickLoginModal = modal;
                    $scope.quickLoginModal.show();
                });
            }

            $scope.closeQuickLoginModal = function () {
                $scope.quickLoginModal.hide();
            };

            $scope.closeRegisterModal = function () {
                $scope.RegisterModal.hide();
            };

            $scope.closeForgotPasswordModal = function () {
                $scope.forgotPasswordModal.hide();
            };

            $scope.loginByWechat = function() {
                var scope = "snsapi_userinfo";
                Wechat.auth(scope, function (response) {
                    getWechatAccessToken(response);
                }, function (reason) {
                    alert("Failed: " + reason);
                });
            };
            $scope.loginByQQ = function() {
                var checkClientIsInstalled = 1;//default is 0,only for iOS
                YCQQ.ssoLogin(function(args){
                     getQQUserInfo(args);
                    },function(failReason){
                       console.log(failReason);
                },checkClientIsInstalled);
            };
            $scope.loginByWeiBo = function() {
                YCWeibo.ssoLogin(function(args){
                    getWeiBoUserInfo(args);
                },function(failReason){
                    console.log(failReason);
                });
            };
            Wechat.isInstalled(function (installed) {
                $scope.wechatIsInstalled = installed;
            }, function (reason) {
                alert("Failed: " + reason);
            });
            YCQQ.checkClientInstalled(function(){
                $scope.qqIsInstalled = true;
            },function(){
                $scope.qqIsInstalled = false;
            });
            YCWeibo.checkClientInstalled(function(){
                $scope.weiBoIsInstalled = true;
            },function(){
                $scope.weiBoIsInstalled = false;
            });
            var getWechatAccessToken = function(response){
                $scope.loading = $ionicLoading.show({
                  showBackdrop: false
                });
                var data = {
                    appid:'wx2289b7a46ca757ef',
                    secret:'9903ae8f28a547e7ebffbe06856da0c3',
                    code:response.code,
                    grant_type:'authorization_code'
                }
                security.getWechatAccessToken(data).then(function(res) {
                    getWechatUserInfo(res);
                    window.localStorage.setItem('WechatData', JSON.stringify(res));
                    $ionicLoading.hide();
                }, function(err) {
                    refershWechatAccessToken();
                    $ionicLoading.hide();
                });
            }

            var refershWechatAccessToken = function() {
                $scope.loading = $ionicLoading.show({
                  showBackdrop: false
                });
                var WechatData =JSON.parse(localStorage.getItem('WechatData')) || [];
                var data = {
                    appid:'wx2289b7a46ca757ef',
                    grant_type:'refresh_token',
                    refresh_token: WechatData.refresh_token
                }
                security.refershWechatAccessToken(data).then(function(res) {
                    $ionicLoading.hide();
                    window.localStorage.setItem('WechatData', JSON.stringify(res));
                }, function(err) {

                    $ionicLoading.hide();
                });
            }

            var getWechatUserInfo = function(res){
                $scope.loading = $ionicLoading.show({
                  showBackdrop: false
                });
                var data = {
                    access_token:res.access_token,
                    openid: res.openid
                }
                security.getWechatUserInfo(data).then(function(res) {
                    $ionicLoading.hide();
                    thirdLogin(res,1);
                }, function(err) {
                    $ionicLoading.hide();
                });
            }

            var getQQUserInfo = function(args){
                $scope.loading = $ionicLoading.show({
                  showBackdrop: false
                });
                var data ={
                    'oauth_consumer_key':1104698005,
                    'access_token': args.access_token,
                    'openid':args.userid,
                    'format':'json'
                }
                security.getQQUserInfo(data).then(function(res) {
                    $ionicLoading.hide();
                    res.openid = args.userid;
                    thirdLogin(res,2);
                }, function(err) {
                    $ionicLoading.hide();
                });
            }
            var getWeiBoUserInfo = function(args){
                $scope.loading = $ionicLoading.show({
                  showBackdrop: false
                });
                var data ={
                    'access_token': args.access_token,
                    'uid':args.userid
                }
                security.getWeiBoUserInfo(data).then(function(res) {
                    $ionicLoading.hide();
                    res.openid = args.userid;
                    thirdLogin(res,3);
                }, function(err) {
                    $ionicLoading.hide();
                });
            }

            var thirdLogin = function(res,type){
                $scope.loading = $ionicLoading.show({
                  showBackdrop: false
                });
                var data;
                if(type==1){
                    data = {
                        'type' :type,
                        'unionid':res.unionid,
                        'nickname':res.nickname,
                        'avatar':res.headimgurl
                    }
                }else if(type==2){
                    data = {
                        'type' :type,
                        'unionid':res.openid,
                        'nickname':res.nickname,
                        'avatar':res.figureurl_2
                    }
                }else{
                    data = {
                        'type' :type,
                        'unionid':res.id,
                        'nickname':res.screen_name,
                        'avatar':res.avatar_hd
                    }
                }

                security.thirdLogin(data).then(function(res) {
                    $ionicLoading.hide();
                    $rootScope.$broadcast(AUTH_EVENTS.loginSuccess);
                    try{
                        window.plugins.jPushPlugin.setAlias(authenticated.data.id);
                    }
                    catch(exception){
                        console.log(exception);
                    }
                }, function(err) {
                    $ionicLoading.hide();
                });
            }

            $scope.$on(AUTH_EVENTS.registerSuccess, function(event) {
                if($scope.RegisterModal){
                    $scope.RegisterModal.hide();
                }
                if($scope.quickLoginModal) {
                    $scope.quickLoginModal.hide();
                }
            });

            $scope.$on(AUTH_EVENTS.setPasswordSuccess, function(event){
                $scope.forgotPasswordModal.hide();
            })

        }
    ]);

angular.module('services.verify', [])

    .factory('Verify', ['URLConfig', '$http', function (URLConfig, $http) {

        var verify = {};
        verify.data = {};

        return {
            verifyMerchant: function (data) {
                $http({
                    method: 'POST',
                    url: URLConfig.API_BASEURL + "/membership/storeinfo/update_authinfo",
                    data: data
                })
                    .success(function (res) {
                        verify.data= res;
                        window.location = "#/addCommodity";
                        return true;
                    }).error(function (res) {
                        return false;
                    });

                    return verify.data;
            }
        };
    }]);
angular.module('services.validate', [])

    .factory('Validate', ['URLConfig', '$http', '$q', function (URLConfig, $http, $q) {

        return{
            send : function (data) {

                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.API_BASEURL + "index.php/home/member/sendcode",
                        params: data
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (error) {
                        reject(error);
                    });
                });

            },

            identify : function (data) {

                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.API_BASEURL + "index.php/home/member/identifyCode",
                        params: data
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (error) {
                        reject(error);
                    });
                });

            },

            register : function (data) {

                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.API_BASEURL + "index.php/home/member/register",
                        params: data
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (error) {
                        reject(error);
                    });
                });

            },
            fastRegister: function (data) {

                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.API_BASEURL + "index.php/home/member/fastRegister?mobile="+data.mobile,
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (error) {
                        reject(error);
                    });
                });

            },
            verify : function (data) {

                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.API_BASEURL + "index.php/home/member/verify",
                        params: data
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (error) {
                        reject(error);
                    });
                });

            },
            checkVerify : function (data) {

                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.API_BASEURL + "index.php/home/member/checkVerify?verify="+data.verify
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (error) {
                        reject(error);
                    });
                });

            },
            setPassword: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/member/setPassword?mobile="+data.mobile+"&password="+data.password+"&type=1")
                    .then(function (response) {
                        return response;
                    });
            }

        };

    }]);

angular.module('services.upload', [])

    .factory('Upload', ['URLConfig', '$http', function (URLConfig, $http) {
        return {
            add: function (data) {
               return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL+"index.php/home/file/index",
                        data: data
                    })
                    .then(function (response) {
                        return response;
                    });
            },
            remove: function (storeId) {

            },
            get: function (storeId) {

            }
        };
    }]);

angular.module('services.tuanGou', [])
  .factory('TuanGou', ['$http', 'URLConfig', function ($http, URLConfig) {

        var products = {};
        return {
            all: function () {
                return $http.get("http://115.28.220.32:8081/groupbuying/product/get_group_buying_list")
                    .then(function (response) {
                        products = response;
                        return products;
                    });
            },
            get: function (id) {
                // Simple index lookup
                return products[id];
            },
            productDetail: function (data) {
                return $http.get( URLConfig.API_BASEURL + "index.php/home/deal/content?id=" + data)
                    .then(function (response) {
                        return response;
                    });
            },
            reviewDetail:function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/dianping/index?deal_id=" + data)
                    .then(function (response) {
                        return response;
                    });
            }
        }
    }]);


angular.module('services.stores', [])

    .factory('Stores', ['$http', 'URLConfig', function ($http, URLConfig) {

        return {
            all: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/location/index?supplier_id="+ data)
                    .then(function (response) {
                        return response;
                    });
            },
            get: function (id) {
                // Simple index lookup
                return products[id];
            },
            productDetail: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/deal/content?id=" + data)
                    .then(function (response) {
                        return response;
                    });
            },
            reviewDetail:function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/dianping/index?deal_id=" + data)
                    .then(function (response) {
                        return response;
                    });
            }
        }
    }]);

angular.module('services.register', [])

    .factory('Register', ['URLConfig', '$http', function (URLConfig, $http) {

        var register = {};
        register.data = {};
        return {
            register: function (data) {
                $http({
                    method: 'GET',
                    url: URLConfig.API_BASEURL + "/membership/user/register_simple",
                    params: data
                })
                    .success(function (res) {
                        register.data= res.Code;
                        return true;
                    }).error(function (res) {
                        return false;
                    });

                return register.data;
            }
        };
    }]);

angular.module('services.post', [])
    .factory('Post', ['$http', 'URLConfig', function ($http, URLConfig) {
        var photos = [];
        return {
            addBidPost: function (data) {
                return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL + "index.php/home/biao/addPost",
                        data: data
                    }).then(function (response) {
                        return response;
                    });
            },
            add: function (data) {
                return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL + "index.php/home/bbs/upInfo",
                        data: data
                    }).then(function (response) {
                        return response;
                    });
            },
            get:function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/bbs/content?id=" + data)
                    .then(function (response) {
                        return response;
                    });
            },
            getBidPost:function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/biao/content?id=" + data)
                    .then(function (response) {
                        return response;
                    });
            },
            like: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/bbs/praise?tid=" + data.tid+"&user_id="+data.user_id+"&to_user_id="+data.to_user_id)
                    .then(function (response) {
                        return response;
                    });
            },
            getComment:function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/bbs/comments?tid=" + data)
                    .then(function (response) {
                        return response;
                    });
            },
            getBidComment:function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/biao/comments?tid=" + data)
                    .then(function (response) {
                        return response;
                    });
            },
            addComment: function (data) {
                return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL + "index.php/home/bbs/upComment",
                        data: data
                    }).then(function (response) {
                        return response;
                    });
            },
            addBidComment: function (data) {
                return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL + "index.php/home/biao/addcomment",
                        data: data
                    }).then(function (response) {
                        return response;
                    });
            },
            removePhotos: function (){
                photos = [];
                return true;
            },
            addPhotos: function (data) {
                angular.forEach(data, function(value, key) {
                    photos.push(value);
                });
                return true;
            },
            getPhotos: function () {
                return photos;
            },
            getReply: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/bbs/reply?id=" + data)
                    .then(function (response) {
                        return response;
                    });
            },
            getBidReply: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/biao/reply?id=" + data)
                    .then(function (response) {
                        return response;
                    });
            },
            addReply: function (data) {
                return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL + "index.php/home/bbs/upComment",
                        data: data
                    }).then(function (response) {
                        return response;
                    });
            },
            report: function (data) {
                return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL + "index.php/home/bbs/report",
                        data: data
                    }).then(function (response) {
                        return response;
                    });
            }
        }
    }]);

// Based https://github.com/angular-app/angular-app

angular.module('services.localizedMessages', ['configuration.I18N'])

    // This service provides one interface to get messages.
    .factory('localizedMessages', ['$interpolate', 'I18N.MESSAGES', function ($interpolate, i18nMessages) {
        var handleNotFound = function (msg, msgKey) {
            return msg || '?' + msgKey + '?';
        };

        return {
            get: function (msgKey, interpolateParams) {
                var msg = i18nMessages[msgKey];

                if (msg) {
                    return $interpolate(msg)(interpolateParams);
                }
                else {
                    return handleNotFound(msg, msgKey);
                }
            }
        };
    }]);

angular.module('services.intentOrder', [])

    .factory('IntentOrder', ['URLConfig', '$http', function (URLConfig, $http) {

        return {
            add: function (data) {
                return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL + "index.php/home/order/done",
                        data: data
                    }).then(function (response) {
                        return response;
                    });
            },
            all: function (data) {
                return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL + "index.php/home/order/lists",
                        data: data
                }).then(function (response) {
                    return response;
                });
            },
            remove: function (id) {

            },
            get: function (data) {
                return $http.get( URLConfig.API_BASEURL + "index.php/home/order/content?order_id=" + data)
                    .then(function (response) {
                        return response;
                    });
            },
            receive: function (data) {
                return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL + "index.php/home/order/receive",
                        data: data
                }).then(function (response) {
                    return response;
                });
            }
        };
    }]);

angular.module('YJServices', [
    'services.baseUrlInterceptor',
    'services.localizedMessages',
    'services.defaultPostDataFormat',
    'services.stores',
    'services.upload',
    'services.validate',
    'services.register',
    'services.verify',
    'services.commodity',
    'services.tuanGou',
    'services.intentOrder',
    'services.accounts',
    'ngCordova.plugins.geolocation',
    'services.comment',
    'services.post',
    'services.bids'
]);

angular.module('ngCordova.plugins.geolocation', [])

  .factory('$cordovaGeolocation', ['$q', function ($q) {

    return {
      getCurrentPosition: function (options) {
        var q = $q.defer();

        navigator.geolocation.getCurrentPosition(function (result) {
          q.resolve(result);
        }, function (err) {
          q.reject(err);
        }, options);

        return q.promise;
      },

      watchPosition: function (options) {
        var q = $q.defer();

        var watchID = navigator.geolocation.watchPosition(function (result) {
          q.notify(result);
        }, function (err) {
          q.reject(err);
        }, options);

        q.promise.cancel = function () {
          navigator.geolocation.clearWatch(watchID);
        };

        q.promise.clearWatch = function (id) {
          navigator.geolocation.clearWatch(id || watchID);
        };

        q.promise.watchID = watchID;

        return q.promise;
      },

      clearWatch: function (watchID) {
        return navigator.geolocation.clearWatch(watchID);
      }
    };
  }]);

angular.module('services.defaultPostDataFormat', [])

    // This config is used to setup content-type and data format for default Post method as following value.
    // Content-type: 'application/x-www-form-urlencoded'
    // Data format as example, from:
    // {
    //      "key": "value",
    //      "key1": "value1"
    // }
    // to:
    // "key=value&key1=value1"
    .config(['$httpProvider', function ($httpProvider) {
        $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';

        var defaults = $httpProvider.defaults.transformRequest;

        defaults = angular.isArray(defaults) ? defaults : [defaults];

        defaults.unshift(function (data) {
            var str = [];

            for (var p in data) {
                str.push(encodeURIComponent(p) + '=' + encodeURIComponent(data[p]));
            }

            return str.join('&');
        });
    }]);

angular.module('services.commodity', [])

    .factory('Commodity', ['URLConfig', '$http', function (URLConfig, $http) {
        
        return {
            add: function (data) {

                $http({
                    method: 'POST',
                    url: URLConfig.API_BASEURL + "/product/info",
                    data: data
                })
                    .success(function (res) {
                        return true;
                    }).error(function (res) {
                        return false;
                    });
            },
            remove: function (storeId) {

            },
            get: function (storeId) {

            }
        };
    }]);
angular.module('services.comment', [])
    .factory('Comment', ['$http', 'URLConfig', function ($http, URLConfig) {
        return {
            add: function (data) {
                return $http({
                        method: 'GET',
                        url: URLConfig.API_BASEURL + "index.php/home/dianping/done",
                        params: data
                    }).then(function (response) {
                        return response;
                    });
            },
            get:function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/dianping/index?deal_id=" + data)
                    .then(function (response) {
                        return response;
                    });
            }
        }
    }]);


angular.module('services.bids', [])
    .factory('Bids', ['$http', 'URLConfig', function ($http, URLConfig) {

        var bids = {};
        var productDetail = '';
        return {
            all: function (data) {
                return $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL+"index.php/home/biao/index",
                        data: data
                    })
                    .then(function (response) {
                        bids =  response.data.data;
                        return response;
                    });
            },
            get: function (id) {
                // Simple index lookup
                return bids[id];
            },
            bidIntention: function (data) {
                return $http({
                        method: 'GET',
                        url: URLConfig.API_BASEURL+"index.php/home/biao/intent?biao_id="+data.biao_id+"&user_id="+data.user_id,
                        data: data
                    })
                    .then(function (response) {
                        return response;
                    });
            },
            addVote:function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/biao/addvote?user_id=" + data.user_id +"&item_id="+data.item_id+"&vote_id="+data.vote_id)
                    .then(function (response) {
                        return response;
                    });
            },
            getCodes: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/member/quan?user_id=" + data.user_id)
                    .then(function (response) {
                        return response;
                    });
            },
            getProducts: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/biao/dealList?biao_id=" + data.biao_id)
                    .then(function (response) {
                        return response;
                    });
            },
            signUp: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/biao/signup?user_id=" + data.user_id +"&biao_id="+data.biao_id+"&name="+data.name+"&mobile="+data.mobile+"&community="+data.community)
                    .then(function (response) {
                        return response;
                    });
            },
            productDetail: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/biao/dealcontent?id=" + data.product_id +"&biao_id=" + data.biao_id+"&user_id="+data.user_id)
                    .then(function (response) {
                        productDetail = response.data.data;
                        return response;
                    });
            },
            getProductDetails: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/deal/content?id=" + data.product_id)
                    .then(function (response) {
                        productDetail = response.data.data;
                        return response;
                    });
            },
            getProductDetail: function () {
                return productDetail;
            },
            getUsers: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/biao/biaoUsers?biao_id=" + data.biao_id)
                    .then(function (response) {
                        return response;
                    });
            },
            voteProduct:function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/biao/selectdeal?user_id=" + data.user_id +"&deal_id="+data.deal_id+"&biao_id="+data.biao_id)
                    .then(function (response) {
                        return response;
                    });
            }

        }
    }]);


angular.module('services.baseUrlInterceptor', ['configuration.environment'])

    // This base Url interceptor adding base url for all api urls.
    .factory('baseUrlInterceptor', ['URLConfig', function(URLConfig) {
        return {
            'request': function(config) {
                // Regular express for filtering urls suffix with .html or .json.
                var SERVER_URL_REGEXP = /^\/(?!.*\.(html|json)$).*$/gi;

                if (SERVER_URL_REGEXP.test(config.url)) {
                    config.url = URLConfig.API_BASEURL + config.url;
                }

                return config;
            }
        };
    }])
    .config(['$httpProvider', function ($httpProvider) {
        $httpProvider.interceptors.push('baseUrlInterceptor');
    }]);

angular.module('services.accounts', [])
    .factory('Account', ['$http', 'URLConfig',function ($http, URLConfig) {
        var address = {};

        return {
            all: function (data) {

               address= [{
                    addressId: 1,
                    name:'冯永亮',
                    mobile: '15298838562',
                    city: '江苏苏州工业园区',
                    address: '浩辰大厦3楼313室',
                    code: '215500'
                }];
                return address;
            },
            remove: function (item) {
                address.splice(address.indexOf(item), 1);
            },
            get: function (addressId) {
                for (var i = 0; i < address.length; i++) {
                    if (address[i].addressId === parseInt(addressId)) {
                        return address[i];
                    }
                }
                return null;
            },
            messages: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/member/message")
                    .then(function (response) {
                        return response;
                    });
            },
            messageDetial :  function (id) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/member/msgContent?id="+id)
                    .then(function (response) {
                        return response;
                    });
            },
            setAvatar :  function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/member/setAvatar?user_id="+data.user_id+"&avatar="+data.avatar)
                    .then(function (response) {
                        return response;
                    });
            },
            setNickname : function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/member/setNickname?user_id="+data.user_id+"&nickname="+data.nickname)
                    .then(function (response) {
                        return response;
                    });
            },
            setMobile: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/member/setMobile?user_id="+data.user_id+"&mobile="+data.mobile)
                    .then(function (response) {
                        return response;
                    });
            },
            setPassword: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/member/setPassword?user_id="+data.user_id+"&password="+data.password+"&old_password="+data.old_password)
                    .then(function (response) {
                        return response;
                    });
            },
            msgBrief: function (data) {
                return $http.get(URLConfig.API_BASEURL + "index.php/home/member/msgBrief?user_id="+data.user_id)
                    .then(function (response) {
                        return response;
                    });
            }
        }
    }]);

// Based loosely around work by Witold Szczerba - https://github.com/witoldsz/angular-http-auth
// Based https://github.com/angular-app/angular-app

/*jshint -W106 */

angular.module('security.service', [
    'security.retryQueue',  // Keeps track of failed requests that need to be retried once the user logs in
    'security.login'        // Contains the login form template and controller
])
    .factory('security', ['URLConfig', '$http', '$q', '$location', 'securityRetryQueue', 'USER_ROLES', '$rootScope',
        function (URLConfig, $http, $q, $location, securityRetryQueue, USER_ROLES, $rootScope) {

            var LOCAL_TOKEN_KEY = 'tokenKey';
            var username = '';
            var isAuthenticated = false;
            var role = '';
            var authToken;

            function loadUserCredentials() {
                var token = window.localStorage.getItem(LOCAL_TOKEN_KEY);
                if (token) {
                  useCredentials(token);
                }
            }

            function storeUserCredentials(token) {
                window.localStorage.setItem(LOCAL_TOKEN_KEY, token.split('.')[1]);
                useCredentials(token);
            }

            function useCredentials(token) {
                username = token.split('.')[0];
                isAuthenticated = true;
                authToken = token.split('.')[1];
                // Set the token as header for your requests!
                $http.defaults.headers.common['X-Auth-Token'] = authToken;
            }

            function destroyUserCredentials() {
                authToken = undefined;
                username = '';
                isAuthenticated = false;
                $http.defaults.headers.common['X-Auth-Token'] = undefined;
                window.localStorage.removeItem(LOCAL_TOKEN_KEY);
                window.localStorage.removeItem('USERS');
                // try{
                //     window.plugins.jPushPlugin.setAlias('');
                // }
                // catch(exception){
                //     console.log(exception);
                // }
            }

            var login = function(data) {
                return $q(function(resolve, reject) {
                    $http({
                        method: 'POST',
                        url: URLConfig.API_BASEURL + "index.php/home/member/login",
                        data: data
                    })
                    .success(function (res) {
                        resolve(res);
                        storeUserCredentials(res.data.nickName + '.'+ res.data.token);
                        window.localStorage.setItem('USERS', JSON.stringify(res.data));
                    }).error(function (res) {
                        reject(res);
                    });
                });
            };

            var quickLogin = function(res) {
                storeUserCredentials(res.data.nickName + '.'+ res.data.token);
                window.localStorage.setItem('USERS', JSON.stringify(res.data));
            }

            var logout = function() {
                destroyUserCredentials();
            };

            var isAuthorized = function(authorizedRoles) {
                if (!angular.isArray(authorizedRoles)) {
                    authorizedRoles = [authorizedRoles];
                }
                return (isAuthenticated && authorizedRoles.indexOf(role) !== -1);
            };

            var getWechatAccessToken = function(data) {
                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.WECHAT_BASEURL + "oauth2/access_token",
                        params: data
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (res) {
                        reject(res);
                    });
                });
            };

            var refershWechatAccessToken = function(data) {
                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.WECHAT_BASEURL + "oauth2/refresh_token",
                        params: data
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (res) {
                        reject(res);
                    });
                });
            };

            var getWechatUserInfo = function(data) {
                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.WECHAT_BASEURL + "userinfo",
                        params: data
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (res) {
                        reject(res);
                    });
                });
            };

            var getQQUserInfo = function(data) {
                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.QQ_BASEURL + "user/get_user_info",
                        params: data
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (res) {
                        reject(res);
                    });
                });
            };
            var getWeiBoUserInfo = function(data) {
                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.WEIBO_BASEURL + "users/show.json",
                        params: data
                    })
                    .success(function (res) {
                        resolve(res);
                    }).error(function (res) {
                        reject(res);
                    });
                });
            };


            var thirdLogin = function(data) {
                return $q(function(resolve, reject) {
                    $http({
                        method: 'GET',
                        url: URLConfig.API_BASEURL + "index.php/home/member/thirdlogin",
                        params: data
                    })
                    .success(function (res) {
                        storeUserCredentials(res.data.nickName + '.'+ res.data.token);
                        window.localStorage.setItem('USERS', JSON.stringify(res.data));
                        resolve(res);
                    }).error(function (res) {
                        reject(res);
                    });
                });
            };


            loadUserCredentials();

            return {
                login: login,
                getWechatAccessToken: getWechatAccessToken,
                refershWechatAccessToken: refershWechatAccessToken,
                getWechatUserInfo: getWechatUserInfo,
                getQQUserInfo: getQQUserInfo,
                getWeiBoUserInfo: getWeiBoUserInfo,
                quickLogin: quickLogin,
                thirdLogin: thirdLogin,
                logout: logout,
                isAuthorized: isAuthorized,
                isAuthenticated: function() {return isAuthenticated;},
                username: function() {return username;},
                role: function() {return role;}
            };
        }]);

/*jshint +W106 */

// Based https://github.com/angular-app/angular-app

angular.module('security.retryQueue', [])

// This is a generic retry queue for security failures.
// Each item is expected to expose two functions: retry and cancel.
    .factory('securityRetryQueue', ['$q', '$log', function($q, $log) {
        var retryQueue = [];
        var service = {
            // The security service puts its own handler in here!
            onItemAddedCallbacks: [],

            hasMore: function() {
                return retryQueue.length > 0;
            },

            push: function(retryItem) {
                retryQueue.push(retryItem);

                // Call all the onItemAdded callbacks
                angular.forEach(service.onItemAddedCallbacks, function(cb) {
                    try {
                        cb(retryItem);
                    }
                    catch(e) {
                        $log.error('securityRetryQueue.push(retryItem): callback threw an error ' + e);
                    }
                });
            },

            pushRetryFn: function(reason, retryFn) {
                // The reason parameter is optional
                if (arguments.length === 1) {
                    retryFn = reason;
                    reason = undefined;
                }

                // The deferred object that will be resolved or rejected by calling retry or cancel
                var deferred = $q.defer();
                var retryItem = {
                    reason: reason,
                    retry: function() {
                        // Wrap the result of the retryFn into a promise if it is not already
                        $q.when(retryFn()).then(function(value) {
                            // If it was successful then resolve our deferred
                            deferred.resolve(value);
                        }, function(value) {
                            // Otherwise reject it
                            deferred.reject(value);
                        });
                    },
                    cancel: function() {
                        // Give up on retrying and reject our deferred
                        deferred.reject();
                    }
                };

                service.push(retryItem);

                return deferred.promise;
            },

            retryReason: function() {
                return service.hasMore() && retryQueue[0].reason;
            },

            cancelAll: function() {
                while(service.hasMore()) {
                    retryQueue.shift().cancel();
                }
            },

            retryAll: function() {
                while(service.hasMore()) {
                    retryQueue.shift().retry();
                }
            }
        };

        return service;
    }]);

// Based https://github.com/angular-app/angular-app

angular.module('security.interceptor', ['security.retryQueue'])

    // This http interceptor listens for authentication failures
    .factory('securityInterceptor', ['$q', '$injector', 'securityRetryQueue', '$rootScope', 'AUTH_EVENTS',
        function ($q, $injector, queue, $rootScope, AUTH_EVENTS) {
            return {
                'request': function(config) {
                    if ( window.localStorage.getItem('tokenKey')) {
                        config.headers['X-Auth-Token'] =  window.localStorage.getItem('tokenKey');
                    }
                    return config || $q.when(config);
                },
                'responseError': function (response) {
                    $rootScope.$broadcast({
                        401: AUTH_EVENTS.notAuthenticated,
                        403: AUTH_EVENTS.notAuthorized
                      }[response.status], response);
                    return $q.reject(response);
                }
            };
        }])

    // We have to add the interceptor to the queue as a string because the interceptor depends upon service instants
    // that are not available in the config block.
    .config(['$httpProvider', function ($httpProvider) {
        $httpProvider.interceptors.push('securityInterceptor');
    }]);

// Based loosely around work by Witold Szczerba - https://github.com/witoldsz/angular-http-auth
// Based https://github.com/angular-app/angular-app
angular.module('security', [
    'security.service',
    'security.interceptor',
    'security.login',
    'security.authorization',
    'security.register'
]);


// Based https://github.com/angular-app/angular-app

angular.module('security.authorization', ['security.service'])

// This service provides guard methods to support AngularJS routes.
// You can add them as resolves to routes to require authorization levels
// before allowing a route change to complete
    .provider('securityAuthorization', {
        requireAuthenticatedUser: ['securityAuthorization', function(securityAuthorization) {
            return securityAuthorization.requireAuthenticatedUser();
        }],

        $get: ['security', 'securityRetryQueue', function(security, queue) {
            var service = {

                // Require that there is an authenticated user
                requireAuthenticatedUser: function() {
                    return security.requestCurrentUser().then(function() {
                        if (!security.isAuthenticated()) {
                            return queue.pushRetryFn('unauthenticated-client', service.requireAuthenticatedUser);
                        }
                    });
                }
            };

            return service;
        }]
    });

angular.module('YJDirectives', [
	'directives.common'
]);

// Get transform origin poly
var extend = angular.extend,
  forEach = angular.forEach,
  isDefined = angular.isDefined,
  isNumber = angular.isNumber,
  isString = angular.isString,
  jqLite = angular.element,
  noop = angular.noop;

var d = document.createElement('div');
var transformKeys = ['webkitTransformOrigin', 'transform-origin', '-webkit-transform-origin', 'webkit-transform-origin',
          '-moz-transform-origin', 'moz-transform-origin', 'MozTransformOrigin', 'mozTransformOrigin'];

var TRANSFORM_ORIGIN = 'webkitTransformOrigin';
for(var i = 0; i < transformKeys.length; i++) {
    if(d.style[transformKeys[i]] !== undefined) {
        TRANSFORM_ORIGIN = transformKeys[i];
        break;
    }
}

var transitionKeys = ['webkitTransition', 'transition', '-webkit-transition', 'webkit-transition',
          '-moz-transition', 'moz-transition', 'MozTransition', 'mozTransition'];
var TRANSITION = 'webkitTransition';
for(var i = 0; i < transitionKeys.length; i++) {
    if(d.style[transitionKeys[i]] !== undefined) {
        TRANSITION = transitionKeys[i];
        break;
    }
}

var HomeSlider = ionic.views.View.inherit({
  initialize: function (options) {
    var slider = this;

    // utilities
    var noop = function() {}; // simple no operation function
    var offloadFn = function(fn) { setTimeout(fn || noop, 0); }; // offload a functions execution

    // check browser capabilities
    var browser = {
      addEventListener: !!window.addEventListener,
      touch: ('ontouchstart' in window) || window.DocumentTouch && document instanceof DocumentTouch,
      transitions: (function(temp) {
        var props = ['transitionProperty', 'WebkitTransition', 'MozTransition', 'OTransition', 'msTransition'];
        for ( var i in props ) if (temp.style[ props[i] ] !== undefined) return true;
        return false;
      })(document.createElement('swipe'))
    };


    var container = options.el;

    // quit if no root element
    if (!container) return;
    var element = container.children[0];
    var slides, slidePos, width, length;
    options = options || {};
    var index = parseInt(options.startSlide, 10) || 0;
    var speed = options.speed || 500;
    options.continuous = options.continuous !== undefined ? options.continuous : true;

    function setup() {

      // do not setup if the container has no width
      if (!container.offsetWidth) {
        return;
      }

      // cache slides
      slides = element.children;
      length = slides.length;

      // set continuous to false if only one slide
      if (slides.length < 2) options.continuous = false;

      //special case if two slides
      if (browser.transitions && options.continuous && slides.length < 3) {
        element.appendChild(slides[0].cloneNode(true));
        element.appendChild(element.children[1].cloneNode(true));
        slides = element.children;
      }

      // create an array to store current positions of each slide
      slidePos = new Array(slides.length);

      // determine width of each slide
      width = (container.offsetWidth || container.getBoundingClientRect().width)/2;

      element.style.width = (slides.length * width) + 'px';
      // element.style.width = (width) + 'px';

      // width = 160;

      // stack elements
      var pos = slides.length;
      while(pos--) {

        var slide = slides[pos];

        slide.style.width = width + 'px';
        var img = slide.children[0];
        if(pos!=index){
            img.style.display = 'none';
        }
        slide.setAttribute('data-index', pos);

        if (browser.transitions) {

          slide.style.left = (pos * -width)+ width/2 +'px';
          move(pos, index > pos ? -width : (index < pos ? width : 0), 0);
        }

      }
      // reposition elements before and after index
      if (options.continuous && browser.transitions) {
        slides[circle(index - 1)].children[0].style.display = 'block';
        slides[circle(index + 1)].children[0].style.display = 'block';

        move(circle(index - 1), -width, 0);
        move(circle(index + 1), width, 0);
      }

      if (!browser.transitions) element.style.left = (index * -width) + 'px';

      container.style.visibility = 'visible';

      options.slidesChanged && options.slidesChanged();
    }

    function hiddenImage(index){
        var pos = slides.length;
        while(pos--) {
            var slide = slides[pos];
            slide.style.width = width + 'px';
            var img = slide.children[0];
            if(pos!=index){
                img.style.display = 'none';
            }
            if (browser.transitions) {
                move(pos, index > pos ? -width : (index < pos ? width : 0), 600);
            }
        }
        if (options.continuous && browser.transitions) {
            slides[circle(index - 1)].children[0].style.display = 'block';
            slides[circle(index + 1)].children[0].style.display = 'block';
            move(circle(index - 1), -width, 600);
            move(circle(index + 1), width, 600);
        }
    }

    function prev(slideSpeed) {

      if (options.continuous) slide(index - 1, slideSpeed);
      else if (index) slide(index - 1, slideSpeed);

    }

    function next(slideSpeed) {

      if (options.continuous) slide(index + 1, slideSpeed);
      else if (index < slides.length - 1) slide(index + 1, slideSpeed);

    }

    function circle(index) {

      // a simple positive modulo using slides.length
      return (slides.length + (index % slides.length)) % slides.length;

    }

    function slide(to, slideSpeed) {

      // do nothing if already on requested slide
      if (index == to) return;

      if (browser.transitions) {

        var direction = Math.abs(index - to) / (index - to); // 1: backward, -1: forward

        // get the actual position of the slide
        if (options.continuous) {
          var naturalDirection = direction;
          direction = -slidePos[circle(to)] / width;

          // if going forward but to < index, use to = slides.length + to
          // if going backward but to > index, use to = -slides.length + to
          if (direction !== naturalDirection) to = -direction * slides.length + to;

        }

        var diff = Math.abs(index - to) - 1;

        // move all the slides between index and to in the right direction
        while (diff--) move( circle((to > index ? to : index) - diff - 1), width * direction, 0);

        to = circle(to);

        move(index, width* direction, slideSpeed || speed);
        move(to, 0, slideSpeed || speed);

        if (options.continuous) move(circle(to - direction), -(width * direction), 0); // we need to get the next in place

      } else {

        to = circle(to);
        animate(index * -width, to * -width, slideSpeed || speed);
        //no fallback for a circular continuous if the browser does not accept transitions
      }

      index = to;
      offloadFn(options.callback && options.callback(index, slides[index]));
    }

    function move(index, dist, speed) {

      translate(index, dist, speed);
      slidePos[index] = dist;

    }

    function translate(index1, dist, speed, x) {
        var o;
        if(x){
            o = Math.abs((x/(width/0.4)));
        }else{
            o=0;
        }
        var slide = slides[index1];
        var style = slide && slide.style;

        if (!style) return;

            style.webkitTransitionDuration =
            style.MozTransitionDuration =
            style.msTransitionDuration =
            style.OTransitionDuration =
            style.transitionDuration = speed + 'ms';
        if(index == index1){
            style.webkitTransform = 'translate(' + dist + 'px,0)' + 'translateZ(0) scale('+ (1-o) +')';
            style.msTransform =
            style.MozTransform =
            style.OTransform = 'translateX(' + dist + 'px) scale('+ (1-o) +')';
            style.opacity = '1'
            // style.
        }else {
            style.webkitTransform = 'translate(' + dist + 'px,0)' + 'translateZ(0) scale('+(0.6+ o)+')';
            style.msTransform =
            style.MozTransform =
            style.OTransform = 'translateX(' + dist + 'px) scale('+(0.6+ o)+')'
            style.opacity = '0.7'
        }

    }

    function animate(from, to, speed) {

      // if not an animation, just reposition
      if (!speed) {

        element.style.left = to + 'px';
        return;

      }

      var start = +new Date();

      var timer = setInterval(function() {

        var timeElap = +new Date() - start;

        if (timeElap > speed) {

          element.style.left = to + 'px';

          if (delay) begin();

          options.transitionEnd && options.transitionEnd.call(event, index, slides[index]);

          clearInterval(timer);
          return;

        }

        element.style.left = (( (to - from) * (Math.floor((timeElap / speed) * 100) / 100) ) + from) + 'px';

      }, 4);

    }

    // setup auto slideshow
    var delay = options.auto || 0;
    var interval;

    function begin() {

      interval = setTimeout(next, delay);

    }

    function stop() {

      delay = options.auto || 0;
      clearTimeout(interval);

    }


    // setup initial vars
    var start = {};
    var delta = {};
    var isScrolling;

    // setup event capturing
    var events = {

      handleEvent: function(event) {
        if(event.type == 'mousedown' || event.type == 'mouseup' || event.type == 'mousemove') {
          event.touches = [{
            pageX: event.pageX,
            pageY: event.pageY
          }];
        }

        switch (event.type) {
          case 'mousedown': this.start(event); break;
          case 'touchstart': this.start(event); break;
          case 'touchmove': this.touchmove(event); break;
          case 'mousemove': this.touchmove(event); break;
          case 'touchend': offloadFn(this.end(event)); break;
          case 'mouseup': offloadFn(this.end(event)); break;
          case 'webkitTransitionEnd':
          case 'msTransitionEnd':
          case 'oTransitionEnd':
          case 'otransitionend':
          case 'transitionend': offloadFn(this.transitionEnd(event)); break;
          case 'resize': offloadFn(setup); break;
        }

        if (options.stopPropagation) event.stopPropagation();

      },
      start: function(event) {

        var touches = event.touches[0];

        // measure start values
        start = {

          // get initial touch coords
          x: touches.pageX,
          y: touches.pageY,

          // store time to determine touch duration
          time: +new Date()

        };

        // used for testing first move event
        isScrolling = undefined;

        // reset delta and end measurements
        delta = {};

        // attach touchmove and touchend listeners
        if(browser.touch) {
          element.addEventListener('touchmove', this, false);
          element.addEventListener('touchend', this, false);
        } else {
          element.addEventListener('mousemove', this, false);
          element.addEventListener('mouseup', this, false);
          document.addEventListener('mouseup', this, false);
        }
      },
      touchmove: function(event) {

        // ensure swiping with one touch and not pinching
        // ensure sliding is enabled

        if (event.touches.length > 1 ||
            event.scale && event.scale !== 1 ||
            slider.slideIsDisabled) {
          return;
        }

        if (options.disableScroll) event.preventDefault();

        var touches = event.touches[0];

        // measure change in x and y
        delta = {
          x: touches.pageX - start.x,
          y: touches.pageY - start.y
        };
        console.log();

        // determine if scrolling test has run - one time test
        if ( typeof isScrolling == 'undefined') {
          isScrolling = !!( isScrolling || Math.abs(delta.x) < Math.abs(delta.y) );
        }

        // if user is not trying to scroll vertically
        if (!isScrolling) {

          // prevent native scrolling
          event.preventDefault();

          // stop slideshow
          stop();

          // increase resistance if first or last slide
          if (options.continuous) { // we don't add resistance at the end

            translate(circle(index - 1), delta.x + slidePos[circle(index - 1)], 0, delta.x);
            translate(index, delta.x + slidePos[index], 0,delta.x);
            translate(circle(index + 1), delta.x + slidePos[circle(index + 1)], 0,delta.x);

          } else {

            delta.x =
              delta.x /
                ( (!index && delta.x > 0 ||         // if first slide and sliding left
                  index == slides.length - 1 &&     // or if last slide and sliding right
                  delta.x < 0                       // and if sliding at all
                ) ?
                ( Math.abs(delta.x) / width + 1 )      // determine resistance level
                : 1 );                                 // no resistance if false

            // translate 1:1
            translate(index - 1, delta.x + slidePos[index - 1], 0,delta.x);
            translate(index, delta.x + slidePos[index], 0,delta.x);
            translate(index + 1, delta.x + slidePos[index + 1], 0,delta.x);
          }

          options.onDrag && options.onDrag();
        }

      },
      end: function() {

        // measure duration
        var duration = +new Date() - start.time;

        // determine if slide attempt triggers next/prev slide
        var isValidSlide =
              Number(duration) < 250 &&         // if slide duration is less than 250ms
              Math.abs(delta.x) > 20 ||         // and if slide amt is greater than 20px
              Math.abs(delta.x) > width / 2;      // or if slide amt is greater than half the width

        // determine if slide attempt is past start and end
        var isPastBounds = (!index && delta.x > 0) ||      // if first slide and slide amt is greater than 0
              (index == slides.length - 1 && delta.x < 0); // or if last slide and slide amt is less than 0

        if (options.continuous) isPastBounds = false;

        // determine direction of swipe (true:right, false:left)
        var direction = delta.x < 0;

        // if not scrolling vertically
        if (!isScrolling) {

          if (isValidSlide && !isPastBounds) {

            if (direction) {

                if (options.continuous) { // we need to get the next in this direction in place
                    move(circle(index - 1), -width, 500);
                    move(circle(index + 2), width, 500);
                    slides[circle(index - 1)].children[0].style.display = 'block';
                    slides[circle(index + 2)].children[0].style.display = 'block';
                } else {
                    move(index - 1, -width, 500);
                }

                move(index, slidePos[index] - width, 500);
                move(circle(index + 1), slidePos[circle(index + 1)] - width, 500);

                index = circle(index + 1);
                move(index, 0, 500);
                hiddenImage(index);

            } else {
                if (options.continuous) { // we need to get the next in this direction in place
                    move(circle(index + 1), width, 500);
                    move(circle(index - 2), -width, 500);
                    slides[circle(index + 1)].children[0].style.display = 'block';
                    slides[circle(index - 2)].children[0].style.display = 'block';
                } else {
                    move(index + 1, width, 500);
                }

                move(index, slidePos[index] + width, 500);
                move(circle(index - 1), slidePos[circle(index - 1)] + width, 500);
                index = circle(index - 1);
                move(index, 0, 500);
                hiddenImage(index);
            }
            options.callback && options.callback(index, slides[index]);

            } else {

            if (options.continuous) {

              move(circle(index - 1), -width, 500);
              move(index, 0, 500);
              move(circle(index + 1), width, 500);

            } else {

              move(index - 1, -width, 500);
              move(index, 0, 500);
              move(index + 1, width, 500);
            }

          }

        }

        // kill touchmove and touchend event listeners until touchstart called again
        if(browser.touch) {
          element.removeEventListener('touchmove', events, false);
          element.removeEventListener('touchend', events, false);
        } else {
          element.removeEventListener('mousemove', events, false);
          element.removeEventListener('mouseup', events, false);
          document.removeEventListener('mouseup', events, false);
        }

        options.onDragEnd && options.onDragEnd();
      },
      transitionEnd: function(event) {

        if (parseInt(event.target.getAttribute('data-index'), 10) == index) {

          if (delay) begin();

          options.transitionEnd && options.transitionEnd.call(event, index, slides[index]);

        }

      }

    };

    // Public API
    this.update = function() {
      setTimeout(setup);
    };
    this.setup = function() {
      setup();
    };

    this.loop = function(value) {
      if (arguments.length) options.continuous = !!value;
      return options.continuous;
    };

    this.enableSlide = function(shouldEnable) {
      if (arguments.length) {
        this.slideIsDisabled = !shouldEnable;
      }
      return !this.slideIsDisabled;
    };

    this.slide = this.select = function(to, speed) {
      // cancel slideshow
      stop();

      slide(to, speed);
    };

    this.prev = this.previous = function() {
      // cancel slideshow
      stop();

      prev();
    };

    this.next = function() {
      // cancel slideshow
      stop();

      next();
    };

    this.stop = function() {
      // cancel slideshow
      stop();
    };

    this.start = function() {
      begin();
    };

    this.autoPlay = function(newDelay) {
      if (!delay || delay < 0) {
        stop();
      } else {
        delay = newDelay;
        begin();
      }
    };

    this.currentIndex = this.selected = function() {
      // return current index position
      return index;
    };

    this.slidesCount = this.count = function() {
      // return total number of slides
      return length;
    };

    this.kill = function() {
      // cancel slideshow
      stop();

      // reset element
      element.style.width = '';
      element.style.left = '';

      // reset slides so no refs are held on to
      slides && (slides = []);

      // removed event listeners
      if (browser.addEventListener) {

        // remove current event listeners
        element.removeEventListener('touchstart', events, false);
        element.removeEventListener('webkitTransitionEnd', events, false);
        element.removeEventListener('msTransitionEnd', events, false);
        element.removeEventListener('oTransitionEnd', events, false);
        element.removeEventListener('otransitionend', events, false);
        element.removeEventListener('transitionend', events, false);
        window.removeEventListener('resize', events, false);

      }
      else {

        window.onresize = null;

      }
    };

    this.load = function() {
      // trigger setup
      setup();

      // start auto slideshow if applicable
      if (delay) begin();


      // add event listeners
      if (browser.addEventListener) {

        // set touchstart event on element
        if (browser.touch) {
          element.addEventListener('touchstart', events, false);
        } else {
          element.addEventListener('mousedown', events, false);
        }

        if (browser.transitions) {
          element.addEventListener('webkitTransitionEnd', events, false);
          element.addEventListener('msTransitionEnd', events, false);
          element.addEventListener('oTransitionEnd', events, false);
          element.addEventListener('otransitionend', events, false);
          element.addEventListener('transitionend', events, false);
        }

        // set resize event on window
        window.addEventListener('resize', events, false);

      } else {

        window.onresize = function () { setup(); }; // to play nice with old IE

      }
    };

  }
});
angular.module('directives.common', [])
.directive('file', function() {
    return {
        restrict: 'AE',
        scope: {
            file: '@'
        },
        link: function(scope, el, attrs){
            el.bind('change', function(event){
                var files = event.target.files;
                var file = files[0];
                scope.file = file;
                scope.$parent.file = file;
                scope.$apply();
            });
        }
    };
})
.directive('dynamicHeight', function() {
    return {
        require: ['^ionSlideBox'],
        link: function(scope, elem, attrs, slider) {
            scope.$watch(function() {
                return slider[0].__slider.selected();
            }, function(val) {
                //getting the height of viewport
                var newHeight = window.getComputedStyle(elem.parent('ion-content')[0], null).getPropertyValue("height");
                if (parseInt(newHeight) > 0) {
                    var ionScrollTag = elem.find('ion-scroll')[0];
                    ionScrollTag.style.height = newHeight;
                }
            });
        }
    };
})
.directive('noImage', [
    '$timeout', function($timeout) {
      return {
        restrict: 'A',
        link: function(scope, element, attrs) {
            scope.$watch(function() {
                return attrs.ngSrc;
            }, function() {
                var src;
                src = attrs.ngSrc;
                if (!src) {
                  return element.attr('src', "img/default.png");
                }
            });
            return element.bind('error', function() {
                return element.attr('src', "img/default.png");
            });
        }
      };
    }
])
.directive('showElement', function($document,$window) {
    return {
        restrict: 'A',
        scope : {
            showElement : "=?"
        },
        link: function(scope, element) {
            element.data('thing',true);
            angular.element($document[0].body).on('click',function(e) {
                var inThing =  angular.element(e.target).inheritedData('thing');
                if (inThing) {
                    scope.showElement = true;
                } else {
                    scope.showElement = false;
                }
                scope.$apply();
            })
        }
    }
})
.directive("starRating", function() {
    return {
        restrict : "EA",
        template : "<ul class='rating' ng-class='{readonly: readonly}'>" +
                   "  <li ng-repeat='star in stars' ng-class='star' ng-click='$parent.toggle($index)'>" +
                   " \u2605" + //&#9733
                   "  </li>" +
                   "</ul>",
        scope : {
            ratingValue : "=ngModel",
            max : "=?", //optional: default is 5
            onRatingSelected : "&?",
            readonly: "=?"
        },
        link : function(scope, elem, attrs) {
          if (scope.max == undefined) { scope.max = 5; }
          function updateStars() {
            scope.stars = [];
            for (var i = 0; i < scope.max; i++) {
              scope.stars.push({
                filled : i < scope.ratingValue
              });
            }
          };
          scope.toggle = function(index) {
            if (scope.readonly == undefined || scope.readonly == false){
              scope.ratingValue = index + 1;
              scope.onRatingSelected({
                rating: index + 1
              });
            }
          };
          scope.$watch("ratingValue", function(oldVal, newVal) {
             updateStars();
          });
        }
    };
})
.directive("ionImages",['$ionicModal', function($ionicModal) {
    return {
        restrict : "EA",
        scope : {
            ionImages : "=ngModel",
            index : "=?", //optional: default is 5
            onSelected : "&?"
        },
        link : function(scope, elem, attrs) {
            elem.bind('click', function (event) {
                $ionicModal.fromTemplateUrl('templates/image-popover.html', {
                    scope: scope,
                    animation: 'slide-in-up'
                }).then(function(modal) {
                    scope.modal = modal;
                    scope.modal.show();
                });
            });
            scope.closeModal = function() {
                scope.modal.hide();
                scope.modal.remove();
            };
        }
    };
}])
.directive('ionHomeSlideBox', [
  '$timeout',
  '$compile',
  '$ionicSlideBoxDelegate',
  '$ionicHistory',
  '$ionicScrollDelegate',
function($timeout, $compile, $ionicSlideBoxDelegate, $ionicHistory, $ionicScrollDelegate) {
  return {
    restrict: 'E',
    replace: true,
    transclude: true,
    scope: {
      autoPlay: '=',
      doesContinue: '@',
      slideInterval: '@',
      showPager: '@',
      pagerClick: '&',
      disableScroll: '@',
      onSlideChanged: '&',
      activeSlide: '=?'
    },
    controller: ['$scope', '$element', '$attrs', function($scope, $element, $attrs) {
      var _this = this;

      var continuous = $scope.$eval($scope.doesContinue) === true;
      var shouldAutoPlay = isDefined($attrs.autoPlay) ? !!$scope.autoPlay : false;
      var slideInterval = shouldAutoPlay ? $scope.$eval($scope.slideInterval) || 4000 : 0;

      var slider = new HomeSlider({
        el: $element[0],
        auto: slideInterval,
        continuous: continuous,
        startSlide: $scope.activeSlide,
        slidesChanged: function() {
          $scope.currentSlide = slider.currentIndex();

          // Try to trigger a digest
          $timeout(function() {});
        },
        callback: function(slideIndex) {
          $scope.currentSlide = slideIndex;
          $scope.onSlideChanged({ index: $scope.currentSlide, $index: $scope.currentSlide});
          $scope.$parent.$broadcast('slideBox.slideChanged', slideIndex);
          $scope.activeSlide = slideIndex;
          // Try to trigger a digest
          $timeout(function() {});
        },
        onDrag: function() {
          freezeAllScrolls(true);
        },
        onDragEnd: function() {
          freezeAllScrolls(false);
        }
      });

      function freezeAllScrolls(shouldFreeze) {
        if (shouldFreeze && !_this.isScrollFreeze) {
          $ionicScrollDelegate.freezeAllScrolls(shouldFreeze);

        } else if (!shouldFreeze && _this.isScrollFreeze) {
          $ionicScrollDelegate.freezeAllScrolls(false);
        }
        _this.isScrollFreeze = shouldFreeze;
      }

      slider.enableSlide($scope.$eval($attrs.disableScroll) !== true);

      $scope.$watch('activeSlide', function(nv) {
        if (isDefined(nv)) {
          slider.slide(nv);
        }
      });

      $scope.$on('slideBox.nextSlide', function() {
        slider.next();
      });

      $scope.$on('slideBox.prevSlide', function() {
        slider.prev();
      });

      $scope.$on('slideBox.setSlide', function(e, index) {
        slider.slide(index);
      });

      //Exposed for testing
      this.__slider = slider;

      var deregisterInstance = $ionicSlideBoxDelegate._registerInstance(
        slider, $attrs.delegateHandle, function() {
          return $ionicHistory.isActiveScope($scope);
        }
      );
      $scope.$on('$destroy', function() {
        deregisterInstance();
        slider.kill();
      });

      this.slidesCount = function() {
        return slider.slidesCount();
      };
      $timeout(function() {
        slider.load();
      });
    }],
    template: '<div class="slider">' +
          '<div class="slider-slides" ng-transclude>' +
          '</div>' +
    '</div>',

    link: function($scope, $element, $attr) {
    }
  };
}])
.directive('ionHomeSlide', function() {
  return {
    restrict: 'E',
    require: '^ionHomeSlideBox',
    compile: function(element) {
      element.addClass('slider-slide');
    }
  };
})
.directive('ionSearch', function() {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                getData: '&source',
                model: '=?',
                search: '=?filter'
            },
            link: function(scope, element, attrs) {
                attrs.minLength = attrs.minLength || 0;
                scope.placeholder = attrs.placeholder || '';
                scope.search = {value: ''};

                if (attrs.class)
                    element.addClass(attrs.class);

                if (attrs.source) {
                    scope.$watch('search.value', function (newValue, oldValue) {
                        if (newValue.length > attrs.minLength) {
                            scope.getData({str: newValue}).then(function (results) {
                                scope.model = results;
                            });
                        } else {
                            scope.model = [];
                        }
                    });
                }

                scope.clearSearch = function() {
                    scope.search.value = '';
                };
            },
            template: '<div class="item-input-wrapper">' +
                        '<i class="icon ion-android-search"></i>' +
                        '<input type="search" placeholder="{{placeholder}}" ng-model="search.value">' +
                        '<i ng-if="search.value.length > 0" ng-click="clearSearch()" class="icon ion-close"></i>' +
                      '</div>'
        };
})
.directive('blurredImage', ['$timeout', function($timeout){
    return {
        restrict: 'E',
        replace:true,
        scope: {
            src:'@',
            width:'=',
            height:'=',
            cssClass:'='
        },
        link: function(scope, element, attrs){
            scope.itemId = "canvas_" + parseInt(Math.random()*1000000000)
            var fillCanvas = function(){
                if(!scope.src)
                    return;

                $timeout(function() {
                    var context = element[0].getContext("2d"); // get the 2d context object
                    var img     = new Image() //create a new image
                    img.onload = function(){
                        context.drawImage(img, 0, 0, scope.width, scope.height); // draw the image at the given location
                        if(device.platform == "Android"){
                            boxBlurCanvasRGBA( scope.itemId, 0, 0, scope.width, scope.height, 20, 40);
                        }else {
                            boxBlurCanvasRGBA( scope.itemId, 0, 0, scope.width, scope.height, 10, 40);
                        }
                    };
                    ionic.requestAnimationFrame(function() {
                        img.src = scope.src;
                        img.crossOrigin = 'Anonymous';
                    });
                },500);

            }
            scope.$watch('src', function(){
                fillCanvas();
            });
        },
        template: '<canvas id="{{itemId}}" class="{{cssClass}}" style="width:100%; height:{{height}}px"></canvas>'
    };
}])
.directive('cmsContent', [
    '$sce', '$compile', 'URLConfig', function($sce, $compile,URLConfig ) {
      return {
        restrict: 'A',
        link: function(scope, element, attrs) {
          var imgPattern, srcPattern, iframePattern;
          imgPattern = /<img.*?(?:>|\/>)/gi;
          srcPattern = /src=[\'\"]?([^\'\"]*)[\'\"]?/i;
          iframePattern = /(<iframe.+?<\/iframe>)/g;
          return scope.$watch(attrs.cmsContent, function(html) {
            if (html) {
              angular.forEach(html.match(imgPattern), function(img) {
                var src;
                src = img.match(srcPattern)[1];
                return html = html.replace(src, "" + URLConfig.IMG_URL + "/" + src);
              });
               angular.forEach(html.match(iframePattern), function(iframe) {
                var src;
                src = iframe.match(srcPattern)[1];
                url = $sce.trustAsResourceUrl(src);
                return html = html.replace(src, url);
              });

              element.html($sce.getTrustedHtml(html));
              return $compile(element.contents())(scope);
            }
          });
        }
      };
    }
  ])
.directive('headerShrink', ['$ionicScrollDelegate','$document',function($ionicScrollDelegate, $document) {
    var fadeAmt;
    var shrink = function(header, content, amt, max) {
        amt = Math.min(44, amt);
        fadeAmt = 1 - amt / 44;
        ionic.requestAnimationFrame(function() {
            header.style.opacity = 1- fadeAmt;
        });
     };

    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {
            var starty = $scope.$eval($attr.headerShrink) || 0;
            var shrinkAmt;
            $element.bind('scroll', function(e) {
                if(!$scope.isHomepage){
                    return;
                }
                var headerList = $document[0].body.querySelectorAll('.nav-bar-block');
                angular.forEach(headerList, function(value, key) {
                    if(value.attributes.getNamedItem('nav-bar').value=== "cached"){
                        header = value.children[0];
                    }
                });
                var headerHeight = header.offsetHeight;
                var scrollTop = null;
                if(e.detail){
                  scrollTop = e.detail.scrollTop;
                }else if(e.target){
                  scrollTop = e.target.scrollTop;
                }
                if(scrollTop<0){
                    shrinkAmt = headerHeight - Math.max(0, (starty + headerHeight) - Math.abs(scrollTop));
                    shrink(header, $element[0], shrinkAmt, headerHeight);
                }else{
                    if(scrollTop > starty){
                      // Start shrinking
                      shrinkAmt = headerHeight - Math.max(0, (starty + headerHeight) - scrollTop);
                      shrink(header, $element[0], shrinkAmt, headerHeight);

                    } else {
                      shrink(header, $element[0], 0, headerHeight);

                    }
                }

            });
        }
    }
}]);

angular.module('YJConfiguration', [
    'configuration.environment',
    'configuration.I18N'
]);
moment.locale('en', {
  relativeTime: {
    future: "在 %s",
    past: "%s 以前",
    s: "%d 秒",
    m: "1 分",
    mm: "%d 分钟",
    h: "1 小时",
    hh: "%d 小时",
    d: "1 天",
    dd: "%d 天",
    M: "1 个月",
    MM: "%d 月",
    y: "1 年",
    yy: "%d 年"
  }
});

angular.module('configuration.I18N', [])

    // This constant defined constant messages.
    .constant('I18N.MESSAGES', {});

/* disable warnings about duplicate hash keys for this file */
/*jshint -W075 */

// Define environment relative variables
angular.module('configuration.environment', [])
    .constant('URLConfig', {
        'API_BASEURL': 'http://www.youjiacn.com:8000/',
        'IMG_URL':'http://www.youjiacn.com:8004/',
        'WECHAT_BASEURL':'https://api.weixin.qq.com/sns/',
        'QQ_BASEURL':'https://graph.qq.com/',
        'WEIBO_BASEURL': 'https://api.weibo.com/2/',
        'imageServer': 'http://youjiatest.oss-cn-qingdao.aliyuncs.com',
    })
    .constant('AUTH_EVENTS', {
        notAuthenticated: 'auth-not-authenticated',
        notAuthorized: 'auth-not-authorized',
        loginSuccess: 'auth-authenticated',
        registerSuccess: 'register-success',
        setPasswordSuccess: 'set-password-success',
        firstOpen:'first-open-app',
        addBBSPostSuccess:'add-bbs-post-success'
    })
    .constant('USER_ROLES', {
      admin: 'admin_role',
      public: 'public_role'
    })
    .constant('MESSAGE',{
        "mobileRequired" : "请输入您的手机号码"
    })
    .constant('CITY', {
        popular_cities: [
            {
            "full_pinyin":"上海",
            "id":36679,
            "code":5132,
            "parent_code":51,
            "name":"阿坝州",
            "level":2
            },
            {
            "full_pinyin":"北京",
            "id":36679,
            "code":5132,
            "parent_code":51,
            "name":"阿坝州",
            "level":2
            },
            {
            "full_pinyin":"广州",
            "id":36679,
            "code":5132,
            "parent_code":51,
            "name":"阿坝州",
            "level":2
            },
            {
            "full_pinyin":"深圳",
            "id":36679,
            "code":5132,
            "parent_code":51,
            "name":"阿坝州",
            "level":2
            },
            {
            "full_pinyin":"武汉",
            "id":36679,
            "code":5132,
            "parent_code":51,
            "name":"阿坝州",
            "level":2
            },
            {
            "full_pinyin":"天津",
            "id":36679,
            "code":5132,
            "parent_code":51,
            "name":"阿坝州",
            "level":2
            },
            {
            "full_pinyin":"西安",
            "id":36679,
            "code":5132,
            "parent_code":51,
            "name":"阿坝州",
            "level":2
            },
            {
            "full_pinyin":"南京",
            "id":36679,
            "code":5132,
            "parent_code":51,
            "name":"阿坝州",
            "level":2
            },
            {
            "full_pinyin":"杭州",
            "id":36679,
            "code":5132,
            "parent_code":51,
            "name":"阿坝州",
            "level":2
            }
        ],
        group: [{
            name: 'A',
            cities:[
                {
                "full_pinyin":"abazhou",
                "id":36679,
                "code":5132,
                "parent_code":51,
                "name":"阿坝州",
                "level":2
                },
                {
                "full_pinyin":"akesudiqu",
                "id":46551,
                "code":6529,
                "parent_code":65,
                "name":"阿克苏地区",
                "level":2
                },
                {
                "full_pinyin":"alashanmeng",
                "id":5799,
                "code":1529,
                "parent_code":15,
                "name":"阿拉善盟",
                "level":2
                },
                {
                "full_pinyin":"aletaidiqu",
                "id":47374,
                "code":6543,
                "parent_code":65,
                "name":"阿勒泰地区",
                "level":2
                },
                {
                "full_pinyin":"alidiqu",
                "id":41770,
                "code":5425,
                "parent_code":54,
                "name":"阿里地区",
                "level":2
                },
                {
                "full_pinyin":"ankangshi",
                "id":43379,
                "code":6109,
                "parent_code":61,
                "name":"安康市",
                "level":2
                },
                {
                "full_pinyin":"anqingshi",
                "id":14687,
                "code":3408,
                "parent_code":34,
                "name":"安庆市",
                "level":2
                },
                {
                "full_pinyin":"anshanshi",
                "id":6266,
                "code":2103,
                "parent_code":21,
                "name":"鞍山市",
                "level":2
                },
                {
                "full_pinyin":"anshunshi",
                "id":38402,
                "code":5204,
                "parent_code":52,
                "name":"安顺市",
                "level":2
                },
                {
                "full_pinyin":"anyangshi",
                "id":22058,
                "code":4105,
                "parent_code":41,
                "name":"安阳市",
                "level":2
                }
            ]},
            {
            name: 'B',
            cities:[
                {
                "full_pinyin":"baichengshi",
                "id":8333,
                "code":2208,
                "parent_code":22,
                "name":"白城市",
                "level":2
                },
                {
                "full_pinyin":"baiseshi",
                "id":31033,
                "code":4510,
                "parent_code":45,
                "name":"百色市",
                "level":2
                },
                {
                "full_pinyin":"baishanshi",
                "id":8144,
                "code":2206,
                "parent_code":22,
                "name":"白山市",
                "level":2
                },
                {
                "full_pinyin":"baiyinshi",
                "id":43936,
                "code":6204,
                "parent_code":62,
                "name":"白银市",
                "level":2
                },
                {
                "full_pinyin":"bangbushi",
                "id":14410,
                "code":3403,
                "parent_code":34,
                "name":"蚌埠市",
                "level":2
                },
                {
                "full_pinyin":"baodingshi",
                "id":1772,
                "code":1306,
                "parent_code":13,
                "name":"保定市",
                "level":2
                },
                {
                "full_pinyin":"baojishi",
                "id":42119,
                "code":6103,
                "parent_code":61,
                "name":"宝鸡市",
                "level":2
                },
                {
                "full_pinyin":"baoshanshi",
                "id":39923,
                "code":5305,
                "parent_code":53,
                "name":"保山市",
                "level":2
                },
                {
                "full_pinyin":"baotoushi",
                "id":4759,
                "code":1502,
                "parent_code":15,
                "name":"包头市",
                "level":2
                },
                {
                "full_pinyin":"bayannaoershi",
                "id":5418,
                "code":1508,
                "parent_code":15,
                "name":"巴彦淖尔市",
                "level":2
                },
                {
                "full_pinyin":"bayinguolengmengguzizhizhou",
                "id":46422,
                "code":6528,
                "parent_code":65,
                "name":"巴音郭楞蒙古自治州",
                "level":2
                },
                {
                "full_pinyin":"bazhongshi",
                "id":36299,
                "code":5119,
                "parent_code":51,
                "name":"巴中市",
                "level":2
                },
                {
                "full_pinyin":"beihaishi",
                "id":30688,
                "code":4505,
                "parent_code":45,
                "name":"北海市",
                "level":2
                },
                {
                "full_pinyin":"benxishi",
                "id":6476,
                "code":2105,
                "parent_code":21,
                "name":"本溪市",
                "level":2
                },
                {
                "full_pinyin":"bijiediqu",
                "id":38816,
                "code":5224,
                "parent_code":52,
                "name":"毕节地区",
                "level":2
                },
                {
                "full_pinyin":"binzhoushi",
                "id":21123,
                "code":3716,
                "parent_code":37,
                "name":"滨州市",
                "level":2
                },
                {
                "full_pinyin":"boertalamengguzizhizhou",
                "id":46380,
                "code":6527,
                "parent_code":65,
                "name":"博尔塔拉蒙古自治州",
                "level":2
                },
                {
                "full_pinyin":"bozhoushi",
                "id":15764,
                "code":3416,
                "parent_code":34,
                "name":"亳州市",
                "level":2
                }
            ]},
            {
            name: 'C',
            cities:[
                {
                "full_pinyin":"cangzhoushi",
                "id":2629,
                "code":1309,
                "parent_code":13,
                "name":"沧州市",
                "level":2
                },
                {
                "full_pinyin":"changchunshi",
                "id":7532,
                "code":2201,
                "parent_code":22,
                "name":"长春市",
                "level":2
                },
                {
                "full_pinyin":"changdeshi",
                "id":26683,
                "code":4307,
                "parent_code":43,
                "name":"常德市",
                "level":2
                },
                {
                "full_pinyin":"changdudiqu",
                "id":41178,
                "code":5421,
                "parent_code":54,
                "name":"昌都地区",
                "level":2
                },
                {
                "full_pinyin":"changjizhou",
                "id":46255,
                "code":6523,
                "parent_code":65,
                "name":"昌吉州",
                "level":2
                },
                {
                "full_pinyin":"changshashi",
                "id":25580,
                "code":4301,
                "parent_code":43,
                "name":"长沙市",
                "level":2
                },
                {
                "full_pinyin":"changzhishi",
                "id":3431,
                "code":1404,
                "parent_code":14,
                "name":"长治市",
                "level":2
                },
                {
                "full_pinyin":"changzhoushi",
                "id":11245,
                "code":3204,
                "parent_code":32,
                "name":"常州市",
                "level":2
                },
                {
                "full_pinyin":"chaohushi",
                "id":15499,
                "code":3414,
                "parent_code":34,
                "name":"巢湖市",
                "level":2
                },
                {
                "full_pinyin":"chaozhoushi",
                "id":29915,
                "code":4451,
                "parent_code":44,
                "name":"潮州市",
                "level":2
                },
                {
                "full_pinyin":"chengdeshi",
                "id":2400,
                "code":1308,
                "parent_code":13,
                "name":"承德市",
                "level":2
                },
                {
                "full_pinyin":"chengdushi",
                "id":33008,
                "code":5101,
                "parent_code":51,
                "name":"成都市",
                "level":2
                },
                {
                "full_pinyin":"chenzhoushi",
                "id":27147,
                "code":4310,
                "parent_code":43,
                "name":"郴州市",
                "level":2
                },
                {
                "full_pinyin":"chifengshi",
                "id":4874,
                "code":1504,
                "parent_code":15,
                "name":"赤峰市",
                "level":2
                },
                {
                "full_pinyin":"chizhoushi",
                "id":15871,
                "code":3417,
                "parent_code":34,
                "name":"池州市",
                "level":2
                },
                {
                "full_pinyin":"chongzuoshi",
                "id":31478,
                "code":4514,
                "parent_code":45,
                "name":"崇左市",
                "level":2
                },
                {
                "full_pinyin":"chuxiongzhou",
                "id":40441,
                "code":5323,
                "parent_code":53,
                "name":"楚雄州",
                "level":2
                },
                {
                "full_pinyin":"chuzhoushi",
                "id":15005,
                "code":3411,
                "parent_code":34,
                "name":"滁州市",
                "level":2
                }
            ]},
            {
            name: 'D',
            cities:[
                {
                "full_pinyin":"dalianshi",
                "id":6088,
                "code":2102,
                "parent_code":21,
                "name":"大连市",
                "level":2
                },
                {
                "full_pinyin":"dalizhou",
                "id":40852,
                "code":5329,
                "parent_code":53,
                "name":"大理州",
                "level":2
                },
                {
                "full_pinyin":"dandongshi",
                "id":6542,
                "code":2106,
                "parent_code":21,
                "name":"丹东市",
                "level":2
                },
                {
                "full_pinyin":"daqingshi",
                "id":9419,
                "code":2306,
                "parent_code":23,
                "name":"大庆市",
                "level":2
                },
                {
                "full_pinyin":"datongshi",
                "id":3224,
                "code":1402,
                "parent_code":14,
                "name":"大同市",
                "level":2
                },
                {
                "full_pinyin":"daxinganlingdiqu",
                "id":10483,
                "code":2327,
                "parent_code":23,
                "name":"大兴安岭地区",
                "level":2
                },
                {
                "full_pinyin":"dazhoushi",
                "id":35813,
                "code":5117,
                "parent_code":51,
                "name":"达州市",
                "level":2
                },
                {
                "full_pinyin":"dehongzhou",
                "id":40979,
                "code":5331,
                "parent_code":53,
                "name":"德宏州",
                "level":2
                },
                {
                "full_pinyin":"deyangshi",
                "id":33681,
                "code":5106,
                "parent_code":51,
                "name":"德阳市",
                "level":2
                },
                {
                "full_pinyin":"dezhoushi",
                "id":20836,
                "code":3714,
                "parent_code":37,
                "name":"德州市",
                "level":2
                },
                {
                "full_pinyin":"dingxishi",
                "id":44699,
                "code":6211,
                "parent_code":62,
                "name":"定西市",
                "level":2
                },
                {
                "full_pinyin":"diqingzhou",
                "id":41070,
                "code":5334,
                "parent_code":53,
                "name":"迪庆州",
                "level":2
                },
                {
                "full_pinyin":"dongguanshi",
                "id":29855,
                "code":4419,
                "parent_code":44,
                "name":"东莞市",
                "level":2
                },
                {
                "full_pinyin":"dongyingshi",
                "id":19796,
                "code":3705,
                "parent_code":37,
                "name":"东营市",
                "level":2
                }
            ]},
            {
            name: 'E',
            cities:[
                {
                "full_pinyin":"eerduosishi",
                "id":5162,
                "code":1506,
                "parent_code":15,
                "name":"鄂尔多斯市",
                "level":2
                },
                {
                "full_pinyin":"enshizhou",
                "id":25388,
                "code":4228,
                "parent_code":42,
                "name":"恩施州",
                "level":2
                },
                {
                "full_pinyin":"ezhoushi",
                "id":24706,
                "code":4207,
                "parent_code":42,
                "name":"鄂州市",
                "level":2
                }
            ]},
            {
            name: 'F',
            cities:[
                {
                "full_pinyin":"fangchenggangshi",
                "id":30724,
                "code":4506,
                "parent_code":45,
                "name":"防城港市",
                "level":2
                },
                {
                "full_pinyin":"foshanshi",
                "id":28737,
                "code":4406,
                "parent_code":44,
                "name":"佛山市",
                "level":2
                },
                {
                "full_pinyin":"fushunshi",
                "id":6384,
                "code":2104,
                "parent_code":21,
                "name":"抚顺市",
                "level":2
                },
                {
                "full_pinyin":"fuxinshi",
                "id":6851,
                "code":2109,
                "parent_code":21,
                "name":"阜新市",
                "level":2
                },
                {
                "full_pinyin":"fuyangshi",
                "id":15194,
                "code":3412,
                "parent_code":34,
                "name":"阜阳市",
                "level":2
                },
                {
                "full_pinyin":"fuzhoushi",
                "id":18829,
                "code":3610,
                "parent_code":36,
                "name":"抚州市",
                "level":2
                },
                {
                "full_pinyin":"fuzhoushi",
                "id":16069,
                "code":3501,
                "parent_code":35,
                "name":"福州市",
                "level":2
                }
            ]},{
            name: 'G',
            cities:[
                {
                "full_pinyin":"gannanzhou",
                "id":45174,
                "code":6230,
                "parent_code":62,
                "name":"甘南州",
                "level":2
                },
                {
                "full_pinyin":"ganzhoushi",
                "id":17999,
                "code":3607,
                "parent_code":36,
                "name":"赣州市",
                "level":2
                },
                {
                "full_pinyin":"ganzicangzuzizhizhou",
                "id":36926,
                "code":5133,
                "parent_code":51,
                "name":"甘孜藏族自治州",
                "level":2
                },
                {
                "full_pinyin":"guanganshi",
                "id":35625,
                "code":5116,
                "parent_code":51,
                "name":"广安市",
                "level":2
                },
                {
                "full_pinyin":"guangyuanshi",
                "id":34120,
                "code":5108,
                "parent_code":51,
                "name":"广元市",
                "level":2
                },
                {
                "full_pinyin":"guangzhoushi",
                "id":28241,
                "code":4401,
                "parent_code":44,
                "name":"广州市",
                "level":2
                },
                {
                "full_pinyin":"guigangshi",
                "id":30834,
                "code":4508,
                "parent_code":45,
                "name":"贵港市",
                "level":2
                },
                {
                "full_pinyin":"guilinshi",
                "id":30448,
                "code":4503,
                "parent_code":45,
                "name":"桂林市",
                "level":2
                },
                {
                "full_pinyin":"guiyangshi",
                "id":37907,
                "code":5201,
                "parent_code":52,
                "name":"贵阳市",
                "level":2
                },
                {
                "full_pinyin":"guoluozhou",
                "id":45597,
                "code":6326,
                "parent_code":63,
                "name":"果洛州",
                "level":2
                },
                {
                "full_pinyin":"guyuanshi",
                "id":45926,
                "code":6404,
                "parent_code":64,
                "name":"固原市",
                "level":2
                }
            ]},{
            name: 'H',
            cities:[
                {
                "full_pinyin":"haerbinshi",
                "id":8559,
                "code":2301,
                "parent_code":23,
                "name":"哈尔滨市",
                "level":2
                },
                {
                "full_pinyin":"haibeizhou",
                "id":45471,
                "code":6322,
                "parent_code":63,
                "name":"海北州",
                "level":2
                },
                {
                "full_pinyin":"haidongdiqu",
                "id":45368,
                "code":6321,
                "parent_code":63,
                "name":"海东地区",
                "level":2
                },
                {
                "full_pinyin":"haikoushi",
                "id":31564,
                "code":4601,
                "parent_code":46,
                "name":"海口市",
                "level":2
                },
                {
                "full_pinyin":"hainanzhou",
                "id":45548,
                "code":6325,
                "parent_code":63,
                "name":"海南州",
                "level":2
                },
                {
                "full_pinyin":"haixizhou",
                "id":45701,
                "code":6328,
                "parent_code":63,
                "name":"海西州",
                "level":2
                },
                {
                "full_pinyin":"hamidiqu",
                "id":46197,
                "code":6522,
                "parent_code":65,
                "name":"哈密地区",
                "level":2
                },
                {
                "full_pinyin":"handanshi",
                "id":1291,
                "code":1304,
                "parent_code":13,
                "name":"邯郸市",
                "level":2
                },
                {
                "full_pinyin":"hangzhoushi",
                "id":12597,
                "code":3301,
                "parent_code":33,
                "name":"杭州市",
                "level":2
                },
                {
                "full_pinyin":"hanzhongshi",
                "id":42888,
                "code":6107,
                "parent_code":61,
                "name":"汉中市",
                "level":2
                },
                {
                "full_pinyin":"hebishi",
                "id":22206,
                "code":4106,
                "parent_code":41,
                "name":"鹤壁市",
                "level":2
                },
                {
                "full_pinyin":"hechishi",
                "id":31249,
                "code":4512,
                "parent_code":45,
                "name":"河池市",
                "level":2
                },
                {
                "full_pinyin":"hefeishi",
                "id":14235,
                "code":3401,
                "parent_code":34,
                "name":"合肥市",
                "level":2
                },
                {
                "full_pinyin":"hegangshi",
                "id":9222,
                "code":2304,
                "parent_code":23,
                "name":"鹤岗市",
                "level":2
                },
                {
                "full_pinyin":"heiheshi",
                "id":10084,
                "code":2311,
                "parent_code":23,
                "name":"黑河市",
                "level":2
                },
                {
                "full_pinyin":"hengshuishi",
                "id":2968,
                "code":1311,
                "parent_code":13,
                "name":"衡水市",
                "level":2
                },
                {
                "full_pinyin":"hengyangshi",
                "id":26001,
                "code":4304,
                "parent_code":43,
                "name":"衡阳市",
                "level":2
                },
                {
                "full_pinyin":"hetiandiqu",
                "id":46957,
                "code":6532,
                "parent_code":65,
                "name":"和田地区",
                "level":2
                },
                {
                "full_pinyin":"heyuanshi",
                "id":29568,
                "code":4416,
                "parent_code":44,
                "name":"河源市",
                "level":2
                },
                {
                "full_pinyin":"hezeshi",
                "id":21218,
                "code":3717,
                "parent_code":37,
                "name":"菏泽市",
                "level":2
                },
                {
                "full_pinyin":"hezhoushi",
                "id":31184,
                "code":4511,
                "parent_code":45,
                "name":"贺州市",
                "level":2
                },
                {
                "full_pinyin":"honghezhou",
                "id":40555,
                "code":5325,
                "parent_code":53,
                "name":"红河州",
                "level":2
                },
                {
                "full_pinyin":"huaianshi",
                "id":11786,
                "code":3208,
                "parent_code":32,
                "name":"淮安市",
                "level":2
                },
                {
                "full_pinyin":"huaibeishi",
                "id":14612,
                "code":3406,
                "parent_code":34,
                "name":"淮北市",
                "level":2
                },
                {
                "full_pinyin":"huaihuashi",
                "id":27650,
                "code":4312,
                "parent_code":43,
                "name":"怀化市",
                "level":2
                },
                {
                "full_pinyin":"huainanshi",
                "id":14500,
                "code":3404,
                "parent_code":34,
                "name":"淮南市",
                "level":2
                },
                {
                "full_pinyin":"huanggangshi",
                "id":25086,
                "code":4211,
                "parent_code":42,
                "name":"黄冈市",
                "level":2
                },
                {
                "full_pinyin":"huangnanzhou",
                "id":45510,
                "code":6323,
                "parent_code":63,
                "name":"黄南州",
                "level":2
                },
                {
                "full_pinyin":"huangshanshi",
                "id":14887,
                "code":3410,
                "parent_code":34,
                "name":"黄山市",
                "level":2
                },
                {
                "full_pinyin":"huangshishi",
                "id":24224,
                "code":4202,
                "parent_code":42,
                "name":"黄石市",
                "level":2
                },
                {
                "full_pinyin":"huhehaoteshi",
                "id":4671,
                "code":1501,
                "parent_code":15,
                "name":"呼和浩特市",
                "level":2
                },
                {
                "full_pinyin":"huizhoushi",
                "id":29282,
                "code":4413,
                "parent_code":44,
                "name":"惠州市",
                "level":2
                },
                {
                "full_pinyin":"huludaoshi",
                "id":7391,
                "code":2114,
                "parent_code":21,
                "name":"葫芦岛市",
                "level":2
                },
                {
                "full_pinyin":"hulunbeiershi",
                "id":5236,
                "code":1507,
                "parent_code":15,
                "name":"呼伦贝尔市",
                "level":2
                },
                {
                "full_pinyin":"huzhoushi",
                "id":13364,
                "code":3305,
                "parent_code":33,
                "name":"湖州市",
                "level":2
                }
            ]},{
            name: 'J',
            cities:[
                {
                "full_pinyin":"jiamusishi",
                "id":9785,
                "code":2308,
                "parent_code":23,
                "name":"佳木斯市",
                "level":2
                },
                {
                "full_pinyin":"jiangmenshi",
                "id":28785,
                "code":4407,
                "parent_code":44,
                "name":"江门市",
                "level":2
                },
                {
                "full_pinyin":"jianshi",
                "id":18330,
                "code":3608,
                "parent_code":36,
                "name":"吉安市",
                "level":2
                },
                {
                "full_pinyin":"jiaozuoshi",
                "id":22423,
                "code":4108,
                "parent_code":41,
                "name":"焦作市",
                "level":2
                },
                {
                "full_pinyin":"jiaxingshi",
                "id":13280,
                "code":3304,
                "parent_code":33,
                "name":"嘉兴市",
                "level":2
                },
                {
                "full_pinyin":"jiayuguanshi",
                "id":43904,
                "code":6202,
                "parent_code":62,
                "name":"嘉峪关市",
                "level":2
                },
                {
                "full_pinyin":"jieyangshi",
                "id":29977,
                "code":4452,
                "parent_code":44,
                "name":"揭阳市",
                "level":2
                },
                {
                "full_pinyin":"jilinshi",
                "id":7706,
                "code":2202,
                "parent_code":22,
                "name":"吉林市",
                "level":2
                },
                {
                "full_pinyin":"jinanshi",
                "id":19281,
                "code":3701,
                "parent_code":37,
                "name":"济南市",
                "level":2
                },
                {
                "full_pinyin":"jinchangshi",
                "id":43914,
                "code":6203,
                "parent_code":62,
                "name":"金昌市",
                "level":2
                },
                {
                "full_pinyin":"jinchengshi",
                "id":3597,
                "code":1405,
                "parent_code":14,
                "name":"晋城市",
                "level":2
                },
                {
                "full_pinyin":"jingdezhenshi",
                "id":17508,
                "code":3602,
                "parent_code":36,
                "name":"景德镇市",
                "level":2
                },
                {
                "full_pinyin":"jingmenshi",
                "id":24737,
                "code":4208,
                "parent_code":42,
                "name":"荆门市",
                "level":2
                },
                {
                "full_pinyin":"jingzhoushi",
                "id":24949,
                "code":4210,
                "parent_code":42,
                "name":"荆州市",
                "level":2
                },
                {
                "full_pinyin":"jinhuashi",
                "id":13564,
                "code":3307,
                "parent_code":33,
                "name":"金华市",
                "level":2
                },
                {
                "full_pinyin":"jiningshi",
                "id":20216,
                "code":3708,
                "parent_code":37,
                "name":"济宁市",
                "level":2
                },
                {
                "full_pinyin":"jinzhongshi",
                "id":3776,
                "code":1407,
                "parent_code":14,
                "name":"晋中市",
                "level":2
                },
                {
                "full_pinyin":"jinzhoushi",
                "id":6643,
                "code":2107,
                "parent_code":21,
                "name":"锦州市",
                "level":2
                },
                {
                "full_pinyin":"jiujiangshi",
                "id":17651,
                "code":3604,
                "parent_code":36,
                "name":"九江市",
                "level":2
                },
                {
                "full_pinyin":"jiuquanshi",
                "id":44477,
                "code":6209,
                "parent_code":62,
                "name":"酒泉市",
                "level":2
                },
                {
                "full_pinyin":"jixishi",
                "id":9117,
                "code":2303,
                "parent_code":23,
                "name":"鸡西市",
                "level":2
                }
            ]},{
            name: 'K',
            cities:[
                {
                "full_pinyin":"kaifengshi",
                "id":21575,
                "code":4102,
                "parent_code":41,
                "name":"开封市",
                "level":2
                },
                {
                "full_pinyin":"kashidiqu",
                "id":46747,
                "code":6531,
                "parent_code":65,
                "name":"喀什地区",
                "level":2
                },
                {
                "full_pinyin":"kelamayishi",
                "id":46138,
                "code":6502,
                "parent_code":65,
                "name":"克拉玛依市",
                "level":2
                },
                {
                "full_pinyin":"kezhou",
                "id":46688,
                "code":6530,
                "parent_code":65,
                "name":"克州",
                "level":2
                },
                {
                "full_pinyin":"kunmingshi",
                "id":39557,
                "code":5301,
                "parent_code":53,
                "name":"昆明市",
                "level":2
                }
            ]},{
            name: 'L',
            cities:[
                 {
                "full_pinyin":"laibinshi",
                "id":31401,
                "code":4513,
                "parent_code":45,
                "name":"来宾市",
                "level":2
                },
                {
                "full_pinyin":"laiwushi",
                "id":20618,
                "code":3712,
                "parent_code":37,
                "name":"莱芜市",
                "level":2
                },
                {
                "full_pinyin":"langfangshi",
                "id":2849,
                "code":1310,
                "parent_code":13,
                "name":"廊坊市",
                "level":2
                },
                {
                "full_pinyin":"lanzhoushi",
                "id":43777,
                "code":6201,
                "parent_code":62,
                "name":"兰州市",
                "level":2
                },
                {
                "full_pinyin":"lasashi",
                "id":41104,
                "code":5401,
                "parent_code":54,
                "name":"拉萨市",
                "level":2
                },
                {
                "full_pinyin":"leshanshi",
                "id":34628,
                "code":5111,
                "parent_code":51,
                "name":"乐山市",
                "level":2
                },
                {
                "full_pinyin":"liangshanzhou",
                "id":37270,
                "code":5134,
                "parent_code":51,
                "name":"凉山州",
                "level":2
                },
                {
                "full_pinyin":"lianyungangshi",
                "id":11663,
                "code":3207,
                "parent_code":32,
                "name":"连云港市",
                "level":2
                },
                {
                "full_pinyin":"liaochengshi",
                "id":20981,
                "code":3715,
                "parent_code":37,
                "name":"聊城市",
                "level":2
                },
                {
                "full_pinyin":"liaoyangshi",
                "id":6955,
                "code":2110,
                "parent_code":21,
                "name":"辽阳市",
                "level":2
                },
                {
                "full_pinyin":"liaoyuanshi",
                "id":7986,
                "code":2204,
                "parent_code":22,
                "name":"辽源市",
                "level":2
                },
                {
                "full_pinyin":"lijiangshi",
                "id":40160,
                "code":5307,
                "parent_code":53,
                "name":"丽江市",
                "level":2
                },
                {
                "full_pinyin":"lincangshi",
                "id":40348,
                "code":5309,
                "parent_code":53,
                "name":"临沧市",
                "level":2
                },
                {
                "full_pinyin":"linfenshi",
                "id":4304,
                "code":1410,
                "parent_code":14,
                "name":"临汾市",
                "level":2
                },
                {
                "full_pinyin":"linxiazhou",
                "id":45035,
                "code":6229,
                "parent_code":62,
                "name":"临夏州",
                "level":2
                },
                {
                "full_pinyin":"linyishi",
                "id":20642,
                "code":3713,
                "parent_code":37,
                "name":"临沂市",
                "level":2
                },
                {
                "full_pinyin":"linzhidiqu",
                "id":41814,
                "code":5426,
                "parent_code":54,
                "name":"林芝地区",
                "level":2
                },
                {
                "full_pinyin":"lishuishi",
                "id":14033,
                "code":3311,
                "parent_code":33,
                "name":"丽水市",
                "level":2
                },
                {
                "full_pinyin":"liuanshi",
                "id":15586,
                "code":3415,
                "parent_code":34,
                "name":"六安市",
                "level":2
                },
                {
                "full_pinyin":"liupanshuishi",
                "id":38042,
                "code":5202,
                "parent_code":52,
                "name":"六盘水市",
                "level":2
                },
                {
                "full_pinyin":"liuzhoushi",
                "id":30319,
                "code":4502,
                "parent_code":45,
                "name":"柳州市",
                "level":2
                },
                {
                "full_pinyin":"longnanshi",
                "id":44829,
                "code":6212,
                "parent_code":62,
                "name":"陇南市",
                "level":2
                },
                {
                "full_pinyin":"longyanshi",
                "id":17077,
                "code":3508,
                "parent_code":35,
                "name":"龙岩市",
                "level":2
                },
                {
                "full_pinyin":"loudishi",
                "id":27963,
                "code":4313,
                "parent_code":43,
                "name":"娄底市",
                "level":2
                },
                {
                "full_pinyin":"luoheshi",
                "id":22762,
                "code":4111,
                "parent_code":41,
                "name":"漯河市",
                "level":2
                },
                {
                "full_pinyin":"luoyangshi",
                "id":21711,
                "code":4103,
                "parent_code":41,
                "name":"洛阳市",
                "level":2
                },
                {
                "full_pinyin":"luzhoushi",
                "id":33528,
                "code":5105,
                "parent_code":51,
                "name":"泸州市",
                "level":2
                },
                {
                "full_pinyin":"lvliangshi",
                "id":4494,
                "code":1411,
                "parent_code":14,
                "name":"吕梁市",
                "level":2
                }
            ]},{
            name: 'M',
            cities:[
                {
                "full_pinyin":"maanshanshi",
                "id":14575,
                "code":3405,
                "parent_code":34,
                "name":"马鞍山市",
                "level":2
                },
                {
                "full_pinyin":"maomingshi",
                "id":29026,
                "code":4409,
                "parent_code":44,
                "name":"茂名市",
                "level":2
                },
                {
                "full_pinyin":"meishanshi",
                "id":35288,
                "code":5114,
                "parent_code":51,
                "name":"眉山市",
                "level":2
                },
                {
                "full_pinyin":"meizhoushi",
                "id":29371,
                "code":4414,
                "parent_code":44,
                "name":"梅州市",
                "level":2
                },
                {
                "full_pinyin":"mianyangshi",
                "id":33817,
                "code":5107,
                "parent_code":51,
                "name":"绵阳市",
                "level":2
                },
                {
                "full_pinyin":"mudanjiangshi",
                "id":9981,
                "code":2310,
                "parent_code":23,
                "name":"牡丹江市",
                "level":2
                }
            ]},{
            name: 'N',
            cities:[
                {
                "full_pinyin":"nanchangshi",
                "id":17360,
                "code":3601,
                "parent_code":36,
                "name":"南昌市",
                "level":2
                },
                {
                "full_pinyin":"nanchongshi",
                "id":34859,
                "code":5113,
                "parent_code":51,
                "name":"南充市",
                "level":2
                },
                {
                "full_pinyin":"nanjingshi",
                "id":10809,
                "code":3201,
                "parent_code":32,
                "name":"南京市",
                "level":2
                },
                {
                "full_pinyin":"nanningshi",
                "id":30165,
                "code":4501,
                "parent_code":45,
                "name":"南宁市",
                "level":2
                },
                {
                "full_pinyin":"nanpingshi",
                "id":16924,
                "code":3507,
                "parent_code":35,
                "name":"南平市",
                "level":2
                },
                {
                "full_pinyin":"nantongshi",
                "id":11482,
                "code":3206,
                "parent_code":32,
                "name":"南通市",
                "level":2
                },
                {
                "full_pinyin":"nanyangshi",
                "id":22910,
                "code":4113,
                "parent_code":41,
                "name":"南阳市",
                "level":2
                },
                {
                "full_pinyin":"naqudiqu",
                "id":41645,
                "code":5424,
                "parent_code":54,
                "name":"那曲地区",
                "level":2
                },
                {
                "full_pinyin":"neijiangshi",
                "id":34501,
                "code":5110,
                "parent_code":51,
                "name":"内江市",
                "level":2
                },
                {
                "full_pinyin":"ningboshi",
                "id":12813,
                "code":3302,
                "parent_code":33,
                "name":"宁波市",
                "level":2
                },
                {
                "full_pinyin":"ningdeshi　",
                "id":17219,
                "code":3509,
                "parent_code":35,
                "name":"宁德市　",
                "level":2
                },
                {
                "full_pinyin":"nujiangzhou",
                "id":41036,
                "code":5333,
                "parent_code":53,
                "name":"怒江州",
                "level":2
                }
            ]},{
            name: 'P',
            cities:[
                {
                "full_pinyin":"panjinshi",
                "id":7024,
                "code":2111,
                "parent_code":21,
                "name":"盘锦市",
                "level":2
                },
                {
                "full_pinyin":"panzhihuashi",
                "id":33460,
                "code":5104,
                "parent_code":51,
                "name":"攀枝花市",
                "level":2
                },
                {
                "full_pinyin":"pingdingshanshi",
                "id":21913,
                "code":4104,
                "parent_code":41,
                "name":"平顶山市",
                "level":2
                },
                {
                "full_pinyin":"pingliangshi",
                "id":44352,
                "code":6208,
                "parent_code":62,
                "name":"平凉市",
                "level":2
                },
                {
                "full_pinyin":"pingxiangshi",
                "id":17589,
                "code":3603,
                "parent_code":36,
                "name":"萍乡市",
                "level":2
                },
                {
                "full_pinyin":"putianshi",
                "id":16348,
                "code":3503,
                "parent_code":35,
                "name":"莆田市",
                "level":2
                },
                {
                "full_pinyin":"puyangshi",
                "id":22558,
                "code":4109,
                "parent_code":41,
                "name":"濮阳市",
                "level":2
                }
            ]},{
            name: 'Q',
            cities:[
                {
                "full_pinyin":"qiandongnanmiaozudongzuzizhizhou",
                "id":39075,
                "code":5226,
                "parent_code":52,
                "name":"黔东南苗族侗族自治州",
                "level":2
                },
                {
                "full_pinyin":"qiannanbuyizumiaozuzizhizhou",
                "id":39302,
                "code":5227,
                "parent_code":52,
                "name":"黔南布依族苗族自治州",
                "level":2
                },
                {
                "full_pinyin":"qianxinanzhou",
                "id":38677,
                "code":5223,
                "parent_code":52,
                "name":"黔西南州",
                "level":2
                },
                {
                "full_pinyin":"qingdaoshi",
                "id":19421,
                "code":3702,
                "parent_code":37,
                "name":"青岛市",
                "level":2
                },
                {
                "full_pinyin":"qingyangshi",
                "id":44569,
                "code":6210,
                "parent_code":62,
                "name":"庆阳市",
                "level":2
                },
                {
                "full_pinyin":"qingyuanshi",
                "id":29755,
                "code":4418,
                "parent_code":44,
                "name":"清远市",
                "level":2
                },
                {
                "full_pinyin":"qinhuangdaoshi",
                "id":1188,
                "code":1303,
                "parent_code":13,
                "name":"秦皇岛市",
                "level":2
                },
                {
                "full_pinyin":"qinzhoushi",
                "id":30762,
                "code":4507,
                "parent_code":45,
                "name":"钦州市",
                "level":2
                },
                {
                "full_pinyin":"qiqihaershi",
                "id":8884,
                "code":2302,
                "parent_code":23,
                "name":"齐齐哈尔市",
                "level":2
                },
                {
                "full_pinyin":"qitaiheshi",
                "id":9930,
                "code":2309,
                "parent_code":23,
                "name":"七台河市",
                "level":2
                },
                {
                "full_pinyin":"quanzhoushi",
                "id":16572,
                "code":3505,
                "parent_code":35,
                "name":"泉州市",
                "level":2
                },
                {
                "full_pinyin":"qujingshi",
                "id":39710,
                "code":5303,
                "parent_code":53,
                "name":"曲靖市",
                "level":2
                },
                {
                "full_pinyin":"quzhoushi",
                "id":13726,
                "code":3308,
                "parent_code":33,
                "name":"衢州市",
                "level":2
                }
            ]},{
            name: 'R',
            cities:[
                {
                "full_pinyin":"rikazediqu",
                "id":41423,
                "code":5423,
                "parent_code":54,
                "name":"日喀则地区",
                "level":2
                },
                {
                "full_pinyin":"rizhaoshi",
                "id":20558,
                "code":3711,
                "parent_code":37,
                "name":"日照市",
                "level":2
                }
            ]},{
            name: 'S',
            cities:[
                {
                "full_pinyin":"sanmenxiashi",
                "id":22824,
                "code":4112,
                "parent_code":41,
                "name":"三门峡市",
                "level":2
                },
                {
                "full_pinyin":"sanmingshi",
                "id":16412,
                "code":3504,
                "parent_code":35,
                "name":"三明市",
                "level":2
                },
                {
                "full_pinyin":"sanyashi",
                "id":31618,
                "code":4602,
                "parent_code":46,
                "name":"三亚市",
                "level":2
                },
                {
                "full_pinyin":"shamenshi",
                "id":16278,
                "code":3502,
                "parent_code":35,
                "name":"厦门市",
                "level":2
                },
                {
                "full_pinyin":"shangluoshi",
                "id":43592,
                "code":6110,
                "parent_code":61,
                "name":"商洛市",
                "level":2
                },
                {
                "full_pinyin":"shangqiushi",
                "id":23170,
                "code":4114,
                "parent_code":41,
                "name":"商丘市",
                "level":2
                },
                {
                "full_pinyin":"shangraoshi",
                "id":19024,
                "code":3611,
                "parent_code":36,
                "name":"上饶市",
                "level":2
                },
                {
                "full_pinyin":"shannandiqu",
                "id":41328,
                "code":5422,
                "parent_code":54,
                "name":"山南地区",
                "level":2
                },
                {
                "full_pinyin":"shantoushi",
                "id":28659,
                "code":4405,
                "parent_code":44,
                "name":"汕头市",
                "level":2
                },
                {
                "full_pinyin":"shanweishi",
                "id":29498,
                "code":4415,
                "parent_code":44,
                "name":"汕尾市",
                "level":2
                },
                {
                "full_pinyin":"shaoguanshi",
                "id":28421,
                "code":4402,
                "parent_code":44,
                "name":"韶关市",
                "level":2
                },
                {
                "full_pinyin":"shaoxingshi",
                "id":13437,
                "code":3306,
                "parent_code":33,
                "name":"绍兴市",
                "level":2
                },
                {
                "full_pinyin":"shaoyangshi",
                "id":26242,
                "code":4305,
                "parent_code":43,
                "name":"邵阳市",
                "level":2
                },
                {
                "full_pinyin":"shengshuxunishi",
                "id":31633,
                "code":4690,
                "parent_code":46,
                "name":"省属虚拟市",
                "level":2
                },
                {
                "full_pinyin":"shengzhixiaxingzhengdanwei",
                "id":47450,
                "code":6590,
                "parent_code":65,
                "name":"省直辖行政单位",
                "level":2
                },
                {
                "full_pinyin":"shengzhixiaxingzhengdanwei",
                "id":25487,
                "code":4290,
                "parent_code":42,
                "name":"省直辖行政单位",
                "level":2
                },
                {
                "full_pinyin":"shenyangshi",
                "id":5828,
                "code":2101,
                "parent_code":21,
                "name":"沈阳市",
                "level":2
                },
                {
                "full_pinyin":"shenzhenshi",
                "id":28558,
                "code":4403,
                "parent_code":44,
                "name":"深圳市",
                "level":2
                },
                {
                "full_pinyin":"shijiazhuangshi",
                "id":637,
                "code":1301,
                "parent_code":13,
                "name":"石家庄市",
                "level":2
                },
                {
                "full_pinyin":"shixiaqu",
                "id":2,
                "code":1101,
                "parent_code":11,
                "name":"市辖区",
                "level":2
                },
                {
                "full_pinyin":"shixiaqu",
                "id":10544,
                "code":3101,
                "parent_code":31,
                "name":"市辖区",
                "level":2
                },
                {
                "full_pinyin":"shixiaqu",
                "id":339,
                "code":1201,
                "parent_code":12,
                "name":"市辖区",
                "level":2
                },
                {
                "full_pinyin":"shixiaqu",
                "id":31930,
                "code":5001,
                "parent_code":50,
                "name":"市辖区",
                "level":2
                },
                {
                "full_pinyin":"shixiaxian",
                "id":569,
                "code":1202,
                "parent_code":12,
                "name":"市辖县",
                "level":2
                },
                {
                "full_pinyin":"shiyanshi",
                "id":24291,
                "code":4203,
                "parent_code":42,
                "name":"十堰市",
                "level":2
                },
                {
                "full_pinyin":"shizuishanshi",
                "id":45825,
                "code":6402,
                "parent_code":64,
                "name":"石嘴山市",
                "level":2
                },
                {
                "full_pinyin":"shuangyashanshi",
                "id":9296,
                "code":2305,
                "parent_code":23,
                "name":"双鸭山市",
                "level":2
                },
                {
                "full_pinyin":"shuozhoushi",
                "id":3690,
                "code":1406,
                "parent_code":14,
                "name":"朔州市",
                "level":2
                },
                {
                "full_pinyin":"simaoshi",
                "id":40230,
                "code":5308,
                "parent_code":53,
                "name":"思茅市",
                "level":2
                },
                {
                "full_pinyin":"sipingshi",
                "id":7868,
                "code":2203,
                "parent_code":22,
                "name":"四平市",
                "level":2
                },
                {
                "full_pinyin":"songyuanshi",
                "id":8216,
                "code":2207,
                "parent_code":22,
                "name":"松原市",
                "level":2
                },
                {
                "full_pinyin":"suihuashi",
                "id":10252,
                "code":2312,
                "parent_code":23,
                "name":"绥化市",
                "level":2
                },
                {
                "full_pinyin":"suiningshi",
                "id":34376,
                "code":5109,
                "parent_code":51,
                "name":"遂宁市",
                "level":2
                },
                {
                "full_pinyin":"suizhoushi",
                "id":25335,
                "code":4213,
                "parent_code":42,
                "name":"随州市",
                "level":2
                },
                {
                "full_pinyin":"suqianshi",
                "id":12475,
                "code":3213,
                "parent_code":32,
                "name":"宿迁市",
                "level":2
                },
                {
                "full_pinyin":"suzhoushi",
                "id":15378,
                "code":3413,
                "parent_code":34,
                "name":"宿州市",
                "level":2
                },
                {
                "full_pinyin":"suzhoushi",
                "id":11348,
                "code":3205,
                "parent_code":32,
                "name":"苏州市",
                "level":2
                }
            ]},{
            name: 'T',
            cities:[
                {
                "full_pinyin":"tachengdiqu",
                "id":47241,
                "code":6542,
                "parent_code":65,
                "name":"塔城地区",
                "level":2
                },
                {
                "full_pinyin":"taianshi",
                "id":20386,
                "code":3709,
                "parent_code":37,
                "name":"泰安市",
                "level":2
                },
                {
                "full_pinyin":"taiyuanshi",
                "id":3103,
                "code":1401,
                "parent_code":14,
                "name":"太原市",
                "level":2
                },
                {
                "full_pinyin":"taizhoushi",
                "id":12343,
                "code":3212,
                "parent_code":32,
                "name":"泰州市",
                "level":2
                },
                {
                "full_pinyin":"taizhoushi",
                "id":13890,
                "code":3310,
                "parent_code":33,
                "name":"台州市",
                "level":2
                },
                {
                "full_pinyin":"tangshanshi",
                "id":936,
                "code":1302,
                "parent_code":13,
                "name":"唐山市",
                "level":2
                },
                {
                "full_pinyin":"tianshuishi",
                "id":44022,
                "code":6205,
                "parent_code":62,
                "name":"天水市",
                "level":2
                },
                {
                "full_pinyin":"tielingshi",
                "id":7088,
                "code":2112,
                "parent_code":21,
                "name":"铁岭市",
                "level":2
                },
                {
                "full_pinyin":"tongchuanshi",
                "id":42069,
                "code":6102,
                "parent_code":61,
                "name":"铜川市",
                "level":2
                },
                {
                "full_pinyin":"tonghuashi",
                "id":8037,
                "code":2205,
                "parent_code":22,
                "name":"通化市",
                "level":2
                },
                {
                "full_pinyin":"tongliaoshi",
                "id":5029,
                "code":1505,
                "parent_code":15,
                "name":"通辽市",
                "level":2
                },
                {
                "full_pinyin":"tonglingshi",
                "id":14653,
                "code":3407,
                "parent_code":34,
                "name":"铜陵市",
                "level":2
                },
                {
                "full_pinyin":"tongrendiqu",
                "id":38497,
                "code":5222,
                "parent_code":52,
                "name":"铜仁地区",
                "level":2
                },
                {
                "full_pinyin":"tulufandiqu",
                "id":46162,
                "code":6521,
                "parent_code":65,
                "name":"吐鲁番地区",
                "level":2
                }
            ]},{
            name: 'W',
            cities:[
                {
                "full_pinyin":"weifangshi",
                "id":20012,
                "code":3707,
                "parent_code":37,
                "name":"潍坊市",
                "level":2
                },
                {
                "full_pinyin":"weihaishi",
                "id":20480,
                "code":3710,
                "parent_code":37,
                "name":"威海市",
                "level":2
                },
                {
                "full_pinyin":"weinanshi",
                "id":42490,
                "code":6105,
                "parent_code":61,
                "name":"渭南市",
                "level":2
                },
                {
                "full_pinyin":"wenshanzhou",
                "id":40705,
                "code":5326,
                "parent_code":53,
                "name":"文山州",
                "level":2
                },
                {
                "full_pinyin":"wenzhoushi",
                "id":12974,
                "code":3303,
                "parent_code":33,
                "name":"温州市",
                "level":2
                },
                {
                "full_pinyin":"wuhaishi",
                "id":4849,
                "code":1503,
                "parent_code":15,
                "name":"乌海市",
                "level":2
                },
                {
                "full_pinyin":"wuhanshi",
                "id":24023,
                "code":4201,
                "parent_code":42,
                "name":"武汉市",
                "level":2
                },
                {
                "full_pinyin":"wuhushi",
                "id":14351,
                "code":3402,
                "parent_code":34,
                "name":"芜湖市",
                "level":2
                },
                {
                "full_pinyin":"wulanchabushi",
                "id":5505,
                "code":1509,
                "parent_code":15,
                "name":"乌兰察布市",
                "level":2
                },
                {
                "full_pinyin":"wulumuqishi",
                "id":46048,
                "code":6501,
                "parent_code":65,
                "name":"乌鲁木齐市",
                "level":2
                },
                {
                "full_pinyin":"wuweishi",
                "id":44154,
                "code":6206,
                "parent_code":62,
                "name":"武威市",
                "level":2
                },
                {
                "full_pinyin":"wuxishi",
                "id":10960,
                "code":3202,
                "parent_code":32,
                "name":"无锡市",
                "level":2
                },
                {
                "full_pinyin":"wuzhongshi",
                "id":45871,
                "code":6403,
                "parent_code":64,
                "name":"吴忠市",
                "level":2
                },
                {
                "full_pinyin":"wuzhoushi",
                "id":30613,
                "code":4504,
                "parent_code":45,
                "name":"梧州市",
                "level":2
                }
            ]},{
            name: 'X',
            cities:[
                {
                "full_pinyin":"xian",
                "id":10779,
                "code":3102,
                "parent_code":31,
                "name":"县",
                "level":2
                },
                {
                "full_pinyin":"xian",
                "id":300,
                "code":1102,
                "parent_code":11,
                "name":"县",
                "level":2
                },
                {
                "full_pinyin":"xian",
                "id":32380,
                "code":5002,
                "parent_code":50,
                "name":"县",
                "level":2
                },
                {
                "full_pinyin":"xiangfanshi",
                "id":24580,
                "code":4206,
                "parent_code":42,
                "name":"襄樊市",
                "level":2
                },
                {
                "full_pinyin":"xiangtanshi",
                "id":25912,
                "code":4303,
                "parent_code":43,
                "name":"湘潭市",
                "level":2
                },
                {
                "full_pinyin":"xiangxitujiazumiaozuzizhizhou",
                "id":28065,
                "code":4331,
                "parent_code":43,
                "name":"湘西土家族苗族自治州",
                "level":2
                },
                {
                "full_pinyin":"xianningshi",
                "id":25249,
                "code":4212,
                "parent_code":42,
                "name":"咸宁市",
                "level":2
                },
                {
                "full_pinyin":"xianshi",
                "id":41878,
                "code":6101,
                "parent_code":61,
                "name":"西安市",
                "level":2
                },
                {
                "full_pinyin":"xianyangshi",
                "id":42287,
                "code":6104,
                "parent_code":61,
                "name":"咸阳市",
                "level":2
                },
                {
                "full_pinyin":"xiaoganshi",
                "id":24816,
                "code":4209,
                "parent_code":42,
                "name":"孝感市",
                "level":2
                },
                {
                "full_pinyin":"xilinguolemeng",
                "id":5702,
                "code":1525,
                "parent_code":15,
                "name":"锡林郭勒盟",
                "level":2
                },
                {
                "full_pinyin":"xinganmeng",
                "id":5616,
                "code":1522,
                "parent_code":15,
                "name":"兴安盟",
                "level":2
                },
                {
                "full_pinyin":"xingtaishi",
                "id":1554,
                "code":1305,
                "parent_code":13,
                "name":"邢台市",
                "level":2
                },
                {
                "full_pinyin":"xiningshi",
                "id":45287,
                "code":6301,
                "parent_code":63,
                "name":"西宁市",
                "level":2
                },
                {
                "full_pinyin":"xinxiangshi",
                "id":22251,
                "code":4107,
                "parent_code":41,
                "name":"新乡市",
                "level":2
                },
                {
                "full_pinyin":"xinyangshi",
                "id":23372,
                "code":4115,
                "parent_code":41,
                "name":"信阳市",
                "level":2
                },
                {
                "full_pinyin":"xinyushi",
                "id":17894,
                "code":3605,
                "parent_code":36,
                "name":"新余市",
                "level":2
                },
                {
                "full_pinyin":"xinzhoushi",
                "id":4093,
                "code":1409,
                "parent_code":14,
                "name":"忻州市",
                "level":2
                },
                {
                "full_pinyin":"xishuangbannazhou",
                "id":40816,
                "code":5328,
                "parent_code":53,
                "name":"西双版纳州",
                "level":2
                },
                {
                "full_pinyin":"xuanchengshi",
                "id":15958,
                "code":3418,
                "parent_code":34,
                "name":"宣城市",
                "level":2
                },
                {
                "full_pinyin":"xuchangshi",
                "id":22655,
                "code":4110,
                "parent_code":41,
                "name":"许昌市",
                "level":2
                },
                {
                "full_pinyin":"xuzhoushi",
                "id":11067,
                "code":3203,
                "parent_code":32,
                "name":"徐州市",
                "level":2
                }
            ]},{
            name: 'Y',
            cities:[
                {
                "full_pinyin":"yaanshi",
                "id":36136,
                "code":5118,
                "parent_code":51,
                "name":"雅安市",
                "level":2
                },
                {
                "full_pinyin":"yananshi",
                "id":42703,
                "code":6106,
                "parent_code":61,
                "name":"延安市",
                "level":2
                },
                {
                "full_pinyin":"yanbianzhaoxianzuzizhizhou",
                "id":8445,
                "code":2224,
                "parent_code":22,
                "name":"延边朝鲜族自治州",
                "level":2
                },
                {
                "full_pinyin":"yanchengshi",
                "id":11947,
                "code":3209,
                "parent_code":32,
                "name":"盐城市",
                "level":2
                },
                {
                "full_pinyin":"yangjiangshi",
                "id":29679,
                "code":4417,
                "parent_code":44,
                "name":"阳江市",
                "level":2
                },
                {
                "full_pinyin":"yangquanshi",
                "id":3379,
                "code":1403,
                "parent_code":14,
                "name":"阳泉市",
                "level":2
                },
                {
                "full_pinyin":"yangzhoushi",
                "id":12135,
                "code":3210,
                "parent_code":32,
                "name":"扬州市",
                "level":2
                },
                {
                "full_pinyin":"yantaishi",
                "id":19846,
                "code":3706,
                "parent_code":37,
                "name":"烟台市",
                "level":2
                },
                {
                "full_pinyin":"yibinshi",
                "id":35427,
                "code":5115,
                "parent_code":51,
                "name":"宜宾市",
                "level":2
                },
                {
                "full_pinyin":"yichangshi",
                "id":24453,
                "code":4205,
                "parent_code":42,
                "name":"宜昌市",
                "level":2
                },
                {
                "full_pinyin":"yichunshi",
                "id":9553,
                "code":2307,
                "parent_code":23,
                "name":"伊春市",
                "level":2
                },
                {
                "full_pinyin":"yichunshi",
                "id":18598,
                "code":3609,
                "parent_code":36,
                "name":"宜春市",
                "level":2
                },
                {
                "full_pinyin":"yilizhou",
                "id":47069,
                "code":6540,
                "parent_code":65,
                "name":"伊犁州",
                "level":2
                },
                {
                "full_pinyin":"yinchuanshi",
                "id":45754,
                "code":6401,
                "parent_code":64,
                "name":"银川市",
                "level":2
                },
                {
                "full_pinyin":"yingkoushi",
                "id":6771,
                "code":2108,
                "parent_code":21,
                "name":"营口市",
                "level":2
                },
                {
                "full_pinyin":"yingtanshi",
                "id":17934,
                "code":3606,
                "parent_code":36,
                "name":"鹰潭市",
                "level":2
                },
                {
                "full_pinyin":"yiyangshi",
                "id":27038,
                "code":4309,
                "parent_code":43,
                "name":"益阳市",
                "level":2
                },
                {
                "full_pinyin":"yongzhoushi",
                "id":27418,
                "code":4311,
                "parent_code":43,
                "name":"永州市",
                "level":2
                },
                {
                "full_pinyin":"yueyangshi",
                "id":26485,
                "code":4306,
                "parent_code":43,
                "name":"岳阳市",
                "level":2
                },
                {
                "full_pinyin":"yulinshi",
                "id":43136,
                "code":6108,
                "parent_code":61,
                "name":"榆林市",
                "level":2
                },
                {
                "full_pinyin":"yulinshi",
                "id":30915,
                "code":4509,
                "parent_code":45,
                "name":"玉林市",
                "level":2
                },
                {
                "full_pinyin":"yunchengshi",
                "id":3925,
                "code":1408,
                "parent_code":14,
                "name":"运城市",
                "level":2
                },
                {
                "full_pinyin":"yunfushi",
                "id":30086,
                "code":4453,
                "parent_code":44,
                "name":"云浮市",
                "level":2
                },
                {
                "full_pinyin":"yushuzhou",
                "id":45648,
                "code":6327,
                "parent_code":63,
                "name":"玉树州",
                "level":2
                },
                {
                "full_pinyin":"yuxishi",
                "id":39836,
                "code":5304,
                "parent_code":53,
                "name":"玉溪市",
                "level":2
                }
            ]},{
            name: 'Z',
            cities:[
                {
                "full_pinyin":"zaozhuangshi",
                "id":19724,
                "code":3704,
                "parent_code":37,
                "name":"枣庄市",
                "level":2
                },
                {
                "full_pinyin":"zhangjiajieshi",
                "id":26925,
                "code":4308,
                "parent_code":43,
                "name":"张家界市",
                "level":2
                },
                {
                "full_pinyin":"zhangjiakoushi",
                "id":2142,
                "code":1307,
                "parent_code":13,
                "name":"张家口市",
                "level":2
                },
                {
                "full_pinyin":"zhangyeshi",
                "id":44265,
                "code":6207,
                "parent_code":62,
                "name":"张掖市",
                "level":2
                },
                {
                "full_pinyin":"zhangzhoushi",
                "id":16754,
                "code":3506,
                "parent_code":35,
                "name":"漳州市",
                "level":2
                },
                {
                "full_pinyin":"zhanjiangshi",
                "id":28880,
                "code":4408,
                "parent_code":44,
                "name":"湛江市",
                "level":2
                },
                {
                "full_pinyin":"zhaoqingshi",
                "id":29159,
                "code":4412,
                "parent_code":44,
                "name":"肇庆市",
                "level":2
                },
                {
                "full_pinyin":"zhaotongshi",
                "id":40004,
                "code":5306,
                "parent_code":53,
                "name":"昭通市",
                "level":2
                },
                {
                "full_pinyin":"zhaoyangshi",
                "id":7208,
                "code":2113,
                "parent_code":21,
                "name":"朝阳市",
                "level":2
                },
                {
                "full_pinyin":"zhengzhoushi",
                "id":21388,
                "code":4101,
                "parent_code":41,
                "name":"郑州市",
                "level":2
                },
                {
                "full_pinyin":"zhenjiangshi",
                "id":12249,
                "code":3211,
                "parent_code":32,
                "name":"镇江市",
                "level":2
                },
                {
                "full_pinyin":"zhongshanshi",
                "id":29890,
                "code":4420,
                "parent_code":44,
                "name":"中山市",
                "level":2
                },
                {
                "full_pinyin":"zhongweishi",
                "id":45999,
                "code":6405,
                "parent_code":64,
                "name":"中卫市",
                "level":2
                },
                {
                "full_pinyin":"zhoukoushi",
                "id":23589,
                "code":4116,
                "parent_code":41,
                "name":"周口市",
                "level":2
                },
                {
                "full_pinyin":"zhoushanshi",
                "id":13840,
                "code":3309,
                "parent_code":33,
                "name":"舟山市",
                "level":2
                },
                {
                "full_pinyin":"zhuhaishi",
                "id":28626,
                "code":4404,
                "parent_code":44,
                "name":"珠海市",
                "level":2
                },
                {
                "full_pinyin":"zhumadianshi",
                "id":23818,
                "code":4117,
                "parent_code":41,
                "name":"驻马店市",
                "level":2
                },
                {
                "full_pinyin":"zhuzhoushi",
                "id":25758,
                "code":4302,
                "parent_code":43,
                "name":"株洲市",
                "level":2
                },
                {
                "full_pinyin":"ziboshi",
                "id":19608,
                "code":3703,
                "parent_code":37,
                "name":"淄博市",
                "level":2
                },
                {
                "full_pinyin":"zigongshi",
                "id":33344,
                "code":5103,
                "parent_code":51,
                "name":"自贡市",
                "level":2
                },
                {
                "full_pinyin":"ziyangshi",
                "id":36497,
                "code":5120,
                "parent_code":51,
                "name":"资阳市",
                "level":2
                },
                {
                "full_pinyin":"zunyishi",
                "id":38145,
                "code":5203,
                "parent_code":52,
                "name":"遵义市",
                "level":2
                }
            ]}
            ]
    });

    /* jshint +W075 */

angular.module('Orders', [])

    .controller('OrdersCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'TuanGou', 'IntentOrder', '$ionicLoading', '$ionicViewSwitcher', '$ionicHistory', '$state', function ($scope, $http, URLConfig, $stateParams, TuanGou, IntentOrder, $ionicLoading, $ionicViewSwitcher, $ionicHistory, $state) {

        if($stateParams.fromTab == 'true'){
            $scope.fromTab = true;
        }else{
            $scope.fromTab = false;
        }

        if($stateParams.isTab == 'true') {
            $scope.isTab = true;
        }else {
            $scope.isTab = false;
        }

        $scope.orders = [];
        $scope.pay_status = '';

        $scope.data = {
            showDelete: false,
            text:"编辑"
        };
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };

        $scope.goOrder = function (id) {
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('order', {'isTab':$scope.isTab,'id':id}, {reload: true});
        }

        $scope.edit = function() {
            $scope.data.showDelete = !$scope.data.showDelete;
            $scope.data.text=$scope.data.showDelete?'完成':'编辑';
        }

        $scope.onItemDelete = function(item) {
            $scope.Items.splice($scope.Items.indexOf(item), 1);
        };

        $scope.loadMore= function() {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            var user = JSON.parse(localStorage.getItem('USERS')) || [];
            var data = {
                'user_id': user.id,
                'm_status': ""
            }
            IntentOrder.all(data).then(function (response) {
               $scope.Items = response.data.data;
               $scope.getItem('');
               $ionicLoading.hide();
               $scope.$broadcast('scroll.refreshComplete');
            }, function (resp) {
               console.log(resp);
               $scope.$broadcast('scroll.refreshComplete');
               $ionicLoading.hide();
            });
        };
        $scope.loadMore();

        $scope.getItem = function(pay_status){
            $scope.orders = [];
            $scope.pay_status = pay_status;
            angular.forEach($scope.Items, function(value, key) {
                if(pay_status!=''){
                    if(pay_status == value.m_status){
                        $scope.orders.push(value);
                    }
                }else {
                    $scope.orders.push(value);
                }

            });
        }
    }]);

angular.module('Order', [])

    .controller('OrderCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'IntentOrder', '$ionicLoading', '$ionicViewSwitcher', '$ionicHistory', '$ionicPopup', function ($scope, $http, URLConfig, $stateParams, IntentOrder, $ionicLoading, $ionicViewSwitcher, $ionicHistory, $ionicPopup) {

        if($stateParams.isTab == 'true'){
            $scope.isTab = true;
        }else{
            $scope.isTab = false;
        }
        $scope.showPage = false;
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];

        $scope.code = $stateParams.id;
        $scope.loadMore = function () {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            IntentOrder.get($scope.code).then(function (response) {
               $scope.item = response.data.data;
               switch($scope.item.m_status){
                    case '0':
                        $scope.item.pay_status_name = "待处理";
                        break;
                    case '1':
                        $scope.item.pay_status_name = "待支付";
                        break;
                    case '2':
                        $scope.item.pay_status_name = "待安装";
                        break;
                    case '3':
                        $scope.item.pay_status_name = "待评价";
                        break;
                    case '4':
                        $scope.item.pay_status_name = "已评价";
                        break;
                    case '5':
                        $scope.item.pay_status_name = "纠纷单";
                        break;
               }
               $ionicLoading.hide();
               $scope.showPage = true;
               $scope.$broadcast('scroll.refreshComplete');
            }, function (resp) {
               console.log(resp);
               $ionicLoading.hide();
               $scope.$broadcast('scroll.refreshComplete');
            });
        };
        $scope.loadMore();

        $scope.cancelOrder = function() {
           var confirmPopup = $ionicPopup.confirm({
             title: '确认信息',
             template: '你确定要取消订单?',
             cancelText:'取消',
             okText: '确定'
           });
           confirmPopup.then(function(res) {
             if(res) {
               console.log('You are sure');
             } else {
               console.log('You are not sure');
             }
           });
        };

        $scope.pay = function () {
            var subject = $scope.item.name;
            var body = $scope.item.name;
            var price = "0.01";
            var out_trade_no = $scope.item.order_sn;
            var callbackUrl = "http://www.youjiacn.com:8000/index.php/home/order/pay";
            var successCallback = function(msg) {
                console.log("successCallback");
                if(typeof msg == "object"){
                    alert("success--->" + msg.resultStatus + " : "+msg.result + " : " + msg.memo);
                }else{
                    alert("success--->" + msg);
                }

            };
            var errorCallback = function(msg) {
                console.log("errorCallback");
                alert("error--->" + msg);
            };
            cordova.plugins.AlipayPlugin.alipay(out_trade_no, subject, body, price, successCallback, errorCallback, callbackUrl);
        }
        $scope.receive = function () {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            var data = {
                'user_id': $scope.user.id,
                'order_id': $scope.item.id
            }
            IntentOrder.receive(data).then(function (response) {
               $scope.Items = response.data.data;
               $ionicLoading.hide();
               $scope.loadMore();
            }, function (resp) {
               $ionicLoading.hide();
            });
        }

    }]);

angular.module('Comment', [])

    .controller('CommentCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'IntentOrder', '$ionicLoading', 'Comment', 'Upload', '$ionicPopup','$cordovaFileTransfer','$ionicHistory','$ionicActionSheet','Bids', function ($scope, $http, URLConfig, $stateParams, IntentOrder, $ionicLoading, Comment, Upload, $ionicPopup, $cordovaFileTransfer, $ionicHistory,$ionicActionSheet, Bids) {
        $scope.product_id = $stateParams.orderId;
        $scope.bid = $stateParams.bid;

        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
        function loadPage(){
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            var data = {
                'product_id':$scope.product_id,
                'biao_id':$scope.bid,
                'user_id':$scope.user.id
            }
            Bids.productDetail(data).then(function (response) {
                $scope.product = response.data.data;
                $ionicLoading.hide();
            }, function (resp) {
                console.log(resp);
            });
        }
        loadPage();
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
        $scope.Data = {
            'title':'',
            'content' : '',
            'point': 5,
            'user_id': $scope.user.id,
            'supplier_location_id': '',
            'deal_id': $scope.product_id,
            'supplier_id': '',
            'images': ''
        }

        $scope.images = [];
        $scope.rateFunction = function(rating) {
            console.log("Rating selected: " + rating);
        };
        $scope.isReadonly = true;
        $scope.photos = [];
        $scope.getPhotoDisable = false;
        $scope.sizeLimit      = 10585760; // 10MB in Bytes
        $scope.uploadProgress = 0;
        $scope.creds          = {};

        document.addEventListener("deviceready",onDeviceReady,false);

        var destinationType;
        var pictureSource;
        function onDeviceReady() {
            pictureSource=navigator.camera.PictureSourceType;
            destinationType=navigator.camera.DestinationType;
        };

        onPhotoSuccess = function(results) {
            if ($scope.photos.length + results.length >10) {
                alert('最多十张');
                return;
            }else if ($scope.photos.length >10) {
                $scope.getPhotoDisable = true;
            };
            for (var i = 0; i < results.length; i++) {
                upload(results[i]);
            }
            $scope.$apply();
        };
        onPhotoDataSuccess = function(results) {
            if ($scope.photos.length>10) {
                alert('最多十张');
                $scope.getPhotoDisable = true;
                return;
            };
            upload(results);
            $scope.$apply();
        };

        onConfirm = function(buttonIndex) {
            if (buttonIndex === 0) {
              return navigator.camera.getPicture(onPhotoDataSuccess, function onFail(message) {
                alert('Failed because: ' + message);
            }, {
                quality: 75,
                allowEdit: false,
                targetWidth: 400,
                targetHeight: 400,
                destinationType: 1,
                sourceType: 1,
                correctOrientation: true,
                saveToPhotoAlbum: true
              });
            } else if (buttonIndex === 1) {
              return window.imagePicker.getPictures(onPhotoSuccess, function onFail(message) {
                alert('Failed because: ' + message);
            }, {
                quality: 75,
                maximumImagesCount: 10,
                width: 400,
                height: 400,
                destinationType: 1,
                sourceType: 0,
                correctOrientation: true
              });
            }
        };

        $scope.getPhoto = function () {
            var hideSheet = $ionicActionSheet.show({
                buttons: [
                   { text: '拍摄图片' },
                   { text: '从相册选择' }
                ],
                titleText: '上传图片',
                cancelText: '取消',
                cancel: function() {
                },
                buttonClicked: function(index) {
                    onConfirm(index);
                    return true;
                }
           });
        };
        function dataURItoBlob(dataURI) {
             var byteString = atob(dataURI.split(',')[1]);
             var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];

             var ab = new ArrayBuffer(byteString.length);
             var ia = new Uint8Array(ab);
             for (var i = 0; i < byteString.length; i++)
             {
                ia[i] = byteString.charCodeAt(i);
             }
             var bb = new Blob([ab], { "type": mimeString });
             return bb;
        };

        var upload = function(imageUrl) {
            console.log("hhaah");
            var options = new FileUploadOptions();
                options.fileKey = "upload";
                options.fileName = imageUrl.substr(imageUrl.lastIndexOf('/') + 1);
                options.mimeType = "image/jpeg";
            $cordovaFileTransfer.upload("http://www.youjiacn.com:8000/index.php/home/file/index", imageUrl, options)
                .then(function(result) {
                    var results = JSON.parse(result.response);
                    $scope.images.push(results.data.url);
                    $scope.photos.push(results.data.url);
                }, function(err) {
                    console.log(err);
                }, function (progress) {
            });
        };

        $scope.addComment = function (isValid) {
            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            if($scope.images.length!=0){
                $scope.Data.images = JSON.stringify($scope.images);
            }
            Comment.add($scope.Data).then(function(res) {
                $ionicLoading.hide();
                $ionicHistory.goBack();
            }, function(err) {
                console.log(err);
                $ionicLoading.hide();
                var alertPopup = $ionicPopup.alert({
                    title: '操作失败',
                    template: ''+err.errorMessage
                });
            });
        };
    }]);

angular.module('AddOrder', ['ionic'])

    .controller('AddOrderCtrl', ['$scope', '$http', 'URLConfig', 'IntentOrder', '$ionicLoading', '$ionicViewSwitcher','$state', '$stateParams', 'TuanGou',function ($scope, $http, URLConfig, IntentOrder, $ionicLoading, $ionicViewSwitcher, $state, $stateParams,TuanGou) {
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
        $scope.code = $stateParams.detailCode;

        $scope.loadMore = function() {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });

            TuanGou.productDetail($stateParams.detailCode).then(function (response) {
                $scope.item = response.data.data;
                $ionicLoading.hide();
            }, function (resp) {
                console.log(resp);
            });
        };
        $scope.loadMore();

        $scope.addIntentOrder= function() {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            var data = {
                "region_lv1"    : 1,
                "region_lv2" : 16,
                "region_lv3"  : 221,
                "region_lv4"  :1853,
                "address"     :"工业园区浩辰大厦",
                "mobile"      : $scope.user.mobile,
                "consignee"   : $scope.user.user_name,
                "discount_price" :'',
                "user_name"   : $scope.user.user_name,
                "name"        : $scope.user.user_name,
                "icon"        : $scope.item.img[0].img,
                "user_id": $scope.user.id,
                "total_price": $scope.item.current_price,
                "memo": '',
                "unit_price": $scope.item.current_price,
                "number": "1",
                "supplier_id": $scope.item.supplier_id,
                "name": $scope.item.name,
                "deal_id": $scope.code
            }
            IntentOrder.add(data).then(function (response) {
                $state.go('orders', {}, {reload: true});
                $ionicLoading.hide();
            }, function (resp) {
                console.log(resp);
                $ionicLoading.hide();
            });
        }
    }]);


angular.module('TuanGou', [])

    .controller('TuanGouCtrl', ['$scope', '$http', 'TuanGou', '$ionicPopover', 'URLConfig', '$ionicLoading','$ionicModal' , '$timeout', '$ionicViewSwitcher', '$ionicHistory', function ($scope, $http, TuanGou, $ionicPopover, URLConfig, $ionicLoading, $ionicModal, $timeout, $ionicViewSwitcher, $ionicHistory) {

        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };
        $scope.items = [];
        $scope.iDisplayStart = 1;
        $scope.filterData = {
            cid: '',
            cName: '全部分类',
            city_id: '',
            city_name: '全城',
            sort: '',
            sortName: '智能排序',
            keyword: ''
        }

        $scope.isLoad = false;
        $scope.noMoreItemsAvailable = false;

        $scope.loadMore = function() {

            if ($scope.isLoad) {
                return;
            };
            $scope.isLoad = true;
            var loaction = JSON.parse(localStorage.getItem('LOCATION')) || [];
            var data = {
                'p': $scope.iDisplayStart,
                'iDisplayLength': 10,
                'cid': $scope.filterData.cid,
                'city_id': $scope.filterData.city_id,
                'keyword': $scope.filterData.keyword,
                'lng': loaction.center.lng,
                'lat': loaction.center.lat
            }
            $http({
                method: 'GET',
                url: URLConfig.API_BASEURL + "index.php/home/deal/index",
                params: data
            })
            .then(function(response){

                if(response.data.data){
                    angular.forEach(response.data.data, function(value, key) {
                    if(value.distance > 1000){
                            value.distance = Math.round(value.distance/100)/10;
                            value.distanceText = value.distance + 'km';
                       }else {
                            value.distanceText = value.distance + 'm';
                       }
                      $scope.items.push(value);
                    });
                }
                if(response.data.data.length < 10){
                    $scope.noMoreItemsAvailable = true;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                $scope.iDisplayStart +=1;
                $ionicLoading.hide();
                $scope.isLoad = false;
            });
          };

        $scope.moreDataCanBeLoaded = function() {
            return ($scope.items.length % 10!=0) ? true : false;
        }

        $scope.clickFilter = function(cid, cName, city_id, city_name, sort, sortName, keyword) {
            $scope.loading = $ionicLoading.show({
                showBackdrop: true
            });
            $scope.items = [];
            $scope.noMoreItemsAvailable = false;
            $scope.iDisplayStart = 1;
            $scope.iDisplayLength = 10;
            $scope.filterData.cid = cid;
            $scope.filterData.cName = cName;
            $scope.filterData.city_id = city_id;
            $scope.filterData.city_name = city_name;
            $scope.filterData.sort = sort;
            $scope.filterData.sortName = sortName;
            $scope.filterData.keyword = keyword;
            $scope.loadMore();
            $scope.locationPopover.hide();
            $scope.typePopover.hide();
            $scope.sortPopover.hide();
        }

        $scope.clearSearch = function() {
            $scope.filterData.keyword = "";
        }

        $ionicPopover.fromTemplateUrl('templates/type.html', {
            scope: $scope,
        }).then(function (popover) {
            $scope.typePopover = popover;
        });
        $ionicPopover.fromTemplateUrl('templates/location.html', {
            scope: $scope,
        }).then(function (popover) {
            $scope.locationPopover = popover;
        });
        $ionicPopover.fromTemplateUrl('templates/sort.html', {
            scope: $scope,
        }).then(function (popover) {
            $scope.sortPopover = popover;
        });

        function getTypes() {
            $http({
                method: 'GET',
                url: URLConfig.API_BASEURL+ "index.php/home/deal/cate"
            })
                .success(function (res) {
                    $scope.types = res.data;
                }).error(function (res) {
                    alert('error');
                });

        }

        function getCities() {
            $http({
                method: 'GET',
                url: URLConfig.API_BASEURL+ "index.php/home/deal/quan?city_id=15"
            })
                .success(function (res) {
                    $scope.cities = res.data;
                }).error(function (res) {
                    alert('error');
                });

        }

        getTypes();
        getCities();
    }])

angular.module('Review', [])

    .controller('ReviewCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'TuanGou', '$ionicLoading', 'Comment', function ($scope, $http, URLConfig, $stateParams, TuanGou, $ionicLoading, Comment) {
        $scope.code = $stateParams.code;
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        TuanGou.productDetail($stateParams.code).then(function (response) {
            $scope.product = response.data.data;

        }, function (resp) {
            console.log(resp);
            $ionicLoading.hide();
        });
        Comment.get($scope.code).then(function (response) {
            $scope.productReviews = response.data.data;
            $ionicLoading.hide();
        }, function (resp) {
            console.log(resp);
            $ionicLoading.hide();
        });
    }]);

angular.module('IntentOrder', ['ionic'])

    .controller('IntentOrderCtrl', ['$scope', '$http', 'URLConfig', 'IntentOrder', '$ionicLoading', '$ionicViewSwitcher','$state', '$stateParams', function ($scope, $http, URLConfig, IntentOrder, $ionicLoading, $ionicViewSwitcher, $state, $stateParams) {
        $scope.loadMore= function() {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            var user = JSON.parse(localStorage.getItem('USERS')) || [];
            var data = {
                'user_id': user.id,
                'm_status': "0"
            }
            IntentOrder.all(data).then(function (response) {
               $scope.Items = response.data.data;
               $scope.getItem('');
               $ionicLoading.hide();
               $scope.$broadcast('scroll.refreshComplete');
            }, function (resp) {
               console.log(resp);
               $scope.$broadcast('scroll.refreshComplete');
               $ionicLoading.hide();
            });
        };
        $scope.loadMore();

        $scope.goOrder = function (id) {
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('order', {'isTab':true,'id':id}, {reload: true});
        }

        $scope.getItem = function(pay_status){
            $scope.orders = [];
            $scope.pay_status = pay_status;
            angular.forEach($scope.Items, function(value, key) {
                if(pay_status!=''){
                    if(pay_status == value.pay_status){
                        $scope.orders.push(value);
                    }
                }else {
                    $scope.orders.push(value);
                }

            });
        }
    }]);


angular.module('TuanGouDetail', [])

    .controller('TuanGouDetailCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', '$ionicSlideBoxDelegate', 'TuanGou', 'IntentOrder', '$timeout', '$ionicLoading', '$ionicModal','$state','$ionicPopup', 'Comment', function ($scope, $http, URLConfig, $stateParams, $ionicSlideBoxDelegate, TuanGou, IntentOrder, $timeout, $ionicLoading, $ionicModal, $state, $ionicPopup, Comment) {

        $scope.showPage = false;
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        $scope.iDisplayStart = 0;
        $scope.iDisplayLength = 3;
        $scope.code = $stateParams.detailCode;

        TuanGou.productDetail($scope.code).then(function (response) {
            $scope.product = response.data.data;
            $timeout(function () {
                $ionicSlideBoxDelegate.$getByHandle('image-viewer').update();
            }, 0);
            $scope.showPage = true;
            $ionicLoading.hide();
        }, function (resp) {
            console.log(resp);
        });

        Comment.get($scope.code).then(function (response) {
            $scope.reviews = response.data.data;

        }, function (resp) {
            console.log(resp);
        });

        function addIntentOrder() {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            var user = JSON.parse(localStorage.getItem('USERS')) || [];
            var data = {
                "region_lv1"    : 1,
                "region_lv2" : 16,
                "region_lv3"  : 221,
                "region_lv4"  :1853,
                "address"     :"工业园区浩辰大厦",
                "mobile"      : user.mobile,
                "consignee"   : user.user_name,
                "discount_price" :'',
                "user_name"   : user.user_name,
                "name"        : user.user_name,
                "icon"        : $scope.product.img[0].img,
                "user_id": user.id,
                "total_price": $scope.product.current_price,
                "memo": '',
                "unit_price": $scope.product.current_price,
                "number": "1",
                "supplier_id": $scope.product.supplier_id,
                "name": $scope.product.name,
                "deal_id": $scope.code
            }
            IntentOrder.add(data).then(function (response) {
                $state.go('orders', {}, {reload: true});
                $ionicLoading.hide();
            }, function (resp) {
                console.log(resp);
                $ionicLoading.hide();
            });
        }

        $scope.showImages = function(index) {
            $scope.activeSlide = index;
            $scope.showModal('templates/image-popover.html');
        }

        $scope.showModal = function(templateUrl) {
            $ionicModal.fromTemplateUrl(templateUrl, {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
            $scope.modal.show();
        });}

         // Close the modal
         $scope.closeModal = function() {
            $scope.modal.hide();
            $scope.modal.remove()
         };
    }]);


angular.module('Stores', [])

    .controller('StoresCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'Stores', 'IntentOrder', '$ionicLoading', '$ionicViewSwitcher', '$ionicHistory', '$state', function ($scope, $http, URLConfig, $stateParams, Stores, IntentOrder, $ionicLoading, $ionicViewSwitcher, $ionicHistory, $state) {
        $scope.supplier_id = $stateParams.supplier_id;
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };

        $scope.goStore = function (id) {
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('store', {'id':id}, {reload: true});
        }

        $scope.loadMore= function() {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Stores.all($scope.supplier_id).then(function (response) {
               $scope.Stores = response.data.data;
               angular.forEach($scope.Stores, function(value, key) {
                    if(value.distance > 1000){
                        value.distance = Math.round(value.distance/100)/10;
                        value.distanceText = value.distance + 'km';
                   }else {
                        value.distanceText = value.distance + 'm';
                   }
               });

               $ionicLoading.hide();
               $scope.$broadcast('scroll.refreshComplete');
            }, function (resp) {
               console.log(resp);
               $scope.$broadcast('scroll.refreshComplete');
               $ionicLoading.hide();
            });
        };
        $scope.loadMore();
    }]);

angular.module('Store', [])

    .controller('StoreCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'IntentOrder', '$ionicLoading', '$ionicViewSwitcher', '$ionicHistory', '$ionicPopup', 'TuanGou', '$timeout', '$ionicSlideBoxDelegate', function ($scope, $http, URLConfig, $stateParams, IntentOrder, $ionicLoading, $ionicViewSwitcher, $ionicHistory, $ionicPopup, TuanGou, $timeout, $ionicSlideBoxDelegate) {

        $scope.showPage = false;
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        $scope.iDisplayStart = 0;
        $scope.iDisplayLength = 3;
        $scope.code = $stateParams.detailCode;

        TuanGou.productDetail(96).then(function (response) {
            $scope.product = response.data.data;
            $timeout(function () {
                $ionicSlideBoxDelegate.$getByHandle('image-viewer').update();
            }, 0);
            $scope.showPage = true;
            $ionicLoading.hide();
        }, function (resp) {
            console.log(resp);
        });

        TuanGou.reviewDetail(96).then(function (response) {
            $scope.reviews = response.data.data;

        }, function (resp) {
            console.log(resp);
        });

        $scope.showImages = function(index) {
            $scope.activeSlide = index;
            $scope.showModal('templates/image-popover.html');
        }

        $scope.showModal = function(templateUrl) {
            $ionicModal.fromTemplateUrl(templateUrl, {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
            $scope.modal.show();
        });}

         // Close the modal
         $scope.closeModal = function() {
            $scope.modal.hide();
            $scope.modal.remove()
         };
    }]);

angular.module('Home', [])
.controller('HomeCtrl', ['$scope','$ionicModal','$ionicLoading', 'CITY', '$location', '$ionicScrollDelegate', '$cordovaGeolocation', '$ionicPopup', '$timeout', '$ionicViewSwitcher', '$state','Bids', '$ionicSlideBoxDelegate','$sce', '$document', function ($scope, $ionicModal,$ionicLoading, CITY, $location, $ionicScrollDelegate, $cordovaGeolocation, $ionicPopup, $timeout, $ionicViewSwitcher, $state, Bids,$ionicSlideBoxDelegate, $sce, $document) {

    $scope.data = {
        scroll: false
    };
    $scope.cards = [{
        icon: 'img/default.png'
    }, {
        icon: 'img/default.png'
    }, {
        icon: 'img/default.png'
    }, {
        icon: 'img/default.png'
    }, {
        icon: 'img/default.png'
    }];
    var isFirstLoad = true;
    $scope.isHomepage = true;
    $scope.$on('$ionicView.beforeEnter', function(){
        $scope.isHomepage = true;
        var headerList = $document[0].body.querySelectorAll('.nav-bar-block');
        angular.forEach(headerList, function(value, key) {
            if(isFirstLoad){
                if(value.attributes.getNamedItem('nav-bar').value=== "cached"){
                    ionic.requestAnimationFrame(function() {
                        value.children[0].style.opacity = 0;
                    });
                }else{
                    ionic.requestAnimationFrame(function() {
                        value.children[0].style.opacity = 1;
                    });
                }
            }else{
                if(value.attributes.getNamedItem('nav-bar').value=== "active"){
                    ionic.requestAnimationFrame(function() {
                        value.children[0].style.opacity = 0;
                    });
                }else{
                    ionic.requestAnimationFrame(function() {
                        value.children[0].style.opacity = 1;
                    });
                }
            }
        });
        isFirstLoad = false;
        $ionicScrollDelegate.scrollTop();
    });

    $scope.$on('$ionicView.beforeLeave', function(){
        handleBeforeLeave();
    });
    function handleBeforeLeave() {
        var headerList = $document[0].body.querySelectorAll('.nav-bar-block');
        angular.forEach(headerList, function(value, key) {
            ionic.requestAnimationFrame(function() {
                value.children[0].style.opacity = 1;
            });
        });
    }
    $scope.isLoad = false;
    $scope.loadData = function() {
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        if ($scope.isLoad) {
            return;
        };
        $scope.isLoad = true;
        var loaction = JSON.parse(localStorage.getItem('LOCATION')) || [];
        var data = {
            'city_id': 15,
            'type': 2
        }
        Bids.all(data).then(function (response) {
            $scope.$broadcast('scroll.refreshComplete');
            $scope.cards.length = 0;
            $scope.cards = [];
            $scope.cards = response.data.data;
            angular.forEach($scope.cards, function(value, key) {
                value.icon = $sce.trustAsResourceUrl(value.icon);
            });
            $ionicLoading.hide();
            $scope.isLoad = false;
            $scope.slideChanged(0);
            $timeout(function () {
                $ionicSlideBoxDelegate.$getByHandle('image-viewer').update();
                $ionicSlideBoxDelegate.$getByHandle('viewer').update();
            }, 0);

        }, function (resp) {
            $ionicLoading.hide();
            console.log(resp);
            $scope.$broadcast('scroll.refreshComplete');
        });
    }
    $scope.goToBid = function (id,type) {
        event.preventDefault();
        handleBeforeLeave();
        $scope.isHomepage = false;
        $ionicViewSwitcher.nextDirection('forward');
        $state.go('bid', {"id":id,"type":type,"form":0}, {reload: true});
    }
    $scope.refersh = function () {
        $scope.loadData();
    }
    $scope.refersh();
    $scope.activeCard = $scope.cards[0];
    $scope.slideChanged = function(index) {
        $scope.activeSlide = index;
        $scope.activeCard = $scope.cards[index];
        // $timeout(function () {
        //     $scope.activeCard = $scope.cards[index];
        //     if($scope.activeCard){
        //            $scope.activeCard.icon = $sce.trustAsResourceUrl($scope.activeCard.icon);
        //         }
        //     }
        // }, 0);
    };
    $scope.cityName = "";
    var loaction = JSON.parse(localStorage.getItem('LOCATION')) || [];
    $scope.selectCityName = loaction.name;
    $scope.openModal = function() {
        var alertPopup = $ionicPopup.alert({
            title: '提示信息',
            template: '其他城市,火热招商中,联系电话:4001603518',
            buttons: [
              {
                text: '<b>确认</b>',
                type: 'button-assertive'
              }
            ]
        });
        return;
        // $ionicModal.fromTemplateUrl('templates/cities.html', {
        //     scope: $scope,
        //     backdropClickToClose: false,
        //     animation: 'slide-in-up'
        // }).then(function(modal) {
        //     $scope.oModal = modal;
        //     $scope.oModal.show();
        // });
    };

    $scope.closeModal = function() {
        $scope.oModal.hide();
    };

    $scope.clearSearch = function() {
        $scope.cityName = "";
    }

    $scope.alphabet = ["#", "A", "B", "C", "D", "E", "F", "G",
            "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T",
            "U", "V", "W", "X", "Y", "Z" ];

    $scope.groups = CITY.group;

    $scope.gotoCity = function(id){
        $location.hash(id);
        $ionicScrollDelegate.anchorScroll();
    }

    function getLocation() {
        $scope.myCityName = "定位中...";
        var myCity = new BMap.LocalCity();
        function myFun(result){
            var myCityName = result.name;
            window.localStorage.setItem('LOCATION', JSON.stringify(result));
            $scope.myCityName = myCityName;
        }
        myCity.get(myFun);
    }
    getLocation();

    $scope.selectCity = function (city) {
        $scope.selectCityName = city.name;
    }
}]);

/*

Superfast Blur - a fast Box Blur For Canvas

Version:    0.5
Author:     Mario Klingemann
Contact:    mario@quasimondo.com
Website:    http://www.quasimondo.com/BoxBlurForCanvas
Twitter:    @quasimondo

In case you find this class useful - especially in commercial projects -
I am not totally unhappy for a small donation to my PayPal account
mario@quasimondo.de

Or support me on flattr:
https://flattr.com/thing/140066/Superfast-Blur-a-pretty-fast-Box-Blur-Effect-for-CanvasJavascript

Copyright (c) 2011 Mario Klingemann

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/
var mul_table = [ 1,57,41,21,203,34,97,73,227,91,149,62,105,45,39,137,241,107,3,173,39,71,65,238,219,101,187,87,81,151,141,133,249,117,221,209,197,187,177,169,5,153,73,139,133,127,243,233,223,107,103,99,191,23,177,171,165,159,77,149,9,139,135,131,253,245,119,231,224,109,211,103,25,195,189,23,45,175,171,83,81,79,155,151,147,9,141,137,67,131,129,251,123,30,235,115,113,221,217,53,13,51,50,49,193,189,185,91,179,175,43,169,83,163,5,79,155,19,75,147,145,143,35,69,17,67,33,65,255,251,247,243,239,59,29,229,113,111,219,27,213,105,207,51,201,199,49,193,191,47,93,183,181,179,11,87,43,85,167,165,163,161,159,157,155,77,19,75,37,73,145,143,141,35,138,137,135,67,33,131,129,255,63,250,247,61,121,239,237,117,29,229,227,225,111,55,109,216,213,211,209,207,205,203,201,199,197,195,193,48,190,47,93,185,183,181,179,178,176,175,173,171,85,21,167,165,41,163,161,5,79,157,78,154,153,19,75,149,74,147,73,144,143,71,141,140,139,137,17,135,134,133,66,131,65,129,1];


var shg_table = [0,9,10,10,14,12,14,14,16,15,16,15,16,15,15,17,18,17,12,18,16,17,17,19,19,18,19,18,18,19,19,19,20,19,20,20,20,20,20,20,15,20,19,20,20,20,21,21,21,20,20,20,21,18,21,21,21,21,20,21,17,21,21,21,22,22,21,22,22,21,22,21,19,22,22,19,20,22,22,21,21,21,22,22,22,18,22,22,21,22,22,23,22,20,23,22,22,23,23,21,19,21,21,21,23,23,23,22,23,23,21,23,22,23,18,22,23,20,22,23,23,23,21,22,20,22,21,22,24,24,24,24,24,22,21,24,23,23,24,21,24,23,24,22,24,24,22,24,24,22,23,24,24,24,20,23,22,23,24,24,24,24,24,24,24,23,21,23,22,23,24,24,24,22,24,24,24,23,22,24,24,25,23,25,25,23,24,25,25,24,22,25,25,25,24,23,24,25,25,25,25,25,25,25,25,25,25,25,25,23,25,23,24,25,25,25,25,25,25,25,25,25,24,22,25,25,23,25,25,20,24,25,24,25,25,22,24,25,24,25,24,25,25,24,25,25,25,25,22,25,25,25,24,25,24,25,18];


function boxBlurImage( imageID, canvasID, radius, blurAlphaChannel, iterations ){

    var img = document.getElementById( imageID );
    var w = img.naturalWidth;
    var h = img.naturalHeight;

    var canvas = document.getElementById( canvasID );

    canvas.style.width  = w + "px";
    canvas.style.height = h + "px";
    canvas.width = w;
    canvas.height = h;

    var context = canvas.getContext("2d");
    context.clearRect( 0, 0, w, h );
    context.drawImage( img, 0, 0 );

    if ( isNaN(radius) || radius < 1 ) return;

    if ( blurAlphaChannel )
    {
        boxBlurCanvasRGBA( canvasID, 0, 0, w, h, radius, iterations );
    } else {
        boxBlurCanvasRGB( canvasID, 0, 0, w, h, radius, iterations );
    }

}


function boxBlurCanvasRGBA( id, top_x, top_y, width, height, radius, iterations ){
    if ( isNaN(radius) || radius < 1 ) return;

    radius |= 0;

    if ( isNaN(iterations) ) iterations = 1;
    iterations |= 0;
    if ( iterations > 3 ) iterations = 3;
    if ( iterations < 1 ) iterations = 1;

    var canvas  = document.getElementById( id );
    var context = canvas.getContext("2d");
    var imageData;

    try {
      try {
        imageData = context.getImageData( top_x, top_y, width, height );
      } catch(e) {

        // NOTE: this part is supposedly only needed if you want to work with local files
        // so it might be okay to remove the whole try/catch block and just use
        // imageData = context.getImageData( top_x, top_y, width, height );
        try {
            netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
            imageData = context.getImageData( top_x, top_y, width, height );
        } catch(e) {
            alert("Cannot access local image");
            throw new Error("unable to access local image data: " + e);
            return;
        }
      }
    } catch(e) {
      alert("Cannot access image");
      throw new Error("unable to access image data: " + e);
      return;
    }

    var pixels = imageData.data;

    var rsum,gsum,bsum,asum,x,y,i,p,p1,p2,yp,yi,yw,idx,pa;
    var wm = width - 1;
    var hm = height - 1;
    var wh = width * height;
    var rad1 = radius + 1;

    var mul_sum = mul_table[radius];
    var shg_sum = shg_table[radius];

    var r = [];
    var g = [];
    var b = [];
    var a = [];

    var vmin = [];
    var vmax = [];

    while ( iterations-- > 0 ){
        yw = yi = 0;

        for ( y=0; y < height; y++ ){
            rsum = pixels[yw]   * rad1;
            gsum = pixels[yw+1] * rad1;
            bsum = pixels[yw+2] * rad1;
            asum = pixels[yw+3] * rad1;


            for( i = 1; i <= radius; i++ ){
                p = yw + (((i > wm ? wm : i )) << 2 );
                rsum += pixels[p++];
                gsum += pixels[p++];
                bsum += pixels[p++];
                asum += pixels[p]
            }

            for ( x = 0; x < width; x++ ) {
                r[yi] = rsum;
                g[yi] = gsum;
                b[yi] = bsum;
                a[yi] = asum;

                if( y==0) {
                    vmin[x] = ( ( p = x + rad1) < wm ? p : wm ) << 2;
                    vmax[x] = ( ( p = x - radius) > 0 ? p << 2 : 0 );
                }

                p1 = yw + vmin[x];
                p2 = yw + vmax[x];

                rsum += pixels[p1++] - pixels[p2++];
                gsum += pixels[p1++] - pixels[p2++];
                bsum += pixels[p1++] - pixels[p2++];
                asum += pixels[p1]   - pixels[p2];

                yi++;
            }
            yw += ( width << 2 );
        }

        for ( x = 0; x < width; x++ ) {
            yp = x;
            rsum = r[yp] * rad1;
            gsum = g[yp] * rad1;
            bsum = b[yp] * rad1;
            asum = a[yp] * rad1;

            for( i = 1; i <= radius; i++ ) {
              yp += ( i > hm ? 0 : width );
              rsum += r[yp];
              gsum += g[yp];
              bsum += b[yp];
              asum += a[yp];
            }

            yi = x << 2;
            for ( y = 0; y < height; y++) {

                pixels[yi+3] = pa = (asum * mul_sum) >>> shg_sum;
                if ( pa > 0 )
                {
                    pa = 255 / pa;
                    pixels[yi]   = ((rsum * mul_sum) >>> shg_sum) * pa;
                    pixels[yi+1] = ((gsum * mul_sum) >>> shg_sum) * pa;
                    pixels[yi+2] = ((bsum * mul_sum) >>> shg_sum) * pa;
                } else {
                    pixels[yi] = pixels[yi+1] = pixels[yi+2] = 0;
                }
                if( x == 0 ) {
                    vmin[y] = ( ( p = y + rad1) < hm ? p : hm ) * width;
                    vmax[y] = ( ( p = y - radius) > 0 ? p * width : 0 );
                }

                p1 = x + vmin[y];
                p2 = x + vmax[y];

                rsum += r[p1] - r[p2];
                gsum += g[p1] - g[p2];
                bsum += b[p1] - b[p2];
                asum += a[p1] - a[p2];

                yi += width << 2;
            }
        }
    }

    context.putImageData( imageData, top_x, top_y );

}

function boxBlurCanvasRGB( id, top_x, top_y, width, height, radius, iterations ){
    if ( isNaN(radius) || radius < 1 ) return;

    radius |= 0;

    if ( isNaN(iterations) ) iterations = 1;
    iterations |= 0;
    if ( iterations > 3 ) iterations = 3;
    if ( iterations < 1 ) iterations = 1;

    var canvas  = document.getElementById( id );
    var context = canvas.getContext("2d");
    var imageData;

    try {
      try {
        imageData = context.getImageData( top_x, top_y, width, height );
      } catch(e) {

        // NOTE: this part is supposedly only needed if you want to work with local files
        // so it might be okay to remove the whole try/catch block and just use
        // imageData = context.getImageData( top_x, top_y, width, height );
        try {
            netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
            imageData = context.getImageData( top_x, top_y, width, height );
        } catch(e) {
            alert("Cannot access local image");
            throw new Error("unable to access local image data: " + e);
            return;
        }
      }
    } catch(e) {
      alert("Cannot access image");
      throw new Error("unable to access image data: " + e);
      return;
    }

    var pixels = imageData.data;

    var rsum,gsum,bsum,asum,x,y,i,p,p1,p2,yp,yi,yw,idx;
    var wm = width - 1;
    var hm = height - 1;
    var wh = width * height;
    var rad1 = radius + 1;

    var r = [];
    var g = [];
    var b = [];

    var mul_sum = mul_table[radius];
    var shg_sum = shg_table[radius];

    var vmin = [];
    var vmax = [];

    while ( iterations-- > 0 ){
        yw = yi = 0;

        for ( y=0; y < height; y++ ){
            rsum = pixels[yw]   * rad1;
            gsum = pixels[yw+1] * rad1;
            bsum = pixels[yw+2] * rad1;

            for( i = 1; i <= radius; i++ ){
                p = yw + (((i > wm ? wm : i )) << 2 );
                rsum += pixels[p++];
                gsum += pixels[p++];
                bsum += pixels[p++];
            }

            for ( x = 0; x < width; x++ ){
                r[yi] = rsum;
                g[yi] = gsum;
                b[yi] = bsum;

                if( y==0) {
                    vmin[x] = ( ( p = x + rad1) < wm ? p : wm ) << 2;
                    vmax[x] = ( ( p = x - radius) > 0 ? p << 2 : 0 );
                }

                p1 = yw + vmin[x];
                p2 = yw + vmax[x];

                rsum += pixels[p1++] - pixels[p2++];
                gsum += pixels[p1++] - pixels[p2++];
                bsum += pixels[p1++] - pixels[p2++];

                yi++;
            }
            yw += ( width << 2 );
        }

        for ( x = 0; x < width; x++ ){
            yp = x;
            rsum = r[yp] * rad1;
            gsum = g[yp] * rad1;
            bsum = b[yp] * rad1;

            for( i = 1; i <= radius; i++ ){
              yp += ( i > hm ? 0 : width );
              rsum += r[yp];
              gsum += g[yp];
              bsum += b[yp];
            }

            yi = x << 2;
            for ( y = 0; y < height; y++){
                pixels[yi]   = (rsum * mul_sum) >>> shg_sum;
                pixels[yi+1] = (gsum * mul_sum) >>> shg_sum;
                pixels[yi+2] = (bsum * mul_sum) >>> shg_sum;

                if( x == 0 ) {
                    vmin[y] = ( ( p = y + rad1) < hm ? p : hm ) * width;
                    vmax[y] = ( ( p = y - radius) > 0 ? p * width : 0 );
                }

                p1 = x + vmin[y];
                p2 = x + vmax[y];

                rsum += r[p1] - r[p2];
                gsum += g[p1] - g[p2];
                bsum += b[p1] - b[p2];

                yi += width << 2;
            }
        }
    }
    context.putImageData( imageData, top_x, top_y );

}

angular.module('myBids', [])
    .controller('MyBidsCtrl', ['$scope', '$http', '$ionicPopover', 'URLConfig', '$ionicLoading','$ionicModal' , '$timeout', '$ionicViewSwitcher', '$ionicHistory', '$ionicBackdrop', 'Bids', '$state', function ($scope, $http, $ionicPopover, URLConfig, $ionicLoading, $ionicModal, $timeout, $ionicViewSwitcher, $ionicHistory, $ionicBackdrop, Bids, $state) {
        $scope.type = 4;
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];

        $scope.selectType = function (index) {
            $scope.items = [];
            $scope.type = index;
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            $scope.loadMore();
        }
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };

        $scope.goToBid = function (bid) {
            event.preventDefault();
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('bid', {"id":bid.id,"type":0,"form":1}, {reload: true});
        }

        $scope.goAddComment = function (bid) {
            event.preventDefault();
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('addComment', {"orderId":bid.deal_id,"bid":bid.id}, {reload: true});
        }
        $scope.items = [];
        $scope.iDisplayStart = 1;

        $scope.isLoad = false;
        $scope.noMoreItemsAvailable = false;

        $scope.loadMore = function() {
            if ($scope.isLoad) {
                return;
            };
            $scope.isLoad = true;
            var loaction = JSON.parse(localStorage.getItem('LOCATION')) || [];
            var data = {
                'city_id': 15,
                'type': $scope.type,
                'user_id': $scope.user.id
            }

            Bids.all(data).then(function (response) {
                if(response.data.data){
                    angular.forEach(response.data.data, function(value, key) {
                        if(value.is_comment==1){
                            value.showAddComment = true;
                        }else{
                            value.showAddComment = false;
                        }
                        $scope.items.push(value);
                        // $scope.apply();
                    });
                }
                if(response.data.data.length < 10){
                    $scope.noMoreItemsAvailable = true;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                $scope.iDisplayStart +=1;
                $ionicLoading.hide();
                $scope.isLoad = false;
                $scope.finish();

            }, function (resp) {
                console.log(resp);
            });


        };

        $scope.refersh = function() {
            $scope.items = [];
            $scope.iDisplayStart = 1;
            $scope.isLoad = false;
            $scope.noMoreItemsAvailable = false;
            $scope.loadMore();
        }

        $scope.finish = function () {

            angular.forEach($scope.items, function(value, key) {
                if (value.submit_end_time*1000 > new Date().getTime()) {
                    value.Status = true;
                    value.pay_status = 1;
                }else {
                    value.Status = false;
                    value.pay_status = 2;
                };
            });
        }

        $scope.getItem = function(pay_status){
            $scope.orders = [];
            $scope.pay_status = pay_status;
            angular.forEach($scope.items, function(value, key) {
                if(pay_status!=''){
                    if(pay_status == value.m_status){
                        $scope.orders.push(value);
                    }
                }else {
                    $scope.orders.push(value);
                }

            });
        }
        $scope.loadMore();

    }])


angular.module('Messages', [])

    .controller('MessagesCtrl', ['$scope', '$http', '$ionicPopover', 'URLConfig', '$ionicLoading','$ionicModal' , '$timeout', '$ionicViewSwitcher', '$ionicHistory', '$ionicBackdrop', 'Account', '$state', '$rootScope', 'security', 'AUTH_EVENTS', function ($scope, $http, $ionicPopover, URLConfig, $ionicLoading, $ionicModal, $timeout, $ionicViewSwitcher, $ionicHistory, $ionicBackdrop, Account, $state, $rootScope, security, AUTH_EVENTS) {
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };
        $scope.showPage = false;
        $scope.isLogin = true;
        if (!security.isAuthenticated()) {
            $scope.isLogin = false;
        }
        $scope.goToBbsMessage = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('bbsMessage', {}, {reload: true});
        }

        $scope.goToMessage = function () {
            event.preventDefault();
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('message', {}, {reload: true});
        }

        $scope.isLoad = false;
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
        $scope.loadMore = function() {
            if ($scope.isLoad) {
                return;
            };
            $scope.isLoad = true;
            var data = {
                'user_id': $scope.user.id
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Account.msgBrief(data).then(function (response) {
                $scope.items = response.data.data;
                $ionicLoading.hide();
                $scope.isLoad = false;
                $scope.showPage = true;
                $scope.$broadcast('scroll.refreshComplete');
            }, function (resp) {
                console.log(resp);
                $ionicLoading.hide();
            });
        };

        $scope.refersh = function() {
            $scope.items = '';
            $scope.isLoad = false;
            $scope.loadMore();
        }
        $scope.loadMore();
    }])


angular.module('Message', [])

    .controller('MessageCtrl', ['$scope', '$http', '$ionicPopover', 'URLConfig', '$ionicLoading','$ionicModal' , '$timeout', '$ionicViewSwitcher', '$ionicHistory', '$ionicBackdrop', 'Account', '$state', '$rootScope', 'security', function ($scope, $http, $ionicPopover, URLConfig, $ionicLoading, $ionicModal, $timeout, $ionicViewSwitcher, $ionicHistory, $ionicBackdrop, Account, $state, $rootScope, security) {
        $rootScope.badge = $rootScope.badge - $rootScope.messageBadge;
        $rootScope.commonBadge =  $rootScope.commonBadge - $rootScope.messageBadge;
        $rootScope.messageBadge = 0;
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };

        $scope.goToBbsMessage = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('bbsMessage', {}, {reload: true});
        }

        $scope.goToMessage = function () {
            event.preventDefault();
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('message', {}, {reload: true});
        }
        $scope.items = [];
        $scope.iDisplayStart = 1;
        $scope.loadMore = function() {
            if ($scope.isLoad) {
                return;
            };
            $scope.isLoad = true;
            var loaction = JSON.parse(localStorage.getItem('LOCATION')) || [];
            var data = {
                'p': $scope.iDisplayStart
            }

            Account.messages(data).then(function (response) {
                if(response.data.data){
                    angular.forEach(response.data.data, function(value, key) {
                        $scope.items.push(value);
                        // $scope.apply();
                    });
                }
                if(response.data.data.length < 10){
                    $scope.noMoreItemsAvailable = true;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                $scope.iDisplayStart +=1;
                $ionicLoading.hide();
                $scope.isLoad = false;

            }, function (resp) {
                console.log(resp);
            });


        };

        $scope.refersh = function() {
            $scope.items = [];
            $scope.iDisplayStart = 1;
            $scope.isLoad = false;
            $scope.noMoreItemsAvailable = false;
            $scope.loadMore();
        }

    }])
    .controller('MessageDetialCtrl', ['$scope', '$http', '$stateParams', 'URLConfig', '$ionicLoading','$ionicModal' , '$timeout', '$ionicViewSwitcher', '$ionicHistory', '$ionicBackdrop', 'Account', '$state', '$rootScope', function ($scope, $http, $stateParams, URLConfig, $ionicLoading, $ionicModal, $timeout, $ionicViewSwitcher, $ionicHistory, $ionicBackdrop, Account, $state, $rootScope) {

        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };
        $scope.id = $stateParams.id;
        $scope.showPage = false;
        $scope.loadMore = function() {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Account.messageDetial($scope.id).then(function (response) {
                $scope.message = response.data.data;
                $scope.showPage = true;
                $ionicLoading.hide();
            }, function (resp) {
                console.log(resp);
                $ionicLoading.hide();
            });
        };

        $scope.loadMore();

    }])


angular.module('BidCode', [])
    .controller('BidCodeCtrl', ['$scope', '$http', '$ionicPopover', 'URLConfig', '$ionicLoading','$ionicModal' , '$timeout', '$ionicViewSwitcher', '$ionicHistory', '$ionicBackdrop', 'Bids', '$state', '$rootScope', function ($scope, $http, $ionicPopover, URLConfig, $ionicLoading, $ionicModal, $timeout, $ionicViewSwitcher, $ionicHistory, $ionicBackdrop, Bids, $state, $rootScope) {
        $rootScope.badge = $rootScope.badge - $rootScope.codeBadge;
        $rootScope.codeBadge = 0;
        $scope.type = 2;
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
        $scope.loadMore = function() {
            var data = {
                'user_id': $scope.user.id
            };
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            Bids.getCodes(data).then(function (response) {
                $scope.items = response.data.data;
                $scope.$broadcast('scroll.refreshComplete');
                $ionicLoading.hide();
            }, function (resp) {
                console.log(resp);
                $ionicLoading.hide();
            });
        };

        $scope.refersh = function() {
            $scope.loadMore();
        }
        $scope.loadMore();
    }])


angular.module('BBSMessage', [])
.controller('BBSMessageCtrl', ['$scope', '$http', 'URLConfig', '$ionicLoading','$ionicActionSheet' , '$state', '$ionicViewSwitcher', '$ionicHistory', 'Post', '$rootScope', function ($scope, $http, URLConfig, $ionicLoading, $ionicActionSheet, $state, $ionicViewSwitcher, $ionicHistory, Post, $rootScope) {
    $rootScope.badge = $rootScope.badge - $rootScope.cityBadge;
    $rootScope.commonBadge =  $rootScope.commonBadge - $rootScope.cityBadge;
    $rootScope.cityBadge = 0;
    $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
    $scope.goToPost = function (item) {
        event.preventDefault();
        $ionicViewSwitcher.nextDirection('forward');
        if (parseInt(item.type)==2) {
            $state.go('bidPosts', {"id":item.cid}, {reload: true});
        }else {
            $state.go('posts', {"id":item.cid, "type":'message'}, {reload: true});
        };
    }
    $scope.items = [];
    $scope.loadMore = function() {

        if ($scope.isLoad) {
            return;
        };
        var data = {
            'user_id' : $scope.user.id,
            'category' : 1
        }
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        $http({
            method: 'GET',
            url: URLConfig.API_BASEURL + "index.php/home/member/notice",
            params: data
        })
        .then(function(response){
            $scope.items = response.data.data;
            $scope.$broadcast('scroll.refreshComplete');
            $ionicLoading.hide();
        });
    };
    $scope.refersh = function() {
        $scope.items = [];
        $scope.loadMore();
    }
    $scope.loadMore();

    $scope.clear = function () {
        var hideSheet = $ionicActionSheet.show({
            titleText: '',
            destructiveText: '清空所有同城消息',
            cancelText: '取消',
            destructiveButtonClicked: function() {
                $scope.loading = $ionicLoading.show({
                  showBackdrop: false
                });
                $http({
                    method: 'GET',
                    url: URLConfig.API_BASEURL + "index.php/home/member/delnotice?user_id=" + $scope.user.id,
                })
                .then(function(response){
                    $scope.loadMore();
                });
                return true;
            }
        });
    }

 }])


angular.module('Account', [])
    .controller('AgreementCtrl', function () {
    })
    .controller('AddAddressCtrl',['$scope', '$stateParams', 'Account', function ($scope, $stateParams, Account) {
        $scope.data = Account.get($stateParams.addressId);
        $scope.title = $scope.data?'修改收货地址':'创建收货地址';
    }])
    .controller('AccountDetialCtrl',['$scope', 'security', '$stateParams', '$ionicHistory', '$ionicViewSwitcher', '$state', '$ionicLoading', 'Account', '$ionicPopup', function($scope, security, $stateParams, $ionicHistory, $ionicViewSwitcher, $state, $ionicLoading, Account, $ionicPopup) {
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };
        $scope.logout = function () {
            event.preventDefault();
            var myPopup = $ionicPopup.show({
                    title: '提示信息',
                    subTitle: '您确认要退出吗？',
                    buttons: [
                      { text: '取消' },
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive',
                        onTap: function(e) {
                            security.logout();
                            $state.go('tab.account', {}, {reload: true});
                            return;
                        }
                      }
                    ]
            });
        }
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];

        $scope.addressList = Account.all();

        $scope.data = {
            showDelete: false,
            text:"编辑"
        };

        $scope.edit = function() {
            $scope.data.showDelete = !$scope.data.showDelete;
            $scope.data.text=$scope.data.showDelete?'完成':'编辑';
        }

        $scope.onItemDelete = function(item) {
            $scope.addressList.splice($scope.addressList.indexOf(item), 1);
        };

        $scope.changeNamedata = {
            'nickname': $scope.user.nickname,
            'user_id':$scope.user.id
        }

        $scope.changeName = function (isValid) {
            event.preventDefault();
            if (!isValid) {
              return;
            }
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });

            Account.setNickname($scope.changeNamedata).then(function(res) {
                $scope.user.nickname = $scope.changeNamedata.nickname;
                window.localStorage.setItem('USERS', JSON.stringify($scope.user));
                $ionicViewSwitcher.nextDirection('back');
                $state.go('tab.account', {}, {reload: true});
                $ionicLoading.hide();
            }, function(err) {
                var alertPopup = $ionicPopup.alert({
                    title: '修改失败',
                    template: '请检查你的用户名是否正确'
                });
                $ionicLoading.hide();
            });
        }

    }])
    .controller('AccountCtrl', ['$scope', 'security', '$rootScope', 'AUTH_EVENTS', '$state', '$ionicActionSheet', '$ionicViewSwitcher', '$ionicPopup', 'Account', '$ionicActionSheet', '$cordovaFileTransfer', function ($scope, security, $rootScope, AUTH_EVENTS, $state, ionicActionSheet, $ionicViewSwitcher, $ionicPopup, Account, $ionicActionSheet, $cordovaFileTransfer) {
        $scope.settings = {
            enableFriends: true
        };

        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
        if($scope.user.mobile){
            $scope.user.phoneStatusText ="已绑定手机";
        }else{
            $scope.user.phoneStatusText ="未绑定手机";
        }

        $scope.isAuthenticated = security.isAuthenticated();

        $scope.goLogin = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
            }
        }

        $scope.goAccountDetials = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
               return;
            } else {
                $ionicViewSwitcher.nextDirection('forward');
                $state.go('accountDetial', {}, {reload: true});
            }

        }

        $scope.goOrders = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('orders', {'fromTab':true}, {reload: true});
        }

        $scope.goMessages = function () {
            event.preventDefault();
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('messages', {}, {reload: true});
        }

        $scope.goMyBids = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('myBids', {}, {reload: true});
        }
        $scope.goMyBidCode = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('bidCode', {}, {reload: true});
        }

        $scope.goAccountName = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('changeAccountName', {}, {reload: true});
        }

        $scope.goChangePhone = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('changePhone', {'type':1}, {reload: true});
        }

        $scope.goAddress = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('address', {}, {reload: true});
        }

        $scope.goResetPassword = function () {
            event.preventDefault();
            if (!security.isAuthenticated()) {
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('resetPassword', {}, {reload: true});
        }

        $scope.getAvatar = function () {
            var hideSheet = $ionicActionSheet.show({
                buttons: [
                   { text: '拍摄图片' },
                   { text: '从相册选择' }
                ],
                titleText: '修改头像',
                cancelText: '取消',
                cancel: function() {
                },
                buttonClicked: function(index) {
                    onConfirm(index);
                    return true;
                }
           });
        }

        $scope.images = [];
        $scope.getPhotoDisable = false;
        $scope.sizeLimit      = 10585760; // 10MB in Bytes
        $scope.uploadProgress = 0;
        $scope.creds          = {};

        document.addEventListener("deviceready",onDeviceReady,false);

        var destinationType;
        var pictureSource;
        function onDeviceReady() {
            pictureSource=navigator.camera.PictureSourceType;
            destinationType=navigator.camera.DestinationType;
        }

        onPhotoSuccess = function(results) {
            for (var i = 0; i < results.length; i++) {
                upload(results[i]);
            }
            $scope.$apply();
        };
        onPhotoDataSuccess = function(results) {
            upload(results);
            $scope.$apply();
        };

        onConfirm = function(buttonIndex) {
            if (buttonIndex === 0) {
              return navigator.camera.getPicture(onPhotoDataSuccess, function onFail(message) {
                alert('Failed because: ' + message);
            }, {
                quality: 75,
                allowEdit: true,
                targetWidth: 400,
                targetHeight: 400,
                destinationType: 1,
                sourceType: 1,
                correctOrientation: true,
                saveToPhotoAlbum: true
              });
            } else if (buttonIndex === 1) {
              return window.imagePicker.getPictures(onPhotoSuccess, function onFail(message) {
                alert('Failed because: ' + message);
            }, {
                quality: 75,
                maximumImagesCount: 1,
                allowEdit: false,
                targetWidth: 400,
                targetHeight: 400,
                width: 400,
                height: 400,
                destinationType: 1,
                sourceType: 0,
                correctOrientation: true
              });
            }
        };

        var upload = function(imageUrl) {
            var options = new FileUploadOptions();
                options.fileKey = "upload";
                options.fileName = imageUrl.substr(imageUrl.lastIndexOf('/') + 1);
                options.mimeType = "image/jpeg";
            $cordovaFileTransfer.upload("http://www.youjiacn.com:8000/index.php/home/file/index", imageUrl, options)
                .then(function(result) {
                    var results = JSON.parse(result.response);
                    $scope.user.avatar = results.data.url;
                    setAvatar(results.data.url);
                }, function(err) {
                    console.log(err);
                }, function (progress) {
            });
        };

        var setAvatar = function(imageUrl) {
            var data = {
                'user_id':$scope.user.id,
                'avatar':imageUrl
            }
            Account.setAvatar(data).then(function(res) {
                $scope.user.avatar = imageUrl;
                window.localStorage.setItem('USERS', JSON.stringify($scope.user));
            }, function(err) {
              var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '请检查你的验证码是否正确'
              });
              $ionicLoading.hide();
            });
        };

    }]);

angular.module('SignupList', [])
    .controller('SignupListCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', '$ionicSlideBoxDelegate', 'Bids', '$rootScope', '$timeout', '$ionicLoading', '$ionicModal','$state','$ionicPopup', 'Comment', '$ionicViewSwitcher','$ionicScrollDelegate', '$ionicPopup', '$ionicHistory', 'security', 'AUTH_EVENTS', function ($scope, $http, URLConfig, $stateParams, $ionicSlideBoxDelegate, Bids, $rootScope, $timeout, $ionicLoading, $ionicModal, $state, $ionicPopup, Comment, $ionicViewSwitcher, $ionicScrollDelegate, $ionicPopup, $ionicHistory, security, AUTH_EVENTS) {
        $scope.bidId = $stateParams.bid;

        $scope.loadUsers = function () {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            var data = {
                'biao_id' : $scope.bidId,
            }
            Bids.getUsers(data).then(function (response) {
               $scope.Users = response.data.data;
               $ionicLoading.hide();
               $scope.$broadcast('scroll.refreshComplete');
            }, function (resp) {
               console.log(resp);
               $ionicLoading.hide();
               $scope.$broadcast('scroll.refreshComplete');
            });
        }
        $scope.loadUsers();

    }]);


angular.module('Bids', [])

    .controller('BidsCtrl', ['$scope', '$http', '$ionicPopover', 'URLConfig', '$ionicLoading','$ionicModal' , '$timeout', '$ionicViewSwitcher', '$ionicHistory', '$ionicBackdrop', 'Bids', '$state', function ($scope, $http, $ionicPopover, URLConfig, $ionicLoading, $ionicModal, $timeout, $ionicViewSwitcher, $ionicHistory, $ionicBackdrop, Bids, $state) {
        $scope.type = 2;
        $scope.selectType = function (index) {
            $scope.items = [];
            $scope.type = index;
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            $scope.loadMore();
        }
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };

        $scope.goToBid = function (bid) {
            event.preventDefault();
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('bid', {"id":bid.id,"type":0,"form":0}, {reload: true});
        }
        $scope.items = [];
        $scope.iDisplayStart = 1;

        $scope.isLoad = false;
        $scope.noMoreItemsAvailable = false;

        $scope.loadMore = function() {
            if ($scope.isLoad) {
                return;
            };
            $scope.isLoad = true;
            var loaction = JSON.parse(localStorage.getItem('LOCATION')) || [];
            var data = {
                'city_id': 15,
                'type': $scope.type
            }

            Bids.all(data).then(function (response) {
                if(response.data.data){
                    angular.forEach(response.data.data, function(value, key) {
                        $scope.items.push(value);
                        // $scope.apply();
                    });
                }
                if(response.data.data.length < 10){
                    $scope.noMoreItemsAvailable = true;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                $scope.iDisplayStart +=1;
                $ionicLoading.hide();
                $scope.isLoad = false;
                $scope.finish();

            }, function (resp) {
                console.log(resp);
            });
        };
        $scope.refersh = function() {
            $scope.items = [];
            $scope.iDisplayStart = 1;
            $scope.isLoad = false;
            $scope.noMoreItemsAvailable = false;
            $scope.loadMore();
        }
        $scope.finish = function () {
            angular.forEach($scope.items, function(value, key) {
                if (value.submit_end_time*1000 > new Date().getTime()) {
                    value.Status = true;
                }else {
                    value.Status = false;
                };
            });
        }

        $scope.loadMore();
    }])


angular.module('BidProduct', [])

    .controller('BidProductCtrl', ['$scope', '$stateParams', '$ionicSlideBoxDelegate', 'Bids', 'IntentOrder', '$timeout', '$ionicLoading','$state','$ionicPopup', 'Comment','security', '$rootScope', function ($scope, $stateParams, $ionicSlideBoxDelegate, Bids, IntentOrder, $timeout, $ionicLoading, $state, $ionicPopup, Comment, security, $rootScope) {

        $scope.showPage = false;
        $scope.code = $stateParams.id;
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
        $scope.bid = $stateParams.bid;
        function loadPage(){
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });

            var data = {
                'product_id':$scope.code,
                'biao_id':$scope.bid,
                'user_id': $scope.user.id
            }
            if(!data.user_id){
                data.user_id = 0;
            }
            Bids.productDetail(data).then(function (response) {
                $scope.product = response.data.data;
                if($scope.product.location.distance > 1000){
                    $scope.product.location.distance = Math.round(value.distance/100)/10;
                    $scope.product.location.distanceText = $scope.product.location.distance + 'km';
                }else {
                    $scope.product.location.distanceText = $scope.product.location.distance + 'm';
                }
                if ($scope.product.submit_end_time*1000 > new Date().getTime()) {
                    $scope.product.Status = true;
                }else {
                    $scope.product.Status = false;
                };
                $timeout(function () {
                    $ionicSlideBoxDelegate.$getByHandle('image-viewer').update();
                }, 0);
                $scope.showPage = true;
                $ionicLoading.hide();
            }, function (resp) {
                console.log(resp);
            });
            $scope.reviews = [];
            Comment.get($scope.code).then(function (response) {
                angular.forEach(response.data.data, function(value, key) {
                    if(key < 3){
                        $scope.reviews.push(value);
                    }
                });
            }, function (resp) {
                console.log(resp);
            });
        }
        loadPage();
         $scope.voteProduct = function(product) {
            $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
            if($scope.product.Status){
                var alertPopup = $ionicPopup.alert({
                    title: '温馨提示',
                    template: '商家还没有报价',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }
            if($scope.product.has_signup == 0){
                var alertPopup = $ionicPopup.alert({
                    title: '温馨提示',
                    template: '您还没有报名',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }

            if($scope.product.has_select == 1){
                var alertPopup = $ionicPopup.alert({
                    title: '提示信息',
                    template: '您已经投过票了',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }


            if(!security.isAuthenticated()){
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }else {
                $scope.voteData = {
                    'user_id': $scope.user.id,
                    'deal_id': product.id,
                    'biao_id': $scope.bidId,
                    'supplier_id':product.supplier_id
                }
                var myPopup = $ionicPopup.show({
                    title: '提示信息',
                    subTitle: '您确认要投票给该产品吗？',
                    buttons: [
                      { text: '取消' },
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive',
                        onTap: function(e) {
                            $scope.loading = $ionicLoading.show({
                              showBackdrop: false
                            });
                            Bids.voteProduct($scope.voteData).then(function (response) {
                               $ionicLoading.hide();
                               $scope.refersh();
                               var alertPopup = $ionicPopup.alert({
                                    title: '提示信息',
                                    template: '投票成功，结果出来，系统会自动发放抵用券，凭抵用券到店消费!',
                                    buttons: [
                                      {
                                        text: '<b>确认</b>',
                                        type: 'button-assertive'
                                      }
                                    ]
                                });

                            }, function (resp) {
                               var alertPopup = $ionicPopup.alert({
                                    title: '温馨提示',
                                    template: "分享失败: " + resp.errorMessage,
                                    buttons: [
                                      {
                                        text: '<b>确认</b>',
                                        type: 'button-assertive'
                                      }
                                    ]
                                });
                                alertPopup.then(function(res) {
                                });
                               $ionicLoading.hide();
                            });
                            return;
                        }
                      }
                    ]
                });
            }

        };

        $scope.$on('$ionicView.beforeEnter', function(){
            loadPage();
        });

    }]);


angular.module('BidPost', [])

.controller('BidPostCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'IntentOrder', '$ionicLoading', 'Comment', 'Upload', '$ionicPopup','$cordovaFileTransfer','$ionicHistory','$ionicViewSwitcher', 'Post','$timeout','$state', '$ionicScrollDelegate', '$ionicActionSheet', function ($scope, $http, URLConfig, $stateParams, IntentOrder, $ionicLoading, Comment, Upload, $ionicPopup, $cordovaFileTransfer, $ionicHistory, $ionicViewSwitcher, Post, $timeout, $state,$ionicScrollDelegate, $ionicActionSheet) {
    $scope.goBack = function () {
        $ionicViewSwitcher.nextDirection('back');
        $ionicHistory.goBack();
    };

    $timeout(function() {
        txtInput = document.body.querySelector('.textarea');
    }, 0);

    $scope.configData = {
        addPicture:false
    }
    $scope.showAddPicture = function () {
        $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        cordova.plugins.Keyboard.close();
        cordova.plugins.Keyboard.disableScroll(true);
    }
    $scope.images = [];
    $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
    $scope.id = $stateParams.id;

    $scope.report = function () {
         var hideSheet = $ionicActionSheet.show({
                buttons: [
                   { text: '虚假信息' },
                   { text: '垃圾广告' },
                   { text: '非法信息' }
                ],
                titleText: '举报该帖子',
                cancelText: '取消',
                cancel: function() {
                },
                buttonClicked: function(index) {
                    var reportData = {
                        'tid': $scope.id,
                        'user_id': $scope.user.id,
                        'type': index+1
                    }
                    $scope.loading = $ionicLoading.show({
                      showBackdrop: false
                    });
                    Post.report(reportData).then(function(res) {
                        $ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                            title: '温馨提示',
                            template: '举报成功，等待管理员处理',
                            buttons: [
                              {
                                text: '<b>确认</b>',
                                type: 'button-assertive'
                              }
                            ]
                        });
                    }, function(err) {
                        $ionicLoading.hide();
                    });
                    return true;
                }
           });
    }
    $scope.goToReply = function (id){
        $ionicViewSwitcher.nextDirection('forward');
        $state.go('reply', {"tid":$scope.id,"fid": id, "bid": true}, {reload: true});
    }
    var getPost = function () {
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        Post.getBidPost($scope.id).then(function(res) {
            $ionicLoading.hide();
            $scope.item =  res.data;
        }, function(err) {
            console.log(err);
            $ionicLoading.hide();
        });

    };

    var getComment = function () {

        Post.getBidComment($scope.id).then(function(res) {
            $scope.comments =  res.data.data;
        }, function(err) {
            console.log(err);
        });

    };
    $scope.refersh = function() {
        getPost();
        getComment();
    }
    $scope.$on('$ionicView.beforeEnter', function(){
        $scope.refersh();
    });

    function keepKeyboardOpen() {
      console.log('keepKeyboardOpen');
      txtInput.addEventListener('blur', function() {
        console.log('textarea blur, focus back on it');
        txtInput.focus();
      });
    }

    $scope.commentData = {
        'tid':$scope.id,
        'fid':'',
        'user_id':$scope.user.id,
        'to_user_id': '',
        'content':'',
        'images':''
    }
    $scope.addComment = function(sendCommentForm) {
        keepKeyboardOpen();
        $scope.commentData.to_user_id = $scope.item.user_id;
        Post.addBidComment($scope.commentData).then(function(res) {
            getComment();
            $scope.commentData.content = '';
        }, function(err) {
            console.log(err);
        });
    };

    $scope.photos = [];
    $scope.getPhotoDisable = false;
    $scope.sizeLimit      = 10585760; // 10MB in Bytes
    $scope.uploadProgress = 0;
    $scope.creds          = {};

    document.addEventListener("deviceready",onDeviceReady,false);

    var destinationType;
    var pictureSource;
    function onDeviceReady() {
        pictureSource=navigator.camera.PictureSourceType;
        destinationType=navigator.camera.DestinationType;
    }

    onPhotoSuccess = function(results) {
        for (var i = 0; i < results.length; i++) {
            $scope.photos.push(results[i]);
        }
        $ionicViewSwitcher.nextDirection('forward');
        Post.removePhotos();
        Post.addPhotos($scope.photos);
        $state.go('addPostComment', {"tid":$scope.id,"type":1}, {reload: true});
    };
    onPhotoDataSuccess = function(results) {
        $scope.photos.push(results);
        Post.removePhotos();
        Post.addPhotos($scope.photos);
        $ionicViewSwitcher.nextDirection('forward');
        $state.go('addPostComment', {"tid":$scope.id,"type":1}, {reload: true});
    };

    $scope.getPhoto = function(buttonIndex) {
        if (buttonIndex === 1) {
          return navigator.camera.getPicture(onPhotoDataSuccess, function onFail(message) {
            alert('Failed because: ' + message);
        }, {
            quality: 75,
            allowEdit: false,
            targetWidth: 400,
            targetHeight: 400,
            destinationType: 1,
            sourceType: 1,
            correctOrientation: true,
            saveToPhotoAlbum: true
          });
        } else if (buttonIndex === 2) {
          return window.imagePicker.getPictures(onPhotoSuccess, function onFail(message) {
            alert('Failed because: ' + message);
        }, {
            quality: 75,
            maximumImagesCount: 10,
            width: 400,
            height: 400,
            destinationType: 1,
            sourceType: 0,
            correctOrientation: true
          });
        }
        return false;
    };
 }]);


 angular.module('BidDetials', [])

    .controller('BidDetialsCtrl', ['$scope', '$http', '$stateParams', 'URLConfig', '$ionicLoading','$ionicModal' , '$timeout', '$ionicViewSwitcher', '$ionicHistory', '$ionicBackdrop', 'Bids', '$state', '$rootScope', function ($scope, $http, $stateParams, URLConfig, $ionicLoading, $ionicModal, $timeout, $ionicViewSwitcher, $ionicHistory, $ionicBackdrop, Bids, $state, $rootScope) {

        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };
        $scope.id = $stateParams.id;
        $scope.showPage = false;
        $scope.loadMore = function() {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            $scope.product = Bids.getProductDetail();
            $scope.showPage = true;
            $ionicLoading.hide();
        };
        $scope.loadMore();
    }]);

angular.module('Bid', [])
    .controller('BidCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', '$ionicSlideBoxDelegate', 'Bids', '$rootScope', '$timeout', '$ionicLoading', '$ionicModal','$state','$ionicPopup', 'Comment', '$ionicViewSwitcher','$ionicScrollDelegate', '$ionicPopup', '$ionicHistory', 'security', 'AUTH_EVENTS', '$document', '$ionicActionSheet', function ($scope, $http, URLConfig, $stateParams, $ionicSlideBoxDelegate, Bids, $rootScope, $timeout, $ionicLoading, $ionicModal, $state, $ionicPopup, Comment, $ionicViewSwitcher, $ionicScrollDelegate, $ionicPopup, $ionicHistory, security, AUTH_EVENTS, $document, $ionicActionSheet) {
        $scope.bidId = $stateParams.id;
        $scope.showPage = false;
        $scope.slideIndex = $stateParams.type;
        $scope.showBackBtn = $stateParams.form==1?false:true;
        $scope.questionActive = true;
        $scope.items = [];
        $scope.iDisplayStart = 1;
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];

        $scope.isLoad = false;
        $scope.noMoreItemsAvailable = false;
        $scope.goToPost = function (id) {
            event.preventDefault();
            if(!security.isAuthenticated()){
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('bidPosts', {"id":id}, {reload: true});
        }

        $scope.goToSignUpList= function () {
            event.preventDefault();
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('signuplist', {"bid":$scope.bidId}, {reload: true});
        }

         $scope.goProduct= function (id) {
            event.preventDefault();
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('bidProduct', {"id":id,"bid":$scope.bidId}, {reload: true});
        }
        $scope.goBack = function () {
            event.preventDefault();
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        };

        $scope.goAddPost = function () {
            event.preventDefault();
            if(!security.isAuthenticated()){
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            $ionicViewSwitcher.nextDirection('forward');
            $state.go('addBidPost', {'biao_id': $scope.bidId}, {reload: true});
        }

        $scope.loadIntention = function () {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            var data = {
                'biao_id' : $scope.bidId,
                'user_id' : $scope.user.id?$scope.user.id:''
            }
            Bids.bidIntention(data).then(function (response) {
               $scope.Intention = response.data;
                if ($scope.Intention.data.info.submit_end_time*1000 > new Date().getTime()) {
                    $scope.Intention.data.info.Status = true;
                }else {
                    $scope.Intention.data.info.Status = false;
                };
                if ($scope.Intention.data.info.event_end_time*1000 > new Date().getTime()) {
                    $scope.Intention.data.info.eventStatus = true;
                }else {
                    $scope.Intention.data.info.eventStatus = false;
                };
                if ($scope.Intention.data.info.event_begin_time*1000 < new Date().getTime()) {
                    $scope.Intention.data.info.eventStartStatus = true;
                }else {
                    $scope.Intention.data.info.eventStartStatus = false;
                };
                if($scope.Intention.data.signup_list.length>4){
                    $scope.Intention.data.showMore = true;
                }else {
                    $scope.Intention.data.showMore = false;
                }

               $scope.showPage = true;
               $ionicLoading.hide();
            }, function (resp) {
               console.log(resp);
               $ionicLoading.hide();
            });
        }

        $scope.loadProducts = function () {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            var data = {
                'biao_id' : $scope.bidId,
                'user_id' : $scope.user.id
            }
            Bids.getProducts(data).then(function (response) {
                $scope.Products = response.data.data;
                angular.forEach($scope.Products, function(value, key) {
                    if(value.select_list.length>4){
                        value.showMore = true;
                    }else {
                        value.showMore = false;
                    }

                });
               $ionicLoading.hide();
            }, function (resp) {
               console.log(resp);
               $ionicLoading.hide();
            });
        }
        $scope.loadBBS = function() {
            $scope.loading = $ionicLoading.show({
              showBackdrop: false
            });
            if ($scope.isLoad) {
                return;
            };
            $scope.isLoad = true;
            var loaction = JSON.parse(localStorage.getItem('LOCATION')) || [];
            var data = {
                'p': $scope.iDisplayStart,
                'user_id' : $scope.user.user_id,
                'biao_id' : $scope.bidId,
                'city_id' : 15
            }
            $http({
                method: 'GET',
                url: URLConfig.API_BASEURL + "index.php/home/biao/postlist",
                params: data
            })
            .then(function(response){
                if(response.data.data.list){
                    angular.forEach(response.data.data.list, function(value, key) {
                        value.praise_text = value.praise_count==0?'赞':value.praise_count;
                        value.comment_text = value.comment_count==0?'评论': value.comment_count;
                        value.is_praise = value.has_praise==1?true:false;
                        $scope.items.push(value);
                    });
                }
                if(response.data.data.list){
                    if(response.data.data.list.length < 10){
                        $scope.noMoreItemsAvailable = true;
                    }
                }else {
                    $scope.noMoreItemsAvailable = true;
                }

                $scope.tops = response.data.data.top;
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                $scope.iDisplayStart +=1;
                $ionicLoading.hide();
                $scope.isLoad = false;
            },function(res){
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                $ionicLoading.hide();
                $scope.isLoad = false;
            });
        };

        $scope.refersh = function() {
            $scope.items = [];
            $scope.iDisplayStart = 1;
            $scope.isLoad = false;
            $scope.noMoreItemsAvailable = false;
            $scope.loadBBS();
            $scope.loadProducts();
            $scope.loadIntention();
        }
        $scope.refersh();
        $scope.slideChanged = function(index) {
            $ionicScrollDelegate.scrollTop(false);
            $scope.slideIndex = index;
            if (index == 1) {
                // $scope.refersh();
            };
            $timeout( function() {
                $ionicScrollDelegate.resize();
            }, 1000);
        };

        $scope.showPopup = function() {
            if(!$scope.Intention.data.info.eventStatus){
                var alertPopup = $ionicPopup.alert({
                    title: '温馨提示',
                    template: '活动已经结束',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }
            if(!$scope.Intention.data.info.eventStartStatus){
                var alertPopup = $ionicPopup.alert({
                    title: '温馨提示',
                    template: '活动还未开始，敬请期待',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }

            if($scope.Intention.data.info.has_signup == 1){
                var alertPopup = $ionicPopup.alert({
                    title: '提示信息',
                    template: '您已经报过名了',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }

            if(!security.isAuthenticated()){
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }else {
                $scope.data = {
                    'name':$scope.user.nickname,
                    'user_id':$scope.user.id,
                    'mobile': $scope.user.mobile,
                    'biao_id':$scope.bidId
                }
                if(!$scope.user.mobile){
                     var alertPopup = $ionicPopup.alert({
                        title: '提示信息',
                        template: '请先绑定您的手机号',
                        buttons: [
                          {
                            text: '<b>确认</b>',
                            type: 'button-assertive'
                          }
                        ]
                    });
                    alertPopup.then(function(res) {
                    });
                    $ionicViewSwitcher.nextDirection('forward');
                    $state.go('changePhone', {'type':0}, {reload: true});
                    return;
                }
                var myPopup = $ionicPopup.show({
                    template: '<label class="item item-input"><span class="input-label">姓名</span><input type="text" name="name" ng-model="data.name" placeholder="请填写您的真实姓名" ng-disabled="true" required></label><label class="item item-input"><span class="input-label">小区</span><input type="text" name="community" ng-model="data.community" placeholder="请填写您所在的小区"  required></label><label class="item item-input"><span class="input-label">电话</span><input type="tel" name="mobile" ng-model="data.mobile" placeholder="请填写您的手机号用于接收活动通知" ng-disabled="true" required></label>',
                    title: '拼标报名!',
                    subTitle: '报名信息如下',
                    scope: $scope,
                    buttons: [
                      { text: '取消' },
                      {
                        text: '<b>提交</b>',
                        type: 'button-assertive',
                        onTap: function(e) {
                            if (!$scope.data.name||!$scope.data.mobile||!$scope.data.community) {
                                e.preventDefault();
                                navigator.notification.alert('请填写您所在的小区', null, "温馨提示", "关闭");
                                return;
                            } else {
                                $scope.loading = $ionicLoading.show({
                                  showBackdrop: false
                                });
                                Bids.signUp($scope.data).then(function (response) {
                                   $ionicLoading.hide();
                                   $scope.refersh();
                                   var alertPopup = $ionicPopup.alert({
                                        title: '提示信息',
                                        template: '报名成功，等待商家报价，静待佳音!',
                                        buttons: [
                                          {
                                            text: '<b>确认</b>',
                                            type: 'button-assertive'
                                          }
                                        ]
                                    });
                                }, function (resp) {
                                   console.log(resp);
                                   $ionicLoading.hide();
                                });
                                return;
                            }
                        }
                      }
                    ]
                });
            }

        };

        $scope.voteProduct = function(product) {
            if(!$scope.Intention.data.info.eventStatus){
                var alertPopup = $ionicPopup.alert({
                    title: '温馨提示',
                    template: '活动已经结束',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }
            if(!$scope.Intention.data.info.eventStartStatus){
                var alertPopup = $ionicPopup.alert({
                    title: '温馨提示',
                    template: '活动还未开始，敬请期待',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }
            if($scope.Intention.data.info.has_signup == 0){
                var alertPopup = $ionicPopup.alert({
                    title: '温馨提示',
                    template: '您还没有报名',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }

            if($scope.Intention.data.info.has_select == 1){
                var alertPopup = $ionicPopup.alert({
                    title: '温馨提示',
                    template: '本次活动您已投票',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }


            if(!security.isAuthenticated()){
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }else {
                $scope.voteData = {
                    'user_id': $scope.user.id,
                    'deal_id': product.id,
                    'biao_id': $scope.bidId,
                    'supplier_id':product.supplier_id
                }
                var myPopup = $ionicPopup.show({
                    title: '温馨提示',
                    subTitle: '您确认要投票给该产品吗？',
                    buttons: [
                      { text: '取消' },
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive',
                        onTap: function(e) {
                            $scope.loading = $ionicLoading.show({
                              showBackdrop: false
                            });
                            Bids.voteProduct($scope.voteData).then(function (response) {
                               $ionicLoading.hide();
                               $scope.refersh();
                               var alertPopup = $ionicPopup.alert({
                                    title: '温馨提示',
                                    template: '投票成功，结果出来，系统会自动发放优惠券，凭优惠券到店消费!',
                                    buttons: [
                                      {
                                        text: '<b>确认</b>',
                                        type: 'button-assertive'
                                      }
                                    ]
                                });
                            }, function (resp) {
                               console.log(resp);
                               $ionicLoading.hide();
                            });
                            return;
                        }
                      }
                    ]
                });
            }

        };


        $scope.addVote = function (question, answer) {
            if(!$scope.Intention.data.info.eventStatus){
                var alertPopup = $ionicPopup.alert({
                    title: '温馨提示',
                    template: '活动已经结束',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }
            if(!$scope.Intention.data.info.eventStartStatus){
                var alertPopup = $ionicPopup.alert({
                    title: '温馨提示',
                    template: '活动还未开始，敬请期待',
                    buttons: [
                      {
                        text: '<b>确认</b>',
                        type: 'button-assertive'
                      }
                    ]
                });
                alertPopup.then(function(res) {
                });
                return;
            }
            if(!security.isAuthenticated()){
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            if (question.has_vote == 1) {
                return;
            };
            var data = {
                'item_id' : answer.id,
                'user_id' : $scope.user.id,
                'vote_id' : question.id
            }
            Bids.addVote(data).then(function (response) {
               $scope.loadIntention();
            }, function (resp) {
               console.log(resp);
               $ionicLoading.hide();
            });
        }

        $scope.like = function (item) {
            event.preventDefault();
            if(!security.isAuthenticated()){
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
                return;
            }
            var data = {
                'tid' : item.id,
                'user_id' : $scope.user.id,
                'to_user_id':item.user_id
            }
            angular.forEach($scope.items, function(value, key) {
                if(item.id == value.id){
                    if(value.has_praise == 1){
                        if(value.praise_count!=0)
                            value.praise_count = parseInt(value.praise_count) - 1;
                        value.has_praise = 0;
                    }else {
                        value.praise_count = parseInt(value.praise_count) + 1;
                        value.has_praise = 1;
                    }
                    value.praise_text = value.praise_count==0?'赞':value.praise_count;
                    value.is_praise = value.has_praise==1?true:false;
                }
            });
            Post.like(data).then(function(res) {
                console.log(res);
            }, function(err) {
                console.log(err);
            });
        }
        Wechat.isInstalled(function (installed) {
            $scope.wechatIsInstalled = installed;
        }, function (reason) {
            alert("Failed: " + reason);
        });
        YCQQ.checkClientInstalled(function(){
            $scope.qqIsInstalled = true;
        },function(){
            $scope.qqIsInstalled = false;
        });
        YCWeibo.checkClientInstalled(function(){
            $scope.weiBoIsInstalled = true;
        },function(){
            $scope.weiBoIsInstalled = false;
        });

        $scope.share = function() {
        var buttons= [{
                optionText: '微信朋友圈',
                isShow: $scope.wechatIsInstalled,
                confirm:function(){
                    Wechat.share({
                    message: {
                        title: $scope.Intention.data.info.name,
                        description: $scope.Intention.data.info.brief,
                        thumb: $scope.Intention.data.info.img,
                        mediaTagName:'WECHAT_TAG_PINBIAO_APP',
                        messageExt: "这是第三方带的测试字段",
                        messageAction: "<action>dotalist</action>",
                        media: {
                            type: Wechat.Type.WEBPAGE,
                            webpageUrl:$scope.Intention.data.share_url
                        }
                    },
                    scene: Wechat.Scene.TIMELINE
                }, function () {
                    var alertPopup = $ionicPopup.alert({
                        title: '温馨提示',
                        template: '分享成功!',
                        buttons: [
                          {
                            text: '<b>确认</b>',
                            type: 'button-assertive'
                          }
                        ]
                    });
                    alertPopup.then(function(res) {
                    });
                }, function (reason) {
                    var alertPopup = $ionicPopup.alert({
                        title: '温馨提示',
                        template: "分享失败: " + reason,
                        buttons: [
                          {
                            text: '<b>确认</b>',
                            type: 'button-assertive'
                          }
                        ]
                    });
                    alertPopup.then(function(res) {
                    });
                });
                }
            },
            {
                optionText: '微信',
                isShow: $scope.wechatIsInstalled,
                confirm:function(){
                     Wechat.share({
                        message: {
                            title: $scope.Intention.data.info.name,
                            description: $scope.Intention.data.info.brief,
                            mediaTagName:'WECHAT_TAG_PINBIAO_APP',
                            thumb: $scope.Intention.data.info.img,
                            messageExt: "这是第三方带的测试字段",
                            messageAction: "<action>dotalist</action>",
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl:$scope.Intention.data.share_url
                            }
                        },
                        scene: Wechat.Scene.SESSION
                    }, function () {
                        var alertPopup = $ionicPopup.alert({
                            title: '温馨提示',
                            template: '分享成功!',
                            buttons: [
                              {
                                text: '<b>确认</b>',
                                type: 'button-assertive'
                              }
                            ]
                        });
                        alertPopup.then(function(res) {
                        });
                    }, function (reason) {
                        var alertPopup = $ionicPopup.alert({
                            title: '温馨提示',
                            template: "分享失败: " + reason,
                            buttons: [
                              {
                                text: '<b>确认</b>',
                                type: 'button-assertive'
                              }
                            ]
                        });
                        alertPopup.then(function(res) {
                        });
                    });
                }
            },
            {
                optionText: 'QQ好友',
                isShow: $scope.qqIsInstalled,
                confirm: function(){
                     var args = {};
                    args.url = $scope.Intention.data.share_url;
                    args.title = $scope.Intention.data.info.name;
                    args.description = $scope.Intention.data.info.brief;
                    args.imageUrl = $scope.Intention.data.info.img;
                    args.appName = "拼标网";
                    YCQQ.shareToQQ(function(){
                        console.log('分享成功');
                    },function(failReason){
                        alert("分享失败: " + failReason);
                    },args);
                }
            },
            {
                optionText: '新浪微博',
                isShow: $scope.weiBoIsInstalled,
                confirm: function(){
                    var args = {};
                    args.url = $scope.Intention.data.share_url;
                    args.title = $scope.Intention.data.info.name;
                    args.description = $scope.Intention.data.info.brief;
                    args.imageUrl = $scope.Intention.data.info.img;
                    args.defaultText = "拼标网";
                    YCWeibo.shareToWeibo(function () {
                        console.log('分享成功');
                    }, function (failReason) {
                        var alertPopup = $ionicPopup.alert({
                            title: '温馨提示',
                            template: "分享失败: " + reason,
                            buttons: [
                              {
                                text: '<b>确认</b>',
                                type: 'button-assertive'
                              }
                            ]
                        });
                        alertPopup.then(function(res) {
                        });
                    }, args);
                }
            }
        ];

            var buttonsGroup = [];
            var confirmGroup = [];
            for (var i = 0; i < buttons.length; i++) {
                if(buttons[i].isShow){
                    var text = {"text":buttons[i].optionText};
                    buttonsGroup.push(text);
                    confirmGroup.push(buttons[i].confirm);
                }
            }
            var hideSheet = $ionicActionSheet.show({
                buttons: buttonsGroup,
                titleText: '分享到',
                cancelText: '取消',
                cancel: function() {
                },
                buttonClicked: function(index) {
                    confirmGroup[index]();
                    return true;
                }
           });
        };

        var onConfirm = function (index){

            if (index === 0) {

            }else  if(index === 1){

            }else if(index === 2){

            }else if(index === 3){

            }
        }
        $scope.$on('$ionicView.beforeEnter', function(){
            $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
            $scope.items = [];
            $scope.iDisplayStart = 1;
            $scope.isLoad = false;
            $scope.noMoreItemsAvailable = false;
            $scope.loadBBS();
        });

    }]);


angular.module('AddBidPost', [])

.controller('AddBidPostCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'IntentOrder', '$ionicLoading', 'Comment', 'Upload', '$ionicPopup','$cordovaFileTransfer','$ionicHistory','$ionicViewSwitcher', 'Post', '$ionicActionSheet', function ($scope, $http, URLConfig, $stateParams, IntentOrder, $ionicLoading, Comment, Upload, $ionicPopup, $cordovaFileTransfer, $ionicHistory, $ionicViewSwitcher, Post, $ionicActionSheet) {

    $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
    $scope.biao_id = $stateParams.biao_id;
    $scope.Data = {
        'content' : '',
        'user_id': $scope.user.id,
        'biao_id': $scope.biao_id,
        'city_id': 15,
        'images': ''
    }

    $scope.images = [];
    $scope.photos = [];
    $scope.getPhotoDisable = false;
    $scope.sizeLimit      = 10585760; // 10MB in Bytes
    $scope.uploadProgress = 0;
    $scope.creds          = {};

    document.addEventListener("deviceready",onDeviceReady,false);

    var destinationType;
    var pictureSource;
    function onDeviceReady() {
        pictureSource=navigator.camera.PictureSourceType;
        destinationType=navigator.camera.DestinationType;
    }

    onPhotoSuccess = function(results) {
        if ($scope.photos.length + results.length >10) {
            alert('最多十张');
            return;
        }else if ($scope.photos.length >10) {
            $scope.getPhotoDisable = true;
        };
        for (var i = 0; i < results.length; i++) {
            upload(results[i]);
        }
        $scope.$apply();
    };
    onPhotoDataSuccess = function(results) {
        if ($scope.photos.length>10) {
            alert('最多十张');
            $scope.getPhotoDisable = true;
            return;
        };
        upload(results);
        $scope.$apply();
    };

    onConfirm = function(buttonIndex) {
        if (buttonIndex === 0) {
          return navigator.camera.getPicture(onPhotoDataSuccess, function onFail(message) {
            alert('Failed because: ' + message);
        }, {
            quality: 75,
            allowEdit: false,
            targetWidth: 400,
            targetHeight: 400,
            destinationType: 1,
            sourceType: 1,
            correctOrientation: true,
            saveToPhotoAlbum: true
          });
        } else if (buttonIndex === 1) {
          return window.imagePicker.getPictures(onPhotoSuccess, function onFail(message) {
            alert('Failed because: ' + message);
        }, {
            quality: 75,
            maximumImagesCount: 10,
            width: 400,
            height: 400,
            destinationType: 1,
            sourceType: 0,
            correctOrientation: true
          });
        }
    };

    $scope.getPhoto = function () {
        var hideSheet = $ionicActionSheet.show({
            buttons: [
               { text: '拍摄图片' },
               { text: '从相册选择' }
            ],
            titleText: '上传图片',
            cancelText: '取消',
            cancel: function() {
            },
            buttonClicked: function(index) {
                onConfirm(index);
                return true;
            }
       });
    }

    var upload = function(imageUrl) {
        var options = new FileUploadOptions();
            options.fileKey = "upload";
            options.fileName = imageUrl.substr(imageUrl.lastIndexOf('/') + 1);
            options.mimeType = "image/jpeg";
        $cordovaFileTransfer.upload("http://www.youjiacn.com:8000/index.php/home/file/index", imageUrl, options)
            .then(function(result) {
                var results = JSON.parse(result.response);
                $scope.images.push(results.data.url);
                $scope.photos.push(results.data.url);
            }, function(err) {
                console.log(err);
            }, function (progress) {
        });
    };

    $scope.addPost = function (isValid) {
        if (!isValid) {
          return;
        }
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        if($scope.images.length!=0){
            $scope.Data.images = JSON.stringify($scope.images);
        }
        Post.addBidPost($scope.Data).then(function(res) {
            $ionicLoading.hide();
            $ionicViewSwitcher.nextDirection('back');
            $ionicHistory.goBack();
        }, function(err) {
            console.log(err);
            $ionicLoading.hide();
        });
    };
 }])

angular.module('Reply', [])

.controller('ReplyCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'IntentOrder', '$ionicLoading', 'Comment', 'Upload', '$ionicPopup','$cordovaFileTransfer','$ionicHistory','$ionicViewSwitcher', 'Post','$timeout','$state', '$ionicScrollDelegate', function ($scope, $http, URLConfig, $stateParams, IntentOrder, $ionicLoading, Comment, Upload, $ionicPopup, $cordovaFileTransfer, $ionicHistory, $ionicViewSwitcher, Post, $timeout, $state,$ionicScrollDelegate) {
    $scope.goBack = function () {
        $ionicViewSwitcher.nextDirection('back');
        $ionicHistory.goBack();
    };
    $scope.placeholder = '我也有话说';

    $scope.replyReply = function (reply) {
        txtInput.focus();
        $scope.placeholder ='回复 '+ reply.nickname+':';
        $scope.ReplyData.to_user_id = reply.user_id;
        $scope.ReplyData.reply_status = 1;
    }
    $timeout(function() {
        txtInput = document.body.querySelector('.textarea');
    }, 0);

    $scope.configData = {
        addEmoji:false
    }

    $scope.showAddPicture = function () {
        $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        cordova.plugins.Keyboard.close();
    }
    $scope.images = [];
    $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
    $scope.tid = $stateParams.tid;
    $scope.fid = $stateParams.fid;
    $scope.bid = $stateParams.bid;

    var getReply = function () {
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        if($scope.bid == 'true'){

            Post.getBidReply($scope.fid).then(function(res) {
                $scope.replys =  res.data.data;
                if($scope.replys.length!=0){
                    $scope.ReplyData.to_user_id = $scope.replys.content.user_id;
                }
                $ionicLoading.hide();
            }, function(err) {
                console.log(err);
                $ionicLoading.hide();
            });
        }else {
            Post.getReply($scope.fid).then(function(res) {
                $scope.replys =  res.data.data;
                if($scope.replys.length!=0){
                    $scope.ReplyData.to_user_id = $scope.replys.content.user_id;
                }
                $ionicLoading.hide();
            }, function(err) {
                console.log(err);
                $ionicLoading.hide();
            });
        }


    };

    getReply();

    function keepKeyboardOpen() {
      console.log('keepKeyboardOpen');
      txtInput.addEventListener('blur', function() {
        console.log('textarea blur, focus back on it');
        txtInput.focus();
        $scope.placeholder = '我也有话说';
      });
    }

    $scope.ReplyData = {
        'tid':$scope.tid,
        'fid': $scope.fid,
        'user_id':$scope.user.id,
        'to_user_id': '',
        'reply_status': 0,
        'content':'',
        'images':''

    }
    $scope.addReply = function(sendReplyForm) {

        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });

        if($scope.bid == 'true'){
            Post.addBidComment($scope.ReplyData).then(function(res) {
                getReply();
                $scope.ReplyData.content = '';
                $ionicLoading.hide();

            }, function(err) {
                console.log(err);
                $ionicLoading.hide();
            });
        }else {
            Post.addReply($scope.ReplyData).then(function(res) {
                getReply();
                $scope.ReplyData.content = '';
                $scope.ReplyData.reply_status = 0;
                $ionicLoading.hide();

            }, function(err) {
                console.log(err);
                $ionicLoading.hide();
            });
        }
        keepKeyboardOpen();
    };
 }]);


angular.module('Posts', [])

.controller('PostsCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'IntentOrder', '$ionicLoading', 'Comment', 'Upload', '$ionicPopup','$cordovaFileTransfer','$ionicHistory','$ionicViewSwitcher', 'Post','$timeout','$state', '$ionicScrollDelegate', '$ionicActionSheet', function ($scope, $http, URLConfig, $stateParams, IntentOrder, $ionicLoading, Comment, Upload, $ionicPopup, $cordovaFileTransfer, $ionicHistory, $ionicViewSwitcher, Post, $timeout, $state,$ionicScrollDelegate, $ionicActionSheet) {
    $scope.goBack = function () {
        $ionicViewSwitcher.nextDirection('back');
        $ionicHistory.goBack();
    };

    $timeout(function() {
        txtInput = document.body.querySelector('.textarea');
    }, 0);

    $scope.configData = {
        addPicture:false
    }
    $scope.showAddPicture = function () {
        $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        cordova.plugins.Keyboard.close();
        cordova.plugins.Keyboard.disableScroll(true);
    }
    $scope.images = [];
    $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
    $scope.id = $stateParams.id;
    $scope.type = $stateParams.type;
    $scope.showGoBack = $scope.type=="message"?true:false;

    $scope.report = function () {
         var hideSheet = $ionicActionSheet.show({
                buttons: [
                   { text: '虚假信息' },
                   { text: '垃圾广告' },
                   { text: '非法信息' }
                ],
                titleText: '举报该帖子',
                cancelText: '取消',
                cancel: function() {
                },
                buttonClicked: function(index) {
                    var reportData = {
                        'tid': $scope.id,
                        'user_id': $scope.user.id,
                        'type': index+1
                    }
                    $scope.loading = $ionicLoading.show({
                      showBackdrop: false
                    });
                    Post.report(reportData).then(function(res) {
                        $ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                            title: '温馨提示',
                            template: '举报成功，等待管理员处理',
                            buttons: [
                              {
                                text: '<b>确认</b>',
                                type: 'button-assertive'
                              }
                            ]
                        });
                    }, function(err) {
                        $ionicLoading.hide();
                    });
                    return true;
                }
        });
    }

    $scope.goToReply = function (id){
        $ionicViewSwitcher.nextDirection('forward');
        $state.go('reply', {"tid":$scope.id,"fid": id,"bid": false}, {reload: true});
    }
    var getPost = function () {
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        Post.get($scope.id).then(function(res) {
            $ionicLoading.hide();
            $scope.item =  res.data;
        }, function(err) {
            console.log(err);
            $ionicLoading.hide();
        });

    };

    var getComment = function () {

        Post.getComment($scope.id).then(function(res) {
            $scope.comments =  res.data.data;
        }, function(err) {
            console.log(err);
        });

    };
    $scope.refersh = function() {
        getPost();
        getComment();
    }

    $scope.$on('$ionicView.beforeEnter', function(){
        $scope.refersh();
    });

    function keepKeyboardOpen() {
      console.log('keepKeyboardOpen');
      txtInput.addEventListener('blur', function() {
        console.log('textarea blur, focus back on it');
        txtInput[0].focus();
      });
    }

    $scope.commentData = {
        'tid':$scope.id,
        'fid':'',
        'user_id':$scope.user.id,
        'to_user_id': '',
        'content':'',
        'images':''
    }
    $scope.addComment = function(sendCommentForm) {
        keepKeyboardOpen();
        $scope.commentData.to_user_id = $scope.item.user_id;
        Post.addComment($scope.commentData).then(function(res) {
            getComment();
            $scope.commentData.content = '';
        }, function(err) {
            console.log(err);
        });
    };

    $scope.photos = [];
    $scope.getPhotoDisable = false;
    $scope.sizeLimit      = 10585760; // 10MB in Bytes
    $scope.uploadProgress = 0;
    $scope.creds          = {};

    document.addEventListener("deviceready",onDeviceReady,false);

    var destinationType;
    var pictureSource;
    function onDeviceReady() {
        pictureSource=navigator.camera.PictureSourceType;
        destinationType=navigator.camera.DestinationType;
    }

    onPhotoSuccess = function(results) {
        for (var i = 0; i < results.length; i++) {
            $scope.photos.push(results[i]);
        }
        $ionicViewSwitcher.nextDirection('forward');
        Post.removePhotos();
        Post.addPhotos($scope.photos);
        $state.go('addPostComment', {"tid":$scope.id,"type":0}, {reload: true});
    };
    onPhotoDataSuccess = function(results) {
        $scope.photos.push(results);
        Post.removePhotos();
        Post.addPhotos($scope.photos);
        $ionicViewSwitcher.nextDirection('forward');
        $state.go('addPostComment', {"tid":$scope.id,"type":0}, {reload: true});
    };

    $scope.getPhoto = function(buttonIndex) {
        if (buttonIndex === 1) {
          return navigator.camera.getPicture(onPhotoDataSuccess, function onFail(message) {
            alert('Failed because: ' + message);
        }, {
            quality: 75,
            allowEdit: false,
            targetWidth: 400,
            targetHeight: 400,
            destinationType: 1,
            sourceType: 1,
            correctOrientation: true,
            saveToPhotoAlbum: true
          });
        } else if (buttonIndex === 2) {
          return window.imagePicker.getPictures(onPhotoSuccess, function onFail(message) {
            alert('Failed because: ' + message);
        }, {
            quality: 75,
            maximumImagesCount: 10,
            width: 400,
            height: 400,
            destinationType: 1,
            sourceType: 0,
            correctOrientation: true
          });
        }
        return false;
    };
 }]);


angular.module('BBS', [])
.controller('BBSCtrl', ['$scope', '$http', 'TuanGou', '$ionicPopover', 'URLConfig', '$ionicLoading','$ionicModal' , '$state', '$ionicViewSwitcher', '$ionicHistory', 'Post', 'security', 'AUTH_EVENTS', '$rootScope', function ($scope, $http, TuanGou, $ionicPopover, URLConfig, $ionicLoading, $ionicModal, $state, $ionicViewSwitcher, $ionicHistory, Post, security, AUTH_EVENTS, $rootScope) {
    $scope.goAddPost = function () {
        event.preventDefault();
        if(!security.isAuthenticated()) {
            $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
            return;
        }
        $ionicViewSwitcher.nextDirection('forward');
        $state.go('addPost', {}, {reload: true});
    }

    $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];

    $scope.goToPost = function (id) {
        event.preventDefault();
        $ionicViewSwitcher.nextDirection('forward');
        $state.go('posts', {"id":id,"type":'bbs'}, {reload: true});
    }

    $scope.like = function (item) {
        event.preventDefault();
        if(!security.isAuthenticated()){
            $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
            return;
        }
        var data = {
            'tid' : item.id,
            'user_id' : $scope.user.id,
            'to_user_id':item.user_id
        }
        angular.forEach($scope.items, function(value, key) {
            if(item.id == value.id){
                if(value.has_praise == 1){
                    if(value.praise_count!=0)
                        value.praise_count = parseInt(value.praise_count) - 1;
                    value.has_praise = 0;
                }else {
                    value.praise_count = parseInt(value.praise_count) + 1;
                    value.has_praise = 1;
                }
                value.praise_text = value.praise_count==0?'赞':value.praise_count;
                value.is_praise = value.has_praise==1?true:false;
            }
        });
        Post.like(data).then(function(res) {
        }, function(err) {
            console.log(err);
        });
    }
    $scope.items = [];
    $scope.iDisplayStart = 1;

    $scope.isLoad = false;
    $scope.noMoreItemsAvailable = false;

    $scope.type = '';

    $scope.loadMore = function(user_id, type) {

        if ($scope.isLoad) {
            return;
        };
        $scope.isLoad = true;
        var loaction = JSON.parse(localStorage.getItem('LOCATION')) || [];
        var data = {
            'p': $scope.iDisplayStart,
            'user_id' : user_id,
            'city_id' : 15,
            'type': type
        }
        $http({
            method: 'GET',
            url: URLConfig.API_BASEURL + "index.php/home/bbs/getlist",
            params: data
        })
        .then(function(response){
            $scope.count = response.data.data.count;
            if(response.data.data.list){
                angular.forEach(response.data.data.list, function(value, key) {
                    value.praise_text = value.praise_count==0?'赞':value.praise_count;
                    value.comment_text = value.comment_count==0?'评论': value.comment_count;
                    value.is_praise = value.has_praise==1?true:false;
                    $scope.items.push(value);
                });
            }else{
                $scope.noMoreItemsAvailable = true;
            }
            if(response.data.data.list){
                if(response.data.data.list.length < 10){
                    $scope.noMoreItemsAvailable = true;
                }
            }


            $scope.tops = response.data.data.top;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.$broadcast('scroll.refreshComplete');
            $scope.iDisplayStart +=1;
            $ionicLoading.hide();
            $scope.isLoad = false;
        },function(res){
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.$broadcast('scroll.refreshComplete');
            $ionicLoading.hide();
            $scope.isLoad = false;
        });
    };

    $scope.refersh = function(user_id, type) {
        if(!security.isAuthenticated() && type!='') {
            $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
            return;
        }
        $scope.items = [];
        $scope.iDisplayStart = 1;
        $scope.isLoad = false;
        $scope.noMoreItemsAvailable = false;
        $scope.type = type;
        $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
        $scope.loadMore($scope.user.id, type);
    }

    $scope.$on('$ionicView.beforeEnter', function(){
        $scope.refersh($scope.user.id,$scope.type);
    });
 }])


angular.module('AddPost', [])

.controller('AddPostCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'IntentOrder', '$ionicLoading', 'Comment', 'Upload', '$ionicPopup','$cordovaFileTransfer','$ionicHistory','$ionicViewSwitcher', 'Post','$ionicActionSheet', 'AUTH_EVENTS', '$rootScope','$timeout','$state',function ($scope, $http, URLConfig, $stateParams, IntentOrder, $ionicLoading, Comment, Upload, $ionicPopup, $cordovaFileTransfer, $ionicHistory, $ionicViewSwitcher, Post, $ionicActionSheet, AUTH_EVENTS, $rootScope, $timeout, $state) {

    $scope.goBack = function () {
        $ionicViewSwitcher.nextDirection('back');
        $ionicHistory.goBack();
    };

    $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];

    $scope.Data = {
        'content' : '',
        'user_id': $scope.user.id,
        'city_id': 15,
        'images': ''
    }

    $scope.images = [];
    $scope.photos = [];
    $scope.getPhotoDisable = false;
    $scope.sizeLimit      = 10585760; // 10MB in Bytes
    $scope.uploadProgress = 0;
    $scope.creds          = {};

    document.addEventListener("deviceready",onDeviceReady,false);

    var destinationType;
    var pictureSource;
    function onDeviceReady() {
        pictureSource=navigator.camera.PictureSourceType;
        destinationType=navigator.camera.DestinationType;
    }

    onPhotoSuccess = function(results) {
        if ($scope.photos.length + results.length >10) {
            alert('最多十张');
            return;
        }else if ($scope.photos.length >10) {
            $scope.getPhotoDisable = true;
        };
        for (var i = 0; i < results.length; i++) {
            upload(results[i]);
        }
        $scope.$apply();
    };
    onPhotoDataSuccess = function(results) {
        if ($scope.photos.length>10) {
            alert('最多十张');
            $scope.getPhotoDisable = true;
            return;
        };
        upload(results);
        $scope.$apply();
    };

    onConfirm = function(buttonIndex) {
        if (buttonIndex === 0) {
          return navigator.camera.getPicture(onPhotoDataSuccess, function onFail(message) {
            alert('Failed because: ' + message);
        }, {
            quality: 75,
            allowEdit: false,
            targetWidth: 400,
            targetHeight: 400,
            destinationType: 1,
            sourceType: 1,
            correctOrientation: true,
            saveToPhotoAlbum: true
          });
        } else if (buttonIndex === 1) {
          return window.imagePicker.getPictures(onPhotoSuccess, function onFail(message) {
            alert('Failed because: ' + message);
        }, {
            quality: 75,
            maximumImagesCount: 10,
            width: 400,
            height: 400,
            destinationType: 1,
            sourceType: 0,
            correctOrientation: true
          });
        }
    };

    $scope.getPhoto = function () {
        var hideSheet = $ionicActionSheet.show({
            buttons: [
               { text: '拍摄图片' },
               { text: '从相册选择' }
            ],
            titleText: '上传图片',
            cancelText: '取消',
            cancel: function() {
            },
            buttonClicked: function(index) {
                onConfirm(index);
                return true;
            }
       });
    }

    var upload = function(imageUrl) {
        var options = new FileUploadOptions();
            options.fileKey = "upload";
            options.fileName = imageUrl.substr(imageUrl.lastIndexOf('/') + 1);
            options.mimeType = "image/jpeg";
        $cordovaFileTransfer.upload("http://www.youjiacn.com:8000/index.php/home/file/index", imageUrl, options)
            .then(function(result) {
                var results = JSON.parse(result.response);
                $scope.images.push(results.data.url);
                $scope.photos.push(results.data.url);
            }, function(err) {
                console.log(err);
            }, function (progress) {
        });
    };

    $scope.addPost = function (isValid) {
        if (!isValid) {
          return;
        }
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        if($scope.images.length!=0){
            $scope.Data.images = JSON.stringify($scope.images);
        }
        Post.add($scope.Data).then(function(res) {
            $ionicLoading.hide();
            $rootScope.$emit(AUTH_EVENTS.addBBSPostSuccess);
            $ionicViewSwitcher.nextDirection('back');
            $state.go('tab.bbs', {}, {reload: true});
        }, function(err) {
            console.log(err);
            $ionicLoading.hide();
        });
    };
 }])

angular.module('AddComment', [])

.controller('AddCommentCtrl', ['$scope', '$http', 'URLConfig', '$stateParams', 'IntentOrder', '$ionicLoading', 'Comment', 'Upload', '$ionicPopup','$cordovaFileTransfer','$ionicHistory','$ionicViewSwitcher', 'Post', '$ionicActionSheet', function ($scope, $http, URLConfig, $stateParams, IntentOrder, $ionicLoading, Comment, Upload, $ionicPopup, $cordovaFileTransfer, $ionicHistory, $ionicViewSwitcher, Post, $ionicActionSheet) {

    $scope.type = $stateParams.type;
    $scope.goBack = function () {
        $ionicViewSwitcher.nextDirection('back');
        $ionicHistory.goBack();
    };
    var upload = function(imageUrl) {
        var options = new FileUploadOptions();
            options.fileKey = "upload";
            options.fileName = imageUrl.substr(imageUrl.lastIndexOf('/') + 1);
            options.mimeType = "image/jpeg";
        $cordovaFileTransfer.upload("http://www.youjiacn.com:8000/index.php/home/file/index", imageUrl, options)
            .then(function(result) {
                var results = JSON.parse(result.response);
                $scope.images.push(results.data.url);
            }, function(err) {
                console.log(err);
            }, function (progress) {
        });
    };
    $scope.id = $stateParams.tid;
    $scope.photos = Post.getPhotos();

    angular.forEach($scope.photos, function(value, key) {
        upload(value);
    });
    $scope.user = JSON.parse(localStorage.getItem('USERS')) || [];
    $scope.commentData = {
        'tid':$scope.id,
        'fid':'',
        'user_id':$scope.user.id,
        'content':'',
        'images': ''
    }

    $scope.images = [];
    $scope.getPhotoDisable = false;
    $scope.sizeLimit      = 10585760; // 10MB in Bytes
    $scope.uploadProgress = 0;
    $scope.creds          = {};

    document.addEventListener("deviceready",onDeviceReady,false);

    var destinationType;
    var pictureSource;
    function onDeviceReady() {
        pictureSource=navigator.camera.PictureSourceType;
        destinationType=navigator.camera.DestinationType;
    }

    onPhotoSuccess = function(results) {
        if ($scope.photos.length + results.length >10) {
            alert('最多十张');
            return;
        }else if ($scope.photos.length >10) {
            $scope.getPhotoDisable = true;
        };
        for (var i = 0; i < results.length; i++) {
            $scope.photos.push(results[i]);
            upload(results[i]);
        }
        $scope.$apply();
    };
    onPhotoDataSuccess = function(results) {
        if ($scope.photos.length>10) {
            alert('最多十张');
            $scope.getPhotoDisable = true;
            return;
        };
        $scope.photos.push(results);
        upload(results);
        $scope.$apply();
    };

    onConfirm = function(buttonIndex) {
        if (buttonIndex === 0) {
          return navigator.camera.getPicture(onPhotoDataSuccess, function onFail(message) {
            alert('Failed because: ' + message);
        }, {
            quality: 75,
            allowEdit: false,
            targetWidth: 400,
            targetHeight: 400,
            destinationType: 1,
            sourceType: 1,
            correctOrientation: true,
            saveToPhotoAlbum: true
          });
        } else if (buttonIndex === 1) {
          return window.imagePicker.getPictures(onPhotoSuccess, function onFail(message) {
            alert('Failed because: ' + message);
        }, {
            quality: 75,
            maximumImagesCount: 10,
            width: 400,
            height: 400,
            destinationType: 1,
            sourceType: 0,
            correctOrientation: true
          });
        }
    };

    $scope.getPhoto = function () {
        var hideSheet = $ionicActionSheet.show({
            buttons: [
               { text: '拍摄图片' },
               { text: '从相册选择' }
            ],
            titleText: '上传图片',
            cancelText: '取消',
            cancel: function() {
            },
            buttonClicked: function(index) {
                onConfirm(index);
                return true;
            }
       });
    }

    $scope.addPostComment = function (isValid) {
        if (!isValid) {
          return;
        }
        $scope.loading = $ionicLoading.show({
          showBackdrop: false
        });
        if($scope.images.length!=0){
            $scope.commentData.images = JSON.stringify($scope.images);
        }
        if($scope.type==1){
            Post.addBidComment($scope.commentData).then(function(res) {
                $ionicLoading.hide();
                $ionicViewSwitcher.nextDirection('back');
                $ionicHistory.goBack();
            }, function(err) {
                console.log(err);
                $ionicLoading.hide();
            });
        }else{
            Post.addComment($scope.commentData).then(function(res) {
                $ionicLoading.hide();
                $ionicViewSwitcher.nextDirection('back');
                $ionicHistory.goBack();
            }, function(err) {
                console.log(err);
                $ionicLoading.hide();
            });
        }

    };
 }])

// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('YouJia', ['ionic',
        'timer',
        'ngCordova',
        'ngSanitize',
        'angularMoment',
        'YJConfiguration',
        'YJDirectives',
        'YJServices',
        'security',
        'TuanGouDetail',
        'TuanGou',
        'Home',
        'Account',
        'Review',
        'IntentOrder',
        'Orders',
        'Order',
        'AddOrder',
        'Comment',
        'Stores',
        'Store',
        'BBS',
        'AddPost',
        'Posts',
        'AddComment',
        'Reply',
        'Bids',
        'Bid',
        'AddBidPost',
        'BidPost',
        'BidProduct',
        'SignupList',
        'BidCode',
        'Messages',
        'Message',
        'BBSMessage',
        'BidDetials',
        'myBids'
    ])
    .run(['$ionicPlatform','$cordovaSplashscreen', function ($ionicPlatform, $cordovaSplashscreen) {
        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);
            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                // StatusBar.styleDefault();
                // StatusBar.overlaysWebView(true);
                StatusBar.backgroundColorByName('white');
            }
            setTimeout(function() {
                if(navigator.splashscreen){
                    $cordovaSplashscreen.hide()
                }
            }, 2000)
            // ionic.Platform.fullScreen();
            // window.plugins.jPushPlugin.init();
        });

    }])

    .config(['$stateProvider', '$urlRouterProvider', '$ionicConfigProvider', '$httpProvider', '$sceDelegateProvider', function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $httpProvider, $sceDelegateProvider) {
        // $httpProvider.defaults.useXDomain = true;
        // $httpProvider.defaults.headers.common = {Accept: "application/json, text/plain, */*"};
        // $httpProvider.defaults.headers.post = {"Content-Type": "application/json;charset=utf-8"};
        // delete $httpProvider.defaults.headers.common['X-Requested-With'];
        $ionicConfigProvider.backButton.text('').icon('ion-ios-arrow-left');
        $ionicConfigProvider.backButton.previousTitleText(false);
        $ionicConfigProvider.tabs.position('bottom');
        $ionicConfigProvider.tabs.style("standard");
        $ionicConfigProvider.navBar.alignTitle("center");
        $ionicConfigProvider.views.swipeBackEnabled(true);
        $sceDelegateProvider.resourceUrlWhitelist(['self', new RegExp('^(http[s]?):\/\/?youku\.com/.+$')]);

        // $ionicConfigProvider.swipeBackEnabled(true);
        // if (ionic.Platform.isWebView() && $ionicConfig.views.swipeBackEnabled()) {
        //         self.initSwipeBack();
        // }
        // Ionic uses AngularUI Router which uses the concept of states
        // Learn more here: https://github.com/angular-ui/ui-router
        // Set up the various states which the app can be in.
        // Each state's controller can be found in controllers.js
        $stateProvider

            // setup an abstract state for the tabs directive
            .state('tab', {
                url: "/tab",
                abstract: true,
                templateUrl: "templates/tabs.html"
            })

            // Each tab has its own nav history stack:

            .state('tab.home', {
                url: '/home',
                views: {
                    'tab-home': {
                        templateUrl: 'templates/tab-home.html',
                        controller: 'HomeCtrl'
                    }
                }
            })

            .state('tab.bids', {
                url: '/bids',
                views: {
                    'tab-bids': {
                        templateUrl: 'templates/bids.html',
                        controller: 'BidsCtrl'
                    }
                }
            })
            .state('tab.orders', {
                url: '/orders/:isTab',
                views: {
                    'tab-orders': {
                        templateUrl: 'templates/tab-orders.html',
                        controller: 'IntentOrderCtrl'
                    }
                },
                requireLogin: true,
                cache: false
            })
            .state('tab.chat-detail', {
                url: '/chats/:chatId',
                views: {
                    'tab-chats': {
                        templateUrl: 'templates/chat-detail.html',
                        controller: 'ChatDetailCtrl'
                    }
                }
            })

            .state('tab.bbs', {
                url: '/bbs',
                views: {
                    'tab-bbs': {
                        templateUrl: 'templates/tab-bbs.html',
                        controller: 'BBSCtrl'
                    }
                }
            })
            .state('tab.friend-detail', {
                url: '/friend/:friendId',
                views: {
                    'tab-friends': {
                        templateUrl: 'templates/friend-detail.html',
                        controller: 'FriendDetailCtrl'
                    }
                }
            })
            .state('tab.account', {
                url: '/account',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/tab-account.html',
                        controller: 'AccountCtrl'
                    }
                },
                cache: false
            })
            .state('tuan-gou', {
                url: '/tuangou/',
                templateUrl: 'templates/tuan-gou.html',
                controller: 'TuanGouCtrl'
            })
            .state('tuan-gou-detail', {
                url: '/tuangoudetail/:detailCode',
                templateUrl: 'templates/tuan-gou-detail.html',
                controller: 'TuanGouDetailCtrl'
            })
            .state('review', {
                url: '/review/:code/:reviewerTotal',
                templateUrl: 'templates/review.html',
                controller: 'ReviewCtrl'
            })
            .state('signuplist', {
                url: '/signuplist/:bid',
                templateUrl: 'templates/signuplist.html',
                controller: 'SignupListCtrl'
            })
            .state('bid', {
                url: '/bid/:id/:type/:form',
                templateUrl: 'templates/bid.html',
                controller: 'BidCtrl'
            })
            .state('orders', {
                url: '/orders/:fromTab',
                templateUrl: 'templates/orders.html',
                controller: 'OrdersCtrl',
                requireLogin: true
            })
            .state('myBids', {
                url: '/myBids/:fromTab',
                templateUrl: 'templates/my-bids.html',
                controller: 'MyBidsCtrl',
                requireLogin: true
            })
            .state('order', {
                url: '/order/:id/:isTab',
                templateUrl: 'templates/order.html',
                controller: 'OrderCtrl',
                requireLogin: true
            })
            .state('stores', {
                url: '/stores/:supplier_id',
                templateUrl: 'templates/stores.html',
                controller: 'StoresCtrl'
            })
            .state('store', {
                url: '/store/:id',
                templateUrl: 'templates/store.html',
                controller: 'StoreCtrl'
            })
            .state('addComment', {
                url: "/addComment/:orderId/:bid",
                templateUrl: "templates/add-comment.html",
                controller: 'CommentCtrl',
                requireLogin: true
            })
            .state('addPost', {
                url: "/addPost",
                templateUrl: "templates/add-post.html",
                controller: 'AddPostCtrl',
                requireLogin: true
            })
            .state('addBidPost', {
                url: "/addBidPost/:biao_id",
                templateUrl: "templates/add-bid-post.html",
                controller: 'AddBidPostCtrl',
                requireLogin: true,
                cache: false
            })
            .state('posts', {
                url: "/posts/:type/:id",
                templateUrl: "templates/posts.html",
                controller: 'PostsCtrl'
            })
            .state('bidPosts', {
                url: "/bidPosts/:id",
                templateUrl: "templates/bid-post.html",
                controller: 'BidPostCtrl'
            })
            .state('bidProduct', {
                url: '/bidProduct/:id/:bid',
                templateUrl: 'templates/bid-product.html',
                controller: 'BidProductCtrl'
            })
            .state('bidCode', {
                url: '/bidCode',
                templateUrl: 'templates/bid-code.html',
                controller: 'BidCodeCtrl',
                requireLogin: true,
                cache: false
            })
            .state('messages', {
                url: '/messages',
                templateUrl: 'templates/messages.html',
                controller: 'MessagesCtrl'
            })
            .state('message', {
                url: '/message',
                templateUrl: 'templates/message.html',
                controller: 'MessageCtrl'
            })
            .state('messageDetial', {
                url: '/messageDetial/:id',
                templateUrl: 'templates/message-detial.html',
                controller: 'MessageDetialCtrl'
            })
            .state('bidDetials', {
                url: '/bidDetials/:id',
                templateUrl: 'templates/bid-detials.html',
                controller: 'BidDetialsCtrl'
            })
            .state('bbsMessage', {
                url: '/bbsMessage',
                templateUrl: 'templates/bbs-message.html',
                controller: 'BBSMessageCtrl',
                requireLogin: true
            })
            .state('addPostComment', {
                url: "/addPostComment/:tid/:type",
                templateUrl: "templates/add-post-comment.html",
                controller: 'AddCommentCtrl',
                requireLogin: true
            })
            .state('reply', {
                url: "/reply/:bid/:tid/:fid",
                templateUrl: "templates/reply.html",
                controller: 'ReplyCtrl',
                requireLogin: true
            })
            .state('addOrder', {
                url: '/addOrder/:detailCode',
                templateUrl: 'templates/add-order.html',
                controller: 'AddOrderCtrl',
                requireLogin: true
            })
            .state('accountDetial', {
                url: "/accountDetial",
                templateUrl: "templates/account-detial.html",
                controller: 'AccountDetialCtrl',
                requireLogin: true
            })
            .state('changeAccountName', {
                url: "/changeAccountName",
                templateUrl: "templates/change-name.html",
                controller: 'AccountDetialCtrl',
                requireLogin: true,
                cache:false
            })
            .state('address', {
                url: "/address",
                templateUrl: "templates/address.html",
                controller: 'AccountDetialCtrl',
                requireLogin: true
            })
            .state('addAddress', {
                url: "/addAddress/:addressId",
                templateUrl: "templates/addAddress.html",
                controller: 'AddAddressCtrl',
                requireLogin: true
            })
            .state('changePhone', {
                url: "/changePhone/:type",
                templateUrl: "templates/phone-number.html",
                controller: 'ChangePhoneCtrl',
                requireLogin: true,
                cache: false
            })
            .state('resetPassword', {
                url: "/resetPassword",
                templateUrl: "templates/reset-password.html",
                controller: 'forgotPasswordCtrl',
                requireLogin: true
            });

        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/tab/home');

    }])
    .run(['$http', '$rootScope', '$state', 'security', 'AUTH_EVENTS', '$document', '$ionicScrollDelegate', function ($http, $rootScope, $state, security, AUTH_EVENTS, $document, $ionicScrollDelegate) {
        // $http.defaults.headers.common['X-Auth-Token'] =  window.localStorage.getItem('tokenKey');
        $rootScope.$on('$stateChangeStart', function (event, next, nextParams, fromState) {
            if ('data' in next && 'authorizedRoles' in next.data) {
              var authorizedRoles = next.data.authorizedRoles;
              if (!security.isAuthorized(authorizedRoles)) {
                event.preventDefault();
                $state.go($state.current, {}, {reload: true});
                $rootScope.$broadcast(AUTH_EVENTS.notAuthorized);
              }
            }

            if (next.requireLogin && !security.isAuthenticated()) {
                event.preventDefault();
                if($state.current.name){
                    $state.go($state.current, {}, {reload: true});
                }
                $rootScope.$broadcast(AUTH_EVENTS.notAuthenticated);
            }

            if(window.localStorage.getItem('firstTime') == null) {
                $rootScope.$broadcast(AUTH_EVENTS.firstOpen);
            }
            window.localStorage.setItem('firstTime', 1);

            // var header = $document[0].body.querySelector('.bar-header');

            // if(next.name=="tab.home"){
            //     var headerList = $document[0].body.querySelectorAll('.nav-bar-block');
            //     angular.forEach(headerList, function(value, key) {
            //         if(value.attributes.getNamedItem('nav-bar').value=== "cached"){
            //             ionic.requestAnimationFrame(function() {
            //                 value.children[0].style.opacity = 0;
            //             });
            //         }else{
            //             ionic.requestAnimationFrame(function() {
            //                 value.children[0].style.opacity = 0;
            //             });
            //         }
            //     });

            //         header.style.opacity = 0;
            //         $ionicScrollDelegate.scrollTop();

            // }else {
            //     ionic.requestAnimationFrame(function() {
            //         header.style.opacity = 1;
            //     });
            // }
        });




    }]).controller('AppCtrl', ['$ionicConfig', '$scope', '$state', '$ionicPopup', 'security', 'AUTH_EVENTS', '$ionicModal', '$window', '$rootScope', '$ionicHistory', '$ionicSlideBoxDelegate', '$ionicViewSwitcher', '$state', function($ionicConfig, $scope, $state, $ionicPopup, security, AUTH_EVENTS, $ionicModal, $window, $rootScope, $ionicHistory, $ionicSlideBoxDelegate, $ionicViewSwitcher, $state) {
        $scope.username = security.username();
        $scope.$on(AUTH_EVENTS.notAuthorized, function(event) {
            var alertPopup = $ionicPopup.alert({
                title: 'Unauthorized!',
                template: 'You are not allowed to access this resource.'
            });
        });

        $scope.$on(AUTH_EVENTS.notAuthenticated, function(event) {
            security.logout();
            // $state.go('login');
            $ionicModal.fromTemplateUrl('templates/login.tpl.html', {
                scope: $scope,
                backdropClickToClose: false,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.oModal = modal;
                $scope.oModal.show();
            });

        });

        $scope.$on(AUTH_EVENTS.firstOpen, function(event) {

            $ionicModal.fromTemplateUrl('templates/guide-pages.html', {
                scope: $scope,
                backdropClickToClose: false,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.firstOpenModal = modal;
                $scope.firstOpenModal.show();
            });

        });


        $scope.$on(AUTH_EVENTS.loginSuccess, function(event) {
            $scope.oModal.hide();
            $state.go($state.current, {}, {reload: true});
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            // this is not polling anymore
            $ionicSlideBoxDelegate.update();
        });

        $scope.closeModal = function() {
            $scope.oModal.hide();
        };

        $scope.closeFirstOpenModal = function() {
            $scope.firstOpenModal.hide();
        };

        $scope.setCurrentUsername = function(name) {
            $scope.username = name;
        };


        $rootScope.codeBadge = 0;
        $rootScope.messageBadge = 0;
        $rootScope.cityBadge = 0;
        $rootScope.commonBadge = parseInt($rootScope.cityBadge) + parseInt($rootScope.messageBadge);
        $rootScope.badge = parseInt($rootScope.codeBadge) + parseInt($rootScope.commonBadge);

        var onDeviceReady   = function(){
            initiateUI();
        }
        var onOpenNotification = function(event){
            try{
                var alertContent;
                if(device.platform == "Android"){
                    if(parseInt(EXTRA.messageType) == 1){
                        $ionicViewSwitcher.nextDirection('forward');
                        $state.go('messages', {}, {reload: true});
                    }else if(parseInt(EXTRA.messageType) == 2) {
                        $ionicViewSwitcher.nextDirection('forward');
                        $state.go('bidCode', {}, {reload: true});
                    }
                }else{
                    if(parseInt(event.messageType) == 1){
                        $ionicViewSwitcher.nextDirection('forward');
                        $state.go('messages', {}, {reload: true});
                    }else if(parseInt(event.messageType) == 2) {
                        $ionicViewSwitcher.nextDirection('forward');
                        $state.go('bidCode', {}, {reload: true});
                    }
                }

            }
            catch(exception){
                console.log("JPushPlugin:onOpenNotification"+exception);
            }
        }
        var onReceiveNotification = function(event){
            try{
                if(device.platform == "Android"){
                    var EXTRA = JSON.parse(event.extras['cn.jpush.android.EXTRA']);
                    if(parseInt(EXTRA.messageType) == 1){
                        var myPopup = $ionicPopup.show({
                            title: '提示信息',
                            subTitle: '您有新的消息,查看该消息',
                            buttons: [
                              { text: '取消' },
                              {
                                text: '<b>确认</b>',
                                type: 'button-assertive',
                                onTap: function(e) {
                                    $ionicViewSwitcher.nextDirection('forward');
                                    $state.go('messages', {}, {reload: true});
                                }
                              }
                            ]
                        });
                    }else if(parseInt(EXTRA.messageType) == 2) {
                        var myPopup = $ionicPopup.show({
                            title: '提示信息',
                            subTitle: '您收到一张优惠券，查看该优惠券',
                            buttons: [
                              { text: '取消' },
                              {
                                text: '<b>确认</b>',
                                type: 'button-assertive',
                                onTap: function(e) {
                                    $ionicViewSwitcher.nextDirection('forward');
                                    $state.go('bidCode', {}, {reload: true});
                                }
                              }
                            ]
                        });
                    }
                }
                else {
                    if(parseInt(event.messageType) == 1){
                        var myPopup = $ionicPopup.show({
                            title: '提示信息',
                            subTitle: '您有新的消息,查看该消息',
                            buttons: [
                              { text: '取消' },
                              {
                                text: '<b>确认</b>',
                                type: 'button-assertive',
                                onTap: function(e) {
                                    $ionicViewSwitcher.nextDirection('forward');
                                    $state.go('messages', {}, {reload: true});
                                }
                              }
                            ]
                        });
                    }else if(parseInt(event.messageType) == 2) {

                        var myPopup = $ionicPopup.show({
                            title: '提示信息',
                            subTitle: '您收到一张优惠券，查看该优惠券',
                            buttons: [
                              { text: '取消' },
                              {
                                text: '<b>确认</b>',
                                type: 'button-assertive',
                                onTap: function(e) {
                                    $ionicViewSwitcher.nextDirection('forward');
                                    $state.go('bidCode', {}, {reload: true});
                                }
                              }
                            ]
                        });
                    }
                }
            }
            catch(exeption){
                console.log(exception);
            }
        }
        var onReceiveMessage = function(event){
            try{
                if(parseInt(event.extras.messageType) == 1){
                    $rootScope.messageBadge = parseInt($rootScope.messageBadge) + 1;
                }else if(parseInt(event.extras.messageType) == 2) {
                    $rootScope.codeBadge = parseInt($rootScope.codeBadge) + 1;
                }else {
                    $rootScope.cityBadge = parseInt($rootScope.cityBadge) + 1;
                }
                $rootScope.commonBadge = parseInt($rootScope.cityBadge) + parseInt($rootScope.messageBadge);
                $rootScope.badge = parseInt($rootScope.commonBadge)+parseInt($rootScope.codeBadge);
                $scope.$apply();
            }
            catch(exception){
                console.log("JPushPlugin:onReceiveMessage-->"+exception);
            }
        }

        var initiateUI = function(){

            try{
                window.plugins.jPushPlugin.init();
                window.plugins.jPushPlugin.getRegistrationID(onGetRegistradionID);

                if(device.platform == "Android"){
                    window.plugins.jPushPlugin.setDebugMode(true);
                    window.plugins.jPushPlugin.setDebugModeFromIos();
                    window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
                    window.plugins.jPushPlugin.receiveMessageInAndroidCallback=onReceiveMessage;
                    window.plugins.jPushPlugin.openNotificationInAndroidCallback=onOpenNotification;
                }else{
                    window.plugins.jPushPlugin.setDebugMode(true);
                }
            }
            catch(exception){
                console.log(exception);
            }
        }
        document.addEventListener("deviceready", onDeviceReady, false);
        document.addEventListener("jpush.openNotification", onOpenNotification, false);
        document.addEventListener("jpush.receiveNotification", onReceiveNotification, false);
        document.addEventListener("jpush.receiveMessage", onReceiveMessage, false);
    }]);

